/*     */ package com.jaspersoft.jasperserver.api.engine.scheduling.domain;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.api.JasperServerAPI;
/*     */ import com.jaspersoft.jasperserver.api.engine.scheduling.domain.jaxb.AddressesXmlAdapter;
/*     */ import com.jaspersoft.jasperserver.api.engine.scheduling.domain.jaxb.ReportJobSendTypeXmlAdapter;
/*     */ import java.io.Serializable;
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ import javax.xml.bind.annotation.XmlElement;
/*     */ import javax.xml.bind.annotation.XmlRootElement;
/*     */ import javax.xml.bind.annotation.XmlTransient;
/*     */ import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ @JasperServerAPI
/*     */ @XmlRootElement
/*     */ public class ReportJobMailNotification
/*     */   implements Serializable
/*     */ {
/*     */   private static final long serialVersionUID = 1L;
/*     */   public static final byte RESULT_SEND = 1;
/*     */   public static final byte RESULT_SEND_ATTACHMENT = 2;
/*     */   public static final byte RESULT_SEND_ATTACHMENT_NOZIP = 3;
/*     */   public static final byte RESULT_SEND_EMBED = 4;
/*     */   public static final byte RESULT_SEND_ATTACHMENT_ZIP_ALL = 5;
/*     */   public static final byte RESULT_SEND_EMBED_ZIP_ALL_OTHERS = 6;
/*     */   private long id;
/* 103 */   private int version = -1;
/*     */   private List toAddresses;
/*     */   private List ccAddresses;
/*     */   private List bccAddresses;
/*     */   private String subject;
/*     */   private String messageText;
/* 109 */   private Byte resultSendType = Byte.valueOf((byte)1);
/*     */   private boolean skipEmptyReports;
/* 111 */   private String messageTextWhenJobFails = null;
/* 112 */   private boolean includingStackTraceWhenJobFails = false;
/* 113 */   private boolean skipNotificationWhenJobFails = false;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public ReportJobMailNotification()
/*     */   {
/* 120 */     this.toAddresses = new ArrayList();
/* 121 */     this.ccAddresses = new ArrayList();
/* 122 */     this.bccAddresses = new ArrayList();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public long getId()
/*     */   {
/* 136 */     return this.id;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setId(long id)
/*     */   {
/* 150 */     this.id = id;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public int getVersion()
/*     */   {
/* 165 */     return this.version;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setVersion(int version)
/*     */   {
/* 180 */     this.version = version;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getMessageText()
/*     */   {
/* 195 */     return this.messageText;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setMessageText(String messageText)
/*     */   {
/* 204 */     this.messageText = messageText;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlElement(name="resultSendType")
/*     */   @XmlJavaTypeAdapter(ReportJobSendTypeXmlAdapter.class)
/*     */   public Byte getResultSendTypeCode()
/*     */   {
/* 216 */     return this.resultSendType;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   @XmlTransient
/*     */   public byte getResultSendType()
/*     */   {
/* 228 */     return getResultSendTypeCode().byteValue();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public void setResultSendType(byte resultSendType)
/*     */   {
/* 240 */     setResultSendTypeCode(Byte.valueOf(resultSendType));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setResultSendTypeCode(Byte resultSendType)
/*     */   {
/* 251 */     this.resultSendType = resultSendType;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getSubject()
/*     */   {
/* 260 */     return this.subject;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setSubject(String subject)
/*     */   {
/* 269 */     this.subject = subject;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlJavaTypeAdapter(AddressesXmlAdapter.class)
/*     */   public List getBccAddresses()
/*     */   {
/* 282 */     return this.bccAddresses;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setBccAddresses(List bccAddresses)
/*     */   {
/* 293 */     this.bccAddresses = bccAddresses;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void addBcc(String address)
/*     */   {
/* 302 */     this.bccAddresses.add(address);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlJavaTypeAdapter(AddressesXmlAdapter.class)
/*     */   public List getCcAddresses()
/*     */   {
/* 314 */     return this.ccAddresses;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setCcAddresses(List ccAddresses)
/*     */   {
/* 325 */     this.ccAddresses = ccAddresses;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void addCc(String address)
/*     */   {
/* 334 */     this.ccAddresses.add(address);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlJavaTypeAdapter(AddressesXmlAdapter.class)
/*     */   public List getToAddresses()
/*     */   {
/* 345 */     return this.toAddresses;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setToAddresses(List toAddresses)
/*     */   {
/* 356 */     this.toAddresses = toAddresses;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void addTo(String address)
/*     */   {
/* 365 */     this.toAddresses.add(address);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlTransient
/*     */   public boolean isEmpty()
/*     */   {
/* 381 */     boolean isEmpty = true;
/* 382 */     if (getToAddresses() != null) {
/* 383 */       isEmpty = getToAddresses().isEmpty();
/*     */     }
/* 385 */     return isEmpty;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isSkipEmptyReports()
/*     */   {
/* 402 */     return this.skipEmptyReports;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setSkipEmptyReports(boolean skipEmptyReports)
/*     */   {
/* 414 */     this.skipEmptyReports = skipEmptyReports;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ReportJobMailNotification(ReportJobMailNotification jobMail)
/*     */   {
/* 429 */     if (jobMail != null)
/*     */     {
/* 431 */       setMessageText(jobMail.getMessageText());
/* 432 */       setResultSendTypeCode(jobMail.getResultSendTypeCode());
/* 433 */       setSubject(jobMail.getSubject());
/* 434 */       List l = jobMail.getBccAddresses();
/* 435 */       if (l != null) setBccAddresses(new ArrayList(l));
/* 436 */       l = jobMail.getCcAddresses();
/* 437 */       if (l != null) setCcAddresses(new ArrayList(l));
/* 438 */       l = jobMail.getToAddresses();
/* 439 */       if (l != null) setToAddresses(new ArrayList(l));
/* 440 */       setSkipEmptyReports(jobMail.isSkipEmptyReports());
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getMessageTextWhenJobFails()
/*     */   {
/* 456 */     return this.messageTextWhenJobFails;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setMessageTextWhenJobFails(String messageTextWhenJobFails)
/*     */   {
/* 465 */     this.messageTextWhenJobFails = messageTextWhenJobFails;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isIncludingStackTraceWhenJobFails()
/*     */   {
/* 474 */     return this.includingStackTraceWhenJobFails;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setIncludingStackTraceWhenJobFails(boolean includingStackTraceWhenJobFails)
/*     */   {
/* 483 */     this.includingStackTraceWhenJobFails = includingStackTraceWhenJobFails;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isSkipNotificationWhenJobFails()
/*     */   {
/* 492 */     return this.skipNotificationWhenJobFails;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setSkipNotificationWhenJobFails(boolean skipNotificationWhenJobFails)
/*     */   {
/* 501 */     this.skipNotificationWhenJobFails = skipNotificationWhenJobFails;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-api-engine-6.0.jar!\com\jaspersoft\jasperserver\api\engine\scheduling\domain\ReportJobMailNotification.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */