/*      */ package com.jaspersoft.jasperserver.irplugin.gui;
/*      */ 
/*      */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ResourceDescriptor;
/*      */ import com.jaspersoft.jasperserver.irplugin.IRPlugin;
/*      */ import com.jaspersoft.jasperserver.irplugin.JServer;
/*      */ import com.jaspersoft.jasperserver.irplugin.RepositoryFolder;
/*      */ import com.jaspersoft.jasperserver.irplugin.gui.explorer.ResourceChooser;
/*      */ import com.jaspersoft.jasperserver.irplugin.wsclient.WSClient;
/*      */ import it.businesslogic.ireport.gui.MainFrame;
/*      */ import it.businesslogic.ireport.gui.sheet.Tag;
/*      */ import it.businesslogic.ireport.util.Misc;
/*      */ import java.awt.Container;
/*      */ import java.awt.Dialog;
/*      */ import java.awt.Dimension;
/*      */ import java.awt.Frame;
/*      */ import java.awt.GridBagConstraints;
/*      */ import java.awt.GridBagLayout;
/*      */ import java.awt.Insets;
/*      */ import java.awt.Window;
/*      */ import java.awt.event.ActionEvent;
/*      */ import java.awt.event.ActionListener;
/*      */ import java.awt.event.MouseEvent;
/*      */ import java.io.PrintStream;
/*      */ import java.util.ArrayList;
/*      */ import java.util.List;
/*      */ import javax.swing.AbstractButton;
/*      */ import javax.swing.BorderFactory;
/*      */ import javax.swing.ButtonGroup;
/*      */ import javax.swing.DefaultListModel;
/*      */ import javax.swing.JButton;
/*      */ import javax.swing.JCheckBox;
/*      */ import javax.swing.JComboBox;
/*      */ import javax.swing.JComponent;
/*      */ import javax.swing.JDialog;
/*      */ import javax.swing.JEditorPane;
/*      */ import javax.swing.JLabel;
/*      */ import javax.swing.JList;
/*      */ import javax.swing.JOptionPane;
/*      */ import javax.swing.JPanel;
/*      */ import javax.swing.JRadioButton;
/*      */ import javax.swing.JScrollPane;
/*      */ import javax.swing.JSeparator;
/*      */ import javax.swing.JTabbedPane;
/*      */ import javax.swing.JTextField;
/*      */ import javax.swing.ListModel;
/*      */ import javax.swing.event.DocumentEvent;
/*      */ import javax.swing.event.DocumentListener;
/*      */ import javax.swing.event.ListSelectionEvent;
/*      */ import javax.swing.text.Document;
/*      */ import javax.swing.text.JTextComponent;
/*      */ 
/*      */ public class InputControlDialog extends JDialog
/*      */ {
/*   54 */   private int dialogResult = 2;
/*      */   
/*   56 */   private JServer server = null;
/*   57 */   private String parentFolder = null;
/*   58 */   private RepositoryFolder resource = null;
/*   59 */   private String reportUnitUri = null;
/*      */   
/*   61 */   private ResourceDescriptor newResourceDescriptor = null;
/*      */   
/*   63 */   private ResourceDescriptor lovResourceDescriptor = null;
/*   64 */   private ResourceDescriptor dataTypeResourceDescriptor = null;
/*   65 */   private ResourceDescriptor queryResourceDescriptor = null;
/*      */   private ButtonGroup buttonGroup1;
/*      */   private ButtonGroup buttonGroup2;
/*      */   private JButton jButtonAddColumn;
/*      */   
/*      */   public InputControlDialog(Frame parent, boolean modal)
/*      */   {
/*   72 */     super(parent, modal);
/*   73 */     initComponents();
/*      */     
/*   75 */     Misc.centerFrame(this);
/*   76 */     DocumentListener changesListener = new DocumentListener() {
/*      */       public void changedUpdate(DocumentEvent evt) {
/*   78 */         InputControlDialog.this.updateSaveButton();
/*      */       }
/*      */       
/*   81 */       public void insertUpdate(DocumentEvent evt) { InputControlDialog.this.updateSaveButton(); }
/*      */       
/*      */       public void removeUpdate(DocumentEvent evt) {
/*   84 */         InputControlDialog.this.updateSaveButton();
/*      */       }
/*      */       
/*   87 */     };
/*   88 */     this.jComboBoxType.addItem(new Tag("1", IRPlugin.getString("inputControlDialog.type.1", "Boolean")));
/*   89 */     this.jComboBoxType.addItem(new Tag("2", IRPlugin.getString("inputControlDialog.type.2", "Single Value")));
/*   90 */     this.jComboBoxType.addItem(new Tag("3", IRPlugin.getString("inputControlDialog.type.3", "Single Select List of Values")));
/*   91 */     this.jComboBoxType.addItem(new Tag("8", IRPlugin.getString("inputControlDialog.type.8", "Single Select List of Values (Radio)")));
/*   92 */     this.jComboBoxType.addItem(new Tag("6", IRPlugin.getString("inputControlDialog.type.6", "Multi Select List of Values")));
/*   93 */     this.jComboBoxType.addItem(new Tag("10", IRPlugin.getString("inputControlDialog.type.10", "Multi Select List of Values (Checkbox)")));
/*   94 */     this.jComboBoxType.addItem(new Tag("4", IRPlugin.getString("inputControlDialog.type.4", "Single Select Query")));
/*   95 */     this.jComboBoxType.addItem(new Tag("9", IRPlugin.getString("inputControlDialog.type.9", "Single Select Query (Radio)")));
/*   96 */     this.jComboBoxType.addItem(new Tag("7", IRPlugin.getString("inputControlDialog.type.7", "Multi Select Query")));
/*   97 */     this.jComboBoxType.addItem(new Tag("11", IRPlugin.getString("inputControlDialog.type.11", "Multi Select Query (Checkbox)")));
/*      */     
/*   99 */     this.jComboBoxType.setSelectedIndex(0);
/*      */     
/*  101 */     this.jTextFieldLabel.getDocument().addDocumentListener(changesListener);
/*  102 */     this.jTextFieldName.getDocument().addDocumentListener(changesListener);
/*  103 */     this.jTextFieldName.requestFocusInWindow();
/*      */     
/*  105 */     this.jListColumns.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
/*      */       public void valueChanged(ListSelectionEvent e) {
/*  107 */         boolean b = InputControlDialog.this.jListColumns.getSelectedIndex() >= 0;
/*  108 */         InputControlDialog.this.jButtonModColumn.setEnabled(b);
/*  109 */         InputControlDialog.this.jButtonRemColumn.setEnabled(b);
/*      */       }
/*      */       
/*  112 */     });
/*  113 */     this.jListColumns.setModel(new DefaultListModel());
/*      */     
/*  115 */     applyI18n();
/*      */   }
/*      */   
/*      */ 
/*      */   public void applyI18n()
/*      */   {
/*  121 */     this.jButtonClose.setText(IRPlugin.getString("inputControlDialog.buttonCancel", "Cancel"));
/*  122 */     this.jButtonSave.setText(IRPlugin.getString("inputControlDialog.buttonSave", "Save"));
/*      */     
/*  124 */     this.jButtonAddColumn.setText(IRPlugin.getString("inputControlDialog.buttonAddColumn", "Add"));
/*      */     
/*  126 */     this.jButtonEditLocalResource.setText(IRPlugin.getString("inputControlDialog.buttonEditLocalResource", "Edit local resource"));
/*  127 */     this.jButtonEditLocalResource1.setText(IRPlugin.getString("inputControlDialog.buttonEditLocalResource", "Edit local resource"));
/*  128 */     this.jButtonModColumn.setText(IRPlugin.getString("inputControlDialog.buttonModifyColumn", "Modify"));
/*  129 */     this.jButtonPickResource.setText(IRPlugin.getString("inputControlDialog.buttonPickResource", "Browse"));
/*  130 */     this.jButtonPickResource1.setText(IRPlugin.getString("inputControlDialog.buttonPickResource", "Browse"));
/*  131 */     this.jButtonRemColumn.setText(IRPlugin.getString("inputControlDialog.buttonRemColumn", "Remove"));
/*      */     
/*  133 */     this.jLabel1.setText(IRPlugin.getString("inputControlDialog.title", "Input Control"));
/*  134 */     this.jLabelDescription.setText(IRPlugin.getString("inputControlDialog.labelDescription", "Description"));
/*  135 */     this.jLabelLabel.setText(IRPlugin.getString("inputControlDialog.labelLabel", "Label"));
/*  136 */     this.jLabelLocate.setText(IRPlugin.getString("inputControlDialog.labelLocateLOV", "Locate List of Values"));
/*  137 */     this.jLabelLocate1.setText(IRPlugin.getString("inputControlDialog.labelLocateQuery", "Locate query"));
/*  138 */     this.jLabelLocate2.setText(IRPlugin.getString("inputControlDialog.labelValueColumn", "Value column"));
/*  139 */     this.jLabelLocate3.setText(IRPlugin.getString("inputControlDialog.labelVisibleColumns", "Visible query columns"));
/*  140 */     this.jLabelMandatory.setText(IRPlugin.getString("inputControlDialog.labelMandatory", "Mandatory"));
/*  141 */     this.jLabelName.setText(IRPlugin.getString("inputControlDialog.labelName", "Name"));
/*  142 */     this.jLabelUriString.setText(IRPlugin.getString("inputControlDialog.labelParentFolder", "Parent folder"));
/*  143 */     this.jLabelReadOnly.setText(IRPlugin.getString("inputControlDialog.labelReadOnly", "Read Only"));
/*  144 */     this.jLabelType.setText(IRPlugin.getString("inputControlDialog.labelType", "Type"));
/*  145 */     this.jRadioButtonLocal.setText(IRPlugin.getString("inputControlDialog.radioLocallyDefined", "Locally Defined"));
/*  146 */     this.jRadioButtonLocal1.setText(IRPlugin.getString("inputControlDialog.radioLocallyDefined", "Locally Defined"));
/*  147 */     this.jRadioButtonRepo.setText(IRPlugin.getString("inputControlDialog.radioRepo", "From the repository"));
/*  148 */     this.jRadioButtonRepo1.setText(IRPlugin.getString("inputControlDialog.radioRepo", "From the repository"));
/*      */     
/*  150 */     this.jTabbedPane1.setTitleAt(0, IRPlugin.getString("inputControlDialog.tabGeneral", "General"));
/*  151 */     this.jTabbedPane1.setTitleAt(1, IRPlugin.getString("inputControlDialog.tabDetails", "Input control details"));
/*  152 */     this.jTabbedPane2.setTitleAt(0, IRPlugin.getString("inputControlDialog.tabQueryResource", "Query resource"));
/*  153 */     this.jTabbedPane2.setTitleAt(1, IRPlugin.getString("inputControlDialog.tabQueryColumns", "Value and visible columns"));
/*      */   }
/*      */   
/*      */   private JButton jButtonClose;
/*      */   private JButton jButtonEditLocalResource;
/*      */   private JButton jButtonEditLocalResource1;
/*      */   private JButton jButtonModColumn;
/*  160 */   private void updateSaveButton() { if ((this.jTextFieldLabel.getText().length() > 0) && (this.jTextFieldName.getText().length() > 0))
/*      */     {
/*      */ 
/*  163 */       this.jButtonSave.setEnabled(true);
/*      */     }
/*      */     else
/*      */     {
/*  167 */       this.jButtonSave.setEnabled(false);
/*      */     }
/*      */   }
/*      */   
/*      */   private JButton jButtonPickResource;
/*      */   private JButton jButtonPickResource1;
/*      */   private JButton jButtonRemColumn;
/*      */   private JButton jButtonSave;
/*      */   private JCheckBox jCheckBoxMandatory;
/*      */   private JCheckBox jCheckBoxReadOnly;
/*      */   private JComboBox jComboBoxType;
/*      */   private void initComponents()
/*      */   {
/*  180 */     this.buttonGroup1 = new ButtonGroup();
/*  181 */     this.buttonGroup2 = new ButtonGroup();
/*  182 */     this.jPanel1 = new JPanel();
/*  183 */     this.jLabel1 = new JLabel();
/*  184 */     this.jSeparator1 = new JSeparator();
/*  185 */     this.jTabbedPane1 = new JTabbedPane();
/*  186 */     this.jPanel2 = new JPanel();
/*  187 */     this.jLabelUriString = new JLabel();
/*  188 */     this.jTextFieldUriString = new JTextField();
/*  189 */     this.jLabelName = new JLabel();
/*  190 */     this.jTextFieldName = new JTextField();
/*  191 */     this.jSeparator2 = new JSeparator();
/*  192 */     this.jLabelLabel = new JLabel();
/*  193 */     this.jTextFieldLabel = new JTextField();
/*  194 */     this.jScrollPane1 = new JScrollPane();
/*  195 */     this.jEditorPaneDescription = new JEditorPane();
/*  196 */     this.jLabelDescription = new JLabel();
/*  197 */     this.jPanel3 = new JPanel();
/*  198 */     this.jLabelType = new JLabel();
/*  199 */     this.jComboBoxType = new JComboBox();
/*  200 */     this.jLabelMandatory = new JLabel();
/*  201 */     this.jCheckBoxMandatory = new JCheckBox();
/*  202 */     this.jLabelReadOnly = new JLabel();
/*  203 */     this.jCheckBoxReadOnly = new JCheckBox();
/*  204 */     this.jSeparator4 = new JSeparator();
/*  205 */     this.jPanel5 = new JPanel();
/*  206 */     this.jPanelLocate = new JPanel();
/*  207 */     this.jLabelLocate = new JLabel();
/*  208 */     this.jRadioButtonRepo = new JRadioButton();
/*  209 */     this.jTextFieldResource = new JTextField();
/*  210 */     this.jButtonPickResource = new JButton();
/*  211 */     this.jRadioButtonLocal = new JRadioButton();
/*  212 */     this.jButtonEditLocalResource = new JButton();
/*  213 */     this.jPanel6 = new JPanel();
/*  214 */     this.jPanelQuery = new JPanel();
/*  215 */     this.jTabbedPane2 = new JTabbedPane();
/*  216 */     this.jPanelLocateQuery = new JPanel();
/*  217 */     this.jLabelLocate1 = new JLabel();
/*  218 */     this.jRadioButtonRepo1 = new JRadioButton();
/*  219 */     this.jTextFieldResource1 = new JTextField();
/*  220 */     this.jButtonPickResource1 = new JButton();
/*  221 */     this.jRadioButtonLocal1 = new JRadioButton();
/*  222 */     this.jButtonEditLocalResource1 = new JButton();
/*  223 */     this.jPanel7 = new JPanel();
/*  224 */     this.jPanelFields = new JPanel();
/*  225 */     this.jLabelLocate2 = new JLabel();
/*  226 */     this.jTextFieldValueColumn = new JTextField();
/*  227 */     this.jPanelVisibleColumns = new JPanel();
/*  228 */     this.jLabelLocate3 = new JLabel();
/*  229 */     this.jScrollPane2 = new JScrollPane();
/*  230 */     this.jListColumns = new JList();
/*  231 */     this.jPanel8 = new JPanel();
/*  232 */     this.jButtonAddColumn = new JButton();
/*  233 */     this.jButtonModColumn = new JButton();
/*  234 */     this.jButtonRemColumn = new JButton();
/*  235 */     this.jPanel4 = new JPanel();
/*  236 */     this.jButtonSave = new JButton();
/*  237 */     this.jButtonClose = new JButton();
/*      */     
/*  239 */     getContentPane().setLayout(new GridBagLayout());
/*      */     
/*  241 */     setDefaultCloseOperation(2);
/*  242 */     setTitle("Data Type");
/*  243 */     this.jPanel1.setLayout(new GridBagLayout());
/*      */     
/*  245 */     this.jPanel1.setBackground(new java.awt.Color(255, 255, 255));
/*  246 */     this.jLabel1.setFont(new java.awt.Font("Dialog", 1, 12));
/*  247 */     this.jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/datasource_new.png")));
/*  248 */     this.jLabel1.setText("Input Control");
/*  249 */     this.jLabel1.setVerticalAlignment(3);
/*  250 */     this.jLabel1.setVerticalTextPosition(3);
/*  251 */     GridBagConstraints gridBagConstraints = new GridBagConstraints();
/*  252 */     gridBagConstraints.fill = 1;
/*  253 */     gridBagConstraints.weightx = 1.0D;
/*  254 */     gridBagConstraints.weighty = 1.0D;
/*  255 */     this.jPanel1.add(this.jLabel1, gridBagConstraints);
/*      */     
/*  257 */     gridBagConstraints = new GridBagConstraints();
/*  258 */     gridBagConstraints.fill = 2;
/*  259 */     getContentPane().add(this.jPanel1, gridBagConstraints);
/*      */     
/*  261 */     this.jSeparator1.setMinimumSize(new Dimension(2, 2));
/*  262 */     this.jSeparator1.setPreferredSize(new Dimension(2, 2));
/*  263 */     gridBagConstraints = new GridBagConstraints();
/*  264 */     gridBagConstraints.gridx = 0;
/*  265 */     gridBagConstraints.fill = 2;
/*  266 */     gridBagConstraints.weightx = 1.0D;
/*  267 */     getContentPane().add(this.jSeparator1, gridBagConstraints);
/*      */     
/*  269 */     this.jPanel2.setLayout(new GridBagLayout());
/*      */     
/*  271 */     this.jPanel2.setPreferredSize(new Dimension(400, 185));
/*  272 */     this.jLabelUriString.setText("Parent folder");
/*  273 */     gridBagConstraints = new GridBagConstraints();
/*  274 */     gridBagConstraints.gridx = 0;
/*  275 */     gridBagConstraints.fill = 2;
/*  276 */     gridBagConstraints.insets = new Insets(4, 4, 4, 4);
/*  277 */     this.jPanel2.add(this.jLabelUriString, gridBagConstraints);
/*      */     
/*  279 */     this.jTextFieldUriString.setEditable(false);
/*  280 */     this.jTextFieldUriString.setBorder(BorderFactory.createEmptyBorder(1, 1, 1, 1));
/*  281 */     this.jTextFieldUriString.setOpaque(false);
/*  282 */     gridBagConstraints = new GridBagConstraints();
/*  283 */     gridBagConstraints.gridx = 1;
/*  284 */     gridBagConstraints.fill = 2;
/*  285 */     gridBagConstraints.weightx = 1.0D;
/*  286 */     gridBagConstraints.insets = new Insets(4, 4, 4, 4);
/*  287 */     this.jPanel2.add(this.jTextFieldUriString, gridBagConstraints);
/*      */     
/*  289 */     this.jLabelName.setText("Name");
/*  290 */     gridBagConstraints = new GridBagConstraints();
/*  291 */     gridBagConstraints.gridx = 0;
/*  292 */     gridBagConstraints.fill = 2;
/*  293 */     gridBagConstraints.insets = new Insets(0, 4, 4, 4);
/*  294 */     this.jPanel2.add(this.jLabelName, gridBagConstraints);
/*      */     
/*  296 */     gridBagConstraints = new GridBagConstraints();
/*  297 */     gridBagConstraints.gridx = 1;
/*  298 */     gridBagConstraints.fill = 2;
/*  299 */     gridBagConstraints.weightx = 1.0D;
/*  300 */     gridBagConstraints.insets = new Insets(0, 4, 4, 4);
/*  301 */     this.jPanel2.add(this.jTextFieldName, gridBagConstraints);
/*      */     
/*  303 */     this.jSeparator2.setMinimumSize(new Dimension(0, 2));
/*  304 */     gridBagConstraints = new GridBagConstraints();
/*  305 */     gridBagConstraints.gridx = 0;
/*  306 */     gridBagConstraints.gridwidth = 2;
/*  307 */     gridBagConstraints.fill = 2;
/*  308 */     gridBagConstraints.weightx = 1.0D;
/*  309 */     gridBagConstraints.insets = new Insets(4, 4, 6, 4);
/*  310 */     this.jPanel2.add(this.jSeparator2, gridBagConstraints);
/*      */     
/*  312 */     this.jLabelLabel.setText("Label");
/*  313 */     gridBagConstraints = new GridBagConstraints();
/*  314 */     gridBagConstraints.gridx = 0;
/*  315 */     gridBagConstraints.fill = 2;
/*  316 */     gridBagConstraints.insets = new Insets(0, 4, 4, 4);
/*  317 */     this.jPanel2.add(this.jLabelLabel, gridBagConstraints);
/*      */     
/*  319 */     gridBagConstraints = new GridBagConstraints();
/*  320 */     gridBagConstraints.gridx = 1;
/*  321 */     gridBagConstraints.fill = 2;
/*  322 */     gridBagConstraints.weightx = 1.0D;
/*  323 */     gridBagConstraints.insets = new Insets(4, 4, 4, 4);
/*  324 */     this.jPanel2.add(this.jTextFieldLabel, gridBagConstraints);
/*      */     
/*  326 */     this.jScrollPane1.setViewportView(this.jEditorPaneDescription);
/*      */     
/*  328 */     gridBagConstraints = new GridBagConstraints();
/*  329 */     gridBagConstraints.gridx = 1;
/*  330 */     gridBagConstraints.fill = 1;
/*  331 */     gridBagConstraints.weightx = 1.0D;
/*  332 */     gridBagConstraints.weighty = 1.0D;
/*  333 */     gridBagConstraints.insets = new Insets(0, 4, 4, 4);
/*  334 */     this.jPanel2.add(this.jScrollPane1, gridBagConstraints);
/*      */     
/*  336 */     this.jLabelDescription.setText("Description");
/*  337 */     gridBagConstraints = new GridBagConstraints();
/*  338 */     gridBagConstraints.gridx = 0;
/*  339 */     gridBagConstraints.fill = 2;
/*  340 */     gridBagConstraints.anchor = 11;
/*  341 */     gridBagConstraints.insets = new Insets(4, 4, 0, 4);
/*  342 */     this.jPanel2.add(this.jLabelDescription, gridBagConstraints);
/*      */     
/*  344 */     this.jTabbedPane1.addTab("General", this.jPanel2);
/*      */     
/*  346 */     this.jPanel3.setLayout(new GridBagLayout());
/*      */     
/*  348 */     this.jLabelType.setHorizontalAlignment(4);
/*  349 */     this.jLabelType.setText("Type");
/*  350 */     gridBagConstraints = new GridBagConstraints();
/*  351 */     gridBagConstraints.gridx = 0;
/*  352 */     gridBagConstraints.gridy = 1;
/*  353 */     gridBagConstraints.fill = 2;
/*  354 */     gridBagConstraints.insets = new Insets(8, 20, 4, 0);
/*  355 */     this.jPanel3.add(this.jLabelType, gridBagConstraints);
/*      */     
/*  357 */     this.jComboBoxType.setMinimumSize(new Dimension(23, 22));
/*  358 */     this.jComboBoxType.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  360 */         InputControlDialog.this.jComboBoxTypeActionPerformed(evt);
/*      */       }
/*      */       
/*  363 */     });
/*  364 */     gridBagConstraints = new GridBagConstraints();
/*  365 */     gridBagConstraints.gridy = 1;
/*  366 */     gridBagConstraints.fill = 2;
/*  367 */     gridBagConstraints.weightx = 1.0D;
/*  368 */     gridBagConstraints.insets = new Insets(8, 4, 4, 20);
/*  369 */     this.jPanel3.add(this.jComboBoxType, gridBagConstraints);
/*      */     
/*  371 */     this.jLabelMandatory.setHorizontalAlignment(4);
/*  372 */     this.jLabelMandatory.setText("Mandatory");
/*  373 */     gridBagConstraints = new GridBagConstraints();
/*  374 */     gridBagConstraints.gridx = 0;
/*  375 */     gridBagConstraints.gridy = 4;
/*  376 */     gridBagConstraints.fill = 2;
/*  377 */     gridBagConstraints.insets = new Insets(0, 4, 4, 0);
/*  378 */     this.jPanel3.add(this.jLabelMandatory, gridBagConstraints);
/*      */     
/*  380 */     this.jCheckBoxMandatory.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
/*  381 */     gridBagConstraints = new GridBagConstraints();
/*  382 */     gridBagConstraints.gridx = 1;
/*  383 */     gridBagConstraints.gridy = 4;
/*  384 */     gridBagConstraints.fill = 2;
/*  385 */     gridBagConstraints.insets = new Insets(0, 4, 4, 20);
/*  386 */     this.jPanel3.add(this.jCheckBoxMandatory, gridBagConstraints);
/*      */     
/*  388 */     this.jLabelReadOnly.setHorizontalAlignment(4);
/*  389 */     this.jLabelReadOnly.setText("Read Only");
/*  390 */     gridBagConstraints = new GridBagConstraints();
/*  391 */     gridBagConstraints.gridx = 0;
/*  392 */     gridBagConstraints.gridy = 6;
/*  393 */     gridBagConstraints.fill = 2;
/*  394 */     gridBagConstraints.insets = new Insets(0, 4, 8, 0);
/*  395 */     this.jPanel3.add(this.jLabelReadOnly, gridBagConstraints);
/*      */     
/*  397 */     this.jCheckBoxReadOnly.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
/*  398 */     gridBagConstraints = new GridBagConstraints();
/*  399 */     gridBagConstraints.gridx = 1;
/*  400 */     gridBagConstraints.gridy = 6;
/*  401 */     gridBagConstraints.fill = 2;
/*  402 */     gridBagConstraints.insets = new Insets(0, 4, 8, 20);
/*  403 */     this.jPanel3.add(this.jCheckBoxReadOnly, gridBagConstraints);
/*      */     
/*  405 */     this.jSeparator4.setMinimumSize(new Dimension(2, 2));
/*  406 */     this.jSeparator4.setPreferredSize(new Dimension(2, 2));
/*  407 */     gridBagConstraints = new GridBagConstraints();
/*  408 */     gridBagConstraints.gridx = 0;
/*  409 */     gridBagConstraints.gridwidth = 2;
/*  410 */     gridBagConstraints.fill = 2;
/*  411 */     gridBagConstraints.weightx = 1.0D;
/*  412 */     gridBagConstraints.insets = new Insets(0, 8, 0, 8);
/*  413 */     this.jPanel3.add(this.jSeparator4, gridBagConstraints);
/*      */     
/*  415 */     this.jPanel5.setLayout(new GridBagLayout());
/*      */     
/*  417 */     this.jPanelLocate.setLayout(new GridBagLayout());
/*      */     
/*  419 */     this.jLabelLocate.setText("Locate List of Values");
/*  420 */     gridBagConstraints = new GridBagConstraints();
/*  421 */     gridBagConstraints.gridx = 0;
/*  422 */     gridBagConstraints.gridwidth = 2;
/*  423 */     gridBagConstraints.fill = 2;
/*  424 */     gridBagConstraints.insets = new Insets(4, 8, 8, 8);
/*  425 */     this.jPanelLocate.add(this.jLabelLocate, gridBagConstraints);
/*      */     
/*  427 */     this.buttonGroup1.add(this.jRadioButtonRepo);
/*  428 */     this.jRadioButtonRepo.setText("From the repository");
/*  429 */     this.jRadioButtonRepo.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
/*  430 */     this.jRadioButtonRepo.setMargin(new Insets(0, 0, 0, 0));
/*  431 */     this.jRadioButtonRepo.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  433 */         InputControlDialog.this.jRadioButtonRepoActionPerformed(evt);
/*      */       }
/*      */       
/*  436 */     });
/*  437 */     gridBagConstraints = new GridBagConstraints();
/*  438 */     gridBagConstraints.gridx = 0;
/*  439 */     gridBagConstraints.gridwidth = 2;
/*  440 */     gridBagConstraints.fill = 2;
/*  441 */     gridBagConstraints.weightx = 1.0D;
/*  442 */     gridBagConstraints.insets = new Insets(8, 8, 4, 4);
/*  443 */     this.jPanelLocate.add(this.jRadioButtonRepo, gridBagConstraints);
/*      */     
/*  445 */     this.jTextFieldResource.setEnabled(false);
/*  446 */     gridBagConstraints = new GridBagConstraints();
/*  447 */     gridBagConstraints.gridx = 0;
/*  448 */     gridBagConstraints.fill = 2;
/*  449 */     gridBagConstraints.weightx = 1.0D;
/*  450 */     gridBagConstraints.insets = new Insets(0, 30, 4, 0);
/*  451 */     this.jPanelLocate.add(this.jTextFieldResource, gridBagConstraints);
/*      */     
/*  453 */     this.jButtonPickResource.setText("Browse");
/*  454 */     this.jButtonPickResource.setEnabled(false);
/*  455 */     this.jButtonPickResource.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  457 */         InputControlDialog.this.jButtonPickResourceActionPerformed(evt);
/*      */       }
/*      */       
/*  460 */     });
/*  461 */     gridBagConstraints = new GridBagConstraints();
/*  462 */     gridBagConstraints.gridx = 1;
/*  463 */     gridBagConstraints.anchor = 18;
/*  464 */     gridBagConstraints.insets = new Insets(0, 0, 4, 8);
/*  465 */     this.jPanelLocate.add(this.jButtonPickResource, gridBagConstraints);
/*      */     
/*  467 */     this.buttonGroup1.add(this.jRadioButtonLocal);
/*  468 */     this.jRadioButtonLocal.setSelected(true);
/*  469 */     this.jRadioButtonLocal.setText("Locally Defined");
/*  470 */     this.jRadioButtonLocal.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
/*  471 */     this.jRadioButtonLocal.setMargin(new Insets(0, 0, 0, 0));
/*  472 */     this.jRadioButtonLocal.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  474 */         InputControlDialog.this.jRadioButtonLocalActionPerformed(evt);
/*      */       }
/*      */       
/*  477 */     });
/*  478 */     gridBagConstraints = new GridBagConstraints();
/*  479 */     gridBagConstraints.gridx = 0;
/*  480 */     gridBagConstraints.gridwidth = 2;
/*  481 */     gridBagConstraints.fill = 2;
/*  482 */     gridBagConstraints.weightx = 1.0D;
/*  483 */     gridBagConstraints.insets = new Insets(8, 8, 4, 4);
/*  484 */     this.jPanelLocate.add(this.jRadioButtonLocal, gridBagConstraints);
/*      */     
/*  486 */     this.jButtonEditLocalResource.setText("Edit local resource");
/*  487 */     this.jButtonEditLocalResource.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  489 */         InputControlDialog.this.jButtonEditLocalResourceActionPerformed(evt);
/*      */       }
/*      */       
/*  492 */     });
/*  493 */     gridBagConstraints = new GridBagConstraints();
/*  494 */     gridBagConstraints.gridx = 0;
/*  495 */     gridBagConstraints.gridwidth = 2;
/*  496 */     gridBagConstraints.anchor = 18;
/*  497 */     gridBagConstraints.insets = new Insets(0, 30, 0, 0);
/*  498 */     this.jPanelLocate.add(this.jButtonEditLocalResource, gridBagConstraints);
/*      */     
/*  500 */     gridBagConstraints = new GridBagConstraints();
/*  501 */     gridBagConstraints.gridx = 0;
/*  502 */     gridBagConstraints.weighty = 1.0D;
/*  503 */     this.jPanelLocate.add(this.jPanel6, gridBagConstraints);
/*      */     
/*  505 */     gridBagConstraints = new GridBagConstraints();
/*  506 */     gridBagConstraints.gridx = 0;
/*  507 */     gridBagConstraints.gridy = 0;
/*  508 */     gridBagConstraints.fill = 1;
/*  509 */     gridBagConstraints.weightx = 1.0D;
/*  510 */     gridBagConstraints.weighty = 1.0D;
/*  511 */     gridBagConstraints.insets = new Insets(0, 4, 4, 4);
/*  512 */     this.jPanel5.add(this.jPanelLocate, gridBagConstraints);
/*      */     
/*  514 */     this.jPanelQuery.setLayout(new GridBagLayout());
/*      */     
/*  516 */     this.jPanelLocateQuery.setLayout(new GridBagLayout());
/*      */     
/*  518 */     this.jLabelLocate1.setText("Locate query");
/*  519 */     gridBagConstraints = new GridBagConstraints();
/*  520 */     gridBagConstraints.gridx = 0;
/*  521 */     gridBagConstraints.gridwidth = 2;
/*  522 */     gridBagConstraints.fill = 2;
/*  523 */     gridBagConstraints.insets = new Insets(4, 8, 8, 8);
/*  524 */     this.jPanelLocateQuery.add(this.jLabelLocate1, gridBagConstraints);
/*      */     
/*  526 */     this.buttonGroup2.add(this.jRadioButtonRepo1);
/*  527 */     this.jRadioButtonRepo1.setText("From the repository");
/*  528 */     this.jRadioButtonRepo1.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
/*  529 */     this.jRadioButtonRepo1.setMargin(new Insets(0, 0, 0, 0));
/*  530 */     this.jRadioButtonRepo1.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  532 */         InputControlDialog.this.jRadioButtonRepoActionPerformed1(evt);
/*      */       }
/*      */       
/*  535 */     });
/*  536 */     gridBagConstraints = new GridBagConstraints();
/*  537 */     gridBagConstraints.gridx = 0;
/*  538 */     gridBagConstraints.gridwidth = 2;
/*  539 */     gridBagConstraints.fill = 2;
/*  540 */     gridBagConstraints.weightx = 1.0D;
/*  541 */     gridBagConstraints.insets = new Insets(8, 8, 4, 4);
/*  542 */     this.jPanelLocateQuery.add(this.jRadioButtonRepo1, gridBagConstraints);
/*      */     
/*  544 */     this.jTextFieldResource1.setEnabled(false);
/*  545 */     gridBagConstraints = new GridBagConstraints();
/*  546 */     gridBagConstraints.gridx = 0;
/*  547 */     gridBagConstraints.fill = 2;
/*  548 */     gridBagConstraints.weightx = 1.0D;
/*  549 */     gridBagConstraints.insets = new Insets(0, 30, 4, 0);
/*  550 */     this.jPanelLocateQuery.add(this.jTextFieldResource1, gridBagConstraints);
/*      */     
/*  552 */     this.jButtonPickResource1.setText("Browse");
/*  553 */     this.jButtonPickResource1.setEnabled(false);
/*  554 */     this.jButtonPickResource1.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  556 */         InputControlDialog.this.jButtonPickResourceActionPerformed1(evt);
/*      */       }
/*      */       
/*  559 */     });
/*  560 */     gridBagConstraints = new GridBagConstraints();
/*  561 */     gridBagConstraints.gridx = 1;
/*  562 */     gridBagConstraints.anchor = 18;
/*  563 */     gridBagConstraints.insets = new Insets(0, 0, 4, 8);
/*  564 */     this.jPanelLocateQuery.add(this.jButtonPickResource1, gridBagConstraints);
/*      */     
/*  566 */     this.buttonGroup2.add(this.jRadioButtonLocal1);
/*  567 */     this.jRadioButtonLocal1.setSelected(true);
/*  568 */     this.jRadioButtonLocal1.setText("Locally Defined");
/*  569 */     this.jRadioButtonLocal1.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
/*  570 */     this.jRadioButtonLocal1.setMargin(new Insets(0, 0, 0, 0));
/*  571 */     this.jRadioButtonLocal1.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  573 */         InputControlDialog.this.jRadioButtonLocalActionPerformed1(evt);
/*      */       }
/*      */       
/*  576 */     });
/*  577 */     gridBagConstraints = new GridBagConstraints();
/*  578 */     gridBagConstraints.gridx = 0;
/*  579 */     gridBagConstraints.gridwidth = 2;
/*  580 */     gridBagConstraints.fill = 2;
/*  581 */     gridBagConstraints.weightx = 1.0D;
/*  582 */     gridBagConstraints.insets = new Insets(8, 8, 4, 4);
/*  583 */     this.jPanelLocateQuery.add(this.jRadioButtonLocal1, gridBagConstraints);
/*      */     
/*  585 */     this.jButtonEditLocalResource1.setText("Edit local resource");
/*  586 */     this.jButtonEditLocalResource1.setActionCommand("Edit local query resource");
/*  587 */     this.jButtonEditLocalResource1.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  589 */         InputControlDialog.this.jButtonEditLocalResourceActionPerformed1(evt);
/*      */       }
/*      */       
/*  592 */     });
/*  593 */     gridBagConstraints = new GridBagConstraints();
/*  594 */     gridBagConstraints.gridx = 0;
/*  595 */     gridBagConstraints.gridwidth = 2;
/*  596 */     gridBagConstraints.anchor = 18;
/*  597 */     gridBagConstraints.insets = new Insets(0, 30, 0, 0);
/*  598 */     this.jPanelLocateQuery.add(this.jButtonEditLocalResource1, gridBagConstraints);
/*      */     
/*  600 */     gridBagConstraints = new GridBagConstraints();
/*  601 */     gridBagConstraints.gridx = 0;
/*  602 */     gridBagConstraints.weighty = 1.0D;
/*  603 */     this.jPanelLocateQuery.add(this.jPanel7, gridBagConstraints);
/*      */     
/*  605 */     this.jTabbedPane2.addTab("Query resource", this.jPanelLocateQuery);
/*      */     
/*  607 */     this.jPanelFields.setLayout(new GridBagLayout());
/*      */     
/*  609 */     this.jLabelLocate2.setText("Value column");
/*  610 */     gridBagConstraints = new GridBagConstraints();
/*  611 */     gridBagConstraints.gridx = 0;
/*  612 */     gridBagConstraints.fill = 2;
/*  613 */     gridBagConstraints.insets = new Insets(4, 8, 8, 8);
/*  614 */     this.jPanelFields.add(this.jLabelLocate2, gridBagConstraints);
/*      */     
/*  616 */     gridBagConstraints = new GridBagConstraints();
/*  617 */     gridBagConstraints.fill = 2;
/*  618 */     gridBagConstraints.weightx = 1.0D;
/*  619 */     gridBagConstraints.insets = new Insets(4, 0, 8, 8);
/*  620 */     this.jPanelFields.add(this.jTextFieldValueColumn, gridBagConstraints);
/*      */     
/*  622 */     this.jPanelVisibleColumns.setLayout(new GridBagLayout());
/*      */     
/*  624 */     this.jLabelLocate3.setText("Visible query columns");
/*  625 */     gridBagConstraints = new GridBagConstraints();
/*  626 */     gridBagConstraints.gridx = 0;
/*  627 */     gridBagConstraints.gridwidth = 2;
/*  628 */     gridBagConstraints.fill = 2;
/*  629 */     gridBagConstraints.weightx = 1.0D;
/*  630 */     this.jPanelVisibleColumns.add(this.jLabelLocate3, gridBagConstraints);
/*      */     
/*  632 */     this.jListColumns.addMouseListener(new java.awt.event.MouseAdapter() {
/*      */       public void mouseClicked(MouseEvent evt) {
/*  634 */         InputControlDialog.this.jListColumnsMouseClicked(evt);
/*      */       }
/*      */       
/*  637 */     });
/*  638 */     this.jScrollPane2.setViewportView(this.jListColumns);
/*      */     
/*  640 */     gridBagConstraints = new GridBagConstraints();
/*  641 */     gridBagConstraints.gridx = 0;
/*  642 */     gridBagConstraints.fill = 1;
/*  643 */     gridBagConstraints.weightx = 1.0D;
/*  644 */     gridBagConstraints.weighty = 1.0D;
/*  645 */     this.jPanelVisibleColumns.add(this.jScrollPane2, gridBagConstraints);
/*      */     
/*  647 */     this.jPanel8.setLayout(new GridBagLayout());
/*      */     
/*  649 */     this.jButtonAddColumn.setText("Add");
/*  650 */     this.jButtonAddColumn.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  652 */         InputControlDialog.this.jButtonAddColumnActionPerformed(evt);
/*      */       }
/*      */       
/*  655 */     });
/*  656 */     gridBagConstraints = new GridBagConstraints();
/*  657 */     gridBagConstraints.fill = 2;
/*  658 */     gridBagConstraints.weightx = 1.0D;
/*  659 */     gridBagConstraints.insets = new Insets(0, 0, 4, 0);
/*  660 */     this.jPanel8.add(this.jButtonAddColumn, gridBagConstraints);
/*      */     
/*  662 */     this.jButtonModColumn.setText("Modify");
/*  663 */     this.jButtonModColumn.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  665 */         InputControlDialog.this.jButtonModColumnActionPerformed(evt);
/*      */       }
/*      */       
/*  668 */     });
/*  669 */     gridBagConstraints = new GridBagConstraints();
/*  670 */     gridBagConstraints.gridx = 0;
/*  671 */     gridBagConstraints.fill = 2;
/*  672 */     gridBagConstraints.weightx = 1.0D;
/*  673 */     gridBagConstraints.insets = new Insets(0, 0, 4, 0);
/*  674 */     this.jPanel8.add(this.jButtonModColumn, gridBagConstraints);
/*      */     
/*  676 */     this.jButtonRemColumn.setText("Remove");
/*  677 */     this.jButtonRemColumn.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  679 */         InputControlDialog.this.jButtonRemColumnActionPerformed(evt);
/*      */       }
/*      */       
/*  682 */     });
/*  683 */     gridBagConstraints = new GridBagConstraints();
/*  684 */     gridBagConstraints.gridx = 0;
/*  685 */     gridBagConstraints.fill = 2;
/*  686 */     gridBagConstraints.anchor = 11;
/*  687 */     gridBagConstraints.weightx = 1.0D;
/*  688 */     gridBagConstraints.weighty = 1.0D;
/*  689 */     gridBagConstraints.insets = new Insets(0, 0, 4, 0);
/*  690 */     this.jPanel8.add(this.jButtonRemColumn, gridBagConstraints);
/*      */     
/*  692 */     gridBagConstraints = new GridBagConstraints();
/*  693 */     gridBagConstraints.gridx = 1;
/*  694 */     gridBagConstraints.fill = 1;
/*  695 */     gridBagConstraints.weighty = 1.0D;
/*  696 */     gridBagConstraints.insets = new Insets(0, 4, 0, 4);
/*  697 */     this.jPanelVisibleColumns.add(this.jPanel8, gridBagConstraints);
/*      */     
/*  699 */     gridBagConstraints = new GridBagConstraints();
/*  700 */     gridBagConstraints.gridx = 0;
/*  701 */     gridBagConstraints.gridwidth = 2;
/*  702 */     gridBagConstraints.fill = 1;
/*  703 */     gridBagConstraints.weightx = 1.0D;
/*  704 */     gridBagConstraints.weighty = 1.0D;
/*  705 */     gridBagConstraints.insets = new Insets(4, 4, 4, 4);
/*  706 */     this.jPanelFields.add(this.jPanelVisibleColumns, gridBagConstraints);
/*      */     
/*  708 */     this.jTabbedPane2.addTab("Value and visible columns", this.jPanelFields);
/*      */     
/*  710 */     gridBagConstraints = new GridBagConstraints();
/*  711 */     gridBagConstraints.fill = 1;
/*  712 */     gridBagConstraints.weightx = 1.0D;
/*  713 */     gridBagConstraints.weighty = 1.0D;
/*  714 */     this.jPanelQuery.add(this.jTabbedPane2, gridBagConstraints);
/*      */     
/*  716 */     gridBagConstraints = new GridBagConstraints();
/*  717 */     gridBagConstraints.gridx = 0;
/*  718 */     gridBagConstraints.gridy = 0;
/*  719 */     gridBagConstraints.gridwidth = 0;
/*  720 */     gridBagConstraints.fill = 1;
/*  721 */     gridBagConstraints.weightx = 1.0D;
/*  722 */     gridBagConstraints.insets = new Insets(0, 4, 4, 4);
/*  723 */     this.jPanel5.add(this.jPanelQuery, gridBagConstraints);
/*      */     
/*  725 */     gridBagConstraints = new GridBagConstraints();
/*  726 */     gridBagConstraints.gridx = 0;
/*  727 */     gridBagConstraints.gridwidth = 0;
/*  728 */     gridBagConstraints.fill = 1;
/*  729 */     gridBagConstraints.anchor = 11;
/*  730 */     gridBagConstraints.weightx = 1.0D;
/*  731 */     gridBagConstraints.weighty = 1.0D;
/*  732 */     this.jPanel3.add(this.jPanel5, gridBagConstraints);
/*      */     
/*  734 */     this.jTabbedPane1.addTab("Input Control details", this.jPanel3);
/*      */     
/*  736 */     gridBagConstraints = new GridBagConstraints();
/*  737 */     gridBagConstraints.gridx = 0;
/*  738 */     gridBagConstraints.fill = 1;
/*  739 */     gridBagConstraints.weightx = 1.0D;
/*  740 */     gridBagConstraints.weighty = 1.0D;
/*  741 */     getContentPane().add(this.jTabbedPane1, gridBagConstraints);
/*      */     
/*  743 */     this.jPanel4.setLayout(new GridBagLayout());
/*      */     
/*  745 */     this.jPanel4.setMinimumSize(new Dimension(10, 30));
/*  746 */     this.jPanel4.setPreferredSize(new Dimension(10, 30));
/*  747 */     this.jButtonSave.setText("Save");
/*  748 */     this.jButtonSave.setEnabled(false);
/*  749 */     this.jButtonSave.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  751 */         InputControlDialog.this.jButtonSaveActionPerformed(evt);
/*      */       }
/*      */       
/*  754 */     });
/*  755 */     gridBagConstraints = new GridBagConstraints();
/*  756 */     gridBagConstraints.anchor = 13;
/*  757 */     gridBagConstraints.weightx = 1.0D;
/*  758 */     gridBagConstraints.insets = new Insets(0, 0, 0, 4);
/*  759 */     this.jPanel4.add(this.jButtonSave, gridBagConstraints);
/*      */     
/*  761 */     this.jButtonClose.setText("Cancel");
/*  762 */     this.jButtonClose.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  764 */         InputControlDialog.this.jButtonCloseActionPerformed(evt);
/*      */       }
/*      */       
/*  767 */     });
/*  768 */     this.jPanel4.add(this.jButtonClose, new GridBagConstraints());
/*      */     
/*  770 */     gridBagConstraints = new GridBagConstraints();
/*  771 */     gridBagConstraints.gridx = 0;
/*  772 */     gridBagConstraints.fill = 2;
/*  773 */     gridBagConstraints.insets = new Insets(0, 4, 0, 4);
/*  774 */     getContentPane().add(this.jPanel4, gridBagConstraints);
/*      */     
/*  776 */     pack();
/*      */   }
/*      */   
/*      */   private void jButtonRemColumnActionPerformed(ActionEvent evt)
/*      */   {
/*  781 */     int[] keys = this.jListColumns.getSelectedIndices();
/*  782 */     DefaultListModel dlm = (DefaultListModel)this.jListColumns.getModel();
/*  783 */     for (int i = keys.length - 1; i >= 0; i--)
/*      */     {
/*  785 */       dlm.remove(keys[i]);
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private void jButtonAddColumnActionPerformed(ActionEvent evt)
/*      */   {
/*  793 */     String s = JOptionPane.showInputDialog(MainFrame.getMainInstance(), IRPlugin.getString("inputControlDialog.columnName", "Column name"));
/*  794 */     if ((s != null) && (s.trim().length() > 0))
/*      */     {
/*  796 */       ((DefaultListModel)this.jListColumns.getModel()).addElement(s);
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   private void jButtonModColumnActionPerformed(ActionEvent evt)
/*      */   {
/*  803 */     int i = this.jListColumns.getSelectedIndex();
/*  804 */     if (i < 0) return;
/*  805 */     String s = "" + this.jListColumns.getSelectedValue();
/*  806 */     s = JOptionPane.showInputDialog(MainFrame.getMainInstance(), IRPlugin.getString("inputControlDialog.columnName", "Column name"), s);
/*  807 */     if ((s != null) && (s.trim().length() > 0))
/*      */     {
/*  809 */       ((DefaultListModel)this.jListColumns.getModel()).setElementAt(s, i);
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   private void jListColumnsMouseClicked(MouseEvent evt)
/*      */   {
/*  816 */     if ((evt.getClickCount() == 2) && (evt.getButton() == 1) && (this.jListColumns.getSelectedIndex() >= 0))
/*      */     {
/*      */ 
/*      */ 
/*  820 */       jButtonModColumnActionPerformed(null);
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   private void jButtonEditLocalResourceActionPerformed1(ActionEvent evt)
/*      */   {
/*  827 */     jButtonEditLocalResourceActionPerformed(evt);
/*      */   }
/*      */   
/*      */   private void jRadioButtonLocalActionPerformed1(ActionEvent evt)
/*      */   {
/*  832 */     updateQueryResourceFromType();
/*      */   }
/*      */   
/*      */   private void jButtonPickResourceActionPerformed1(ActionEvent evt) {
/*  836 */     ResourceChooser rc = new ResourceChooser();
/*  837 */     rc.setServer(getServer());
/*  838 */     if (rc.showDialog(this, null) == 0)
/*      */     {
/*  840 */       ResourceDescriptor rd = rc.getSelectedDescriptor();
/*  841 */       if ((rd == null) || (rd.getUriString() == null))
/*      */       {
/*  843 */         this.jTextFieldResource1.setText("");
/*      */       }
/*      */       else
/*      */       {
/*  847 */         this.jTextFieldResource1.setText(rd.getUriString());
/*      */       }
/*  849 */       updateSaveButton();
/*      */     }
/*      */   }
/*      */   
/*      */   private void jRadioButtonRepoActionPerformed1(ActionEvent evt) {
/*  854 */     updateQueryResourceFromType();
/*      */   }
/*      */   
/*      */   private void jButtonEditLocalResourceActionPerformed(ActionEvent evt)
/*      */   {
/*  859 */     byte b = Byte.parseByte(((Tag)this.jComboBoxType.getSelectedItem()).getValue() + "");
/*      */     
/*  861 */     if (b == 2)
/*      */     {
/*  863 */       DataTypeDialog dtd = new DataTypeDialog(MainFrame.getMainInstance(), true);
/*  864 */       dtd.setServer(getServer());
/*  865 */       dtd.setParentFolder(getParentFolder() + "/<inputControl>");
/*  866 */       dtd.setDoNotStore(true);
/*  867 */       if (this.dataTypeResourceDescriptor != null)
/*      */       {
/*  869 */         dtd.setResource(this.dataTypeResourceDescriptor);
/*      */       }
/*      */       
/*  872 */       dtd.setVisible(true);
/*      */       
/*  874 */       if (dtd.getDialogResult() == 0)
/*      */       {
/*  876 */         this.dataTypeResourceDescriptor = dtd.getNewResourceDescriptor();
/*      */       }
/*      */     }
/*  879 */     else if ((b == 3) || (b == 6) || (b == 8) || (b == 10))
/*      */     {
/*      */ 
/*      */ 
/*      */ 
/*  884 */       ListOfValuesDialog dtd = new ListOfValuesDialog(MainFrame.getMainInstance(), true);
/*  885 */       dtd.setServer(getServer());
/*  886 */       dtd.setParentFolder(getParentFolder() + "/<inputControl>");
/*  887 */       dtd.setDoNotStore(true);
/*  888 */       if (this.lovResourceDescriptor != null)
/*      */       {
/*  890 */         dtd.setResource(this.lovResourceDescriptor);
/*      */       }
/*      */       
/*  893 */       dtd.setVisible(true);
/*      */       
/*  895 */       if (dtd.getDialogResult() == 0)
/*      */       {
/*  897 */         this.lovResourceDescriptor = dtd.getNewResourceDescriptor();
/*      */       }
/*      */     }
/*  900 */     else if ((b == 4) || (b == 7) || (b == 9) || (b == 11))
/*      */     {
/*      */ 
/*      */ 
/*      */ 
/*  905 */       QueryDialog dtd = new QueryDialog(MainFrame.getMainInstance(), true);
/*  906 */       dtd.setServer(getServer());
/*  907 */       dtd.setParentFolder(getParentFolder() + "/<inputControl>");
/*  908 */       dtd.setDoNotStore(true);
/*  909 */       List datasources = null;
/*      */       
/*  911 */       if (IRPlugin.getMainInstance().getBrandingProperties().getProperty("ireport.manage.datasources.enabled", "true").equals("true")) {
/*      */         try
/*      */         {
/*  914 */           datasources = getServer().getWSClient().listDatasources();
/*  915 */           dtd.setDatasources(datasources);
/*      */         }
/*      */         catch (Exception ex)
/*      */         {
/*  919 */           JOptionPane.showMessageDialog(MainFrame.getMainInstance(), IRPlugin.getFormattedString("repositoryExplorer.message.errorListingDatasources", "Error getting the list of available datasources:\n{0}", new Object[] { ex.getMessage() }));
/*      */           
/*  921 */           ex.printStackTrace();
/*      */         }
/*      */       }
/*      */       
/*  925 */       if (this.queryResourceDescriptor != null)
/*      */       {
/*  927 */         dtd.setResource(this.queryResourceDescriptor);
/*      */       }
/*      */       
/*      */ 
/*  931 */       dtd.setVisible(true);
/*      */       
/*  933 */       if (dtd.getDialogResult() == 0)
/*      */       {
/*  935 */         this.queryResourceDescriptor = dtd.getNewResourceDescriptor();
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   private void jButtonPickResourceActionPerformed(ActionEvent evt)
/*      */   {
/*  943 */     ResourceChooser rc = new ResourceChooser();
/*  944 */     rc.setServer(getServer());
/*  945 */     if (rc.showDialog(this, null) == 0)
/*      */     {
/*  947 */       ResourceDescriptor rd = rc.getSelectedDescriptor();
/*  948 */       if ((rd == null) || (rd.getUriString() == null))
/*      */       {
/*  950 */         this.jTextFieldResource.setText("");
/*      */       }
/*      */       else
/*      */       {
/*  954 */         this.jTextFieldResource.setText(rd.getUriString());
/*      */       }
/*  956 */       updateSaveButton();
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   private void jComboBoxTypeActionPerformed(ActionEvent evt)
/*      */   {
/*  963 */     String value = ((Tag)this.jComboBoxType.getSelectedItem()).getValue() + "";
/*      */     
/*  965 */     int ic_type = Integer.parseInt(value);
/*      */     
/*  967 */     if (ic_type == 1)
/*      */     {
/*  969 */       this.jPanelLocate.setVisible(false);
/*  970 */       this.jPanelQuery.setVisible(false);
/*      */     }
/*  972 */     else if (ic_type == 2)
/*      */     {
/*  974 */       this.jPanelLocate.setVisible(true);
/*  975 */       this.jLabelLocate.setText(IRPlugin.getString("inputControlDialog.labelLocateDataType", "Locate (Data Type)"));
/*  976 */       this.jButtonEditLocalResource.setText(IRPlugin.getString("inputControlDialog.buttonEditLocalResourceDT", "Edit local resource (Data Type)"));
/*      */       
/*  978 */       this.jPanelQuery.setVisible(false);
/*      */     }
/*  980 */     else if ((ic_type == 3) || (ic_type == 8) || (ic_type == 6) || (ic_type == 10))
/*      */     {
/*      */ 
/*      */ 
/*      */ 
/*  985 */       this.jPanelLocate.setVisible(true);
/*  986 */       this.jLabelLocate.setText(IRPlugin.getString("inputControlDialog.labelLocateLOV", "Locate (List of Values)"));
/*  987 */       this.jButtonEditLocalResource.setText(IRPlugin.getString("inputControlDialog.buttonEditLocalResourceLOV", "Edit local resource (List of Values)"));
/*  988 */       this.jPanelQuery.setVisible(false);
/*      */     }
/*  990 */     else if ((ic_type == 4) || (ic_type == 9) || (ic_type == 7) || (ic_type == 11))
/*      */     {
/*      */ 
/*      */ 
/*      */ 
/*  995 */       this.jPanelLocate.setVisible(false);
/*  996 */       this.jPanelQuery.setVisible(true);
/*      */     }
/*      */   }
/*      */   
/*      */   private void jRadioButtonLocalActionPerformed(ActionEvent evt)
/*      */   {
/* 1002 */     updateResourceFromType();
/*      */   }
/*      */   
/*      */   private void jRadioButtonRepoActionPerformed(ActionEvent evt) {
/* 1006 */     updateResourceFromType();
/*      */   }
/*      */   
/*      */   private void jButtonCloseActionPerformed(ActionEvent evt)
/*      */   {
/* 1011 */     setVisible(false);
/* 1012 */     dispose();
/*      */   }
/*      */   
/*      */ 
/*      */   private void jButtonSaveActionPerformed(ActionEvent evt)
/*      */   {
/* 1018 */     ResourceDescriptor rd = new ResourceDescriptor();
/*      */     
/* 1020 */     rd.setDescription(this.jEditorPaneDescription.getText().trim());
/* 1021 */     rd.setName(this.jTextFieldName.getText());
/* 1022 */     String uri = getParentFolder();
/* 1023 */     if (!uri.endsWith("/")) uri = uri + "/";
/* 1024 */     uri = uri + this.jTextFieldName.getText();
/* 1025 */     rd.setUriString(uri);
/* 1026 */     rd.setLabel(this.jTextFieldLabel.getText().trim());
/* 1027 */     rd.setParentFolder(getParentFolder());
/* 1028 */     rd.setIsNew(this.resource == null);
/*      */     
/* 1030 */     rd.setWsType("inputControl");
/*      */     
/* 1032 */     rd.setMandatory(this.jCheckBoxMandatory.isSelected());
/* 1033 */     rd.setReadOnly(this.jCheckBoxReadOnly.isSelected());
/* 1034 */     rd.setControlType(Byte.parseByte(((Tag)this.jComboBoxType.getSelectedItem()).getValue() + ""));
/*      */     
/* 1036 */     if ((((rd.getControlType() == 3 ? 1 : 0) | (rd.getControlType() == 8 ? 1 : 0)) != 0) || (rd.getControlType() == 6) || (rd.getControlType() == 10))
/*      */     {
/*      */ 
/*      */ 
/*      */ 
/* 1041 */       if (this.jRadioButtonLocal.isSelected())
/*      */       {
/* 1043 */         if ((this.lovResourceDescriptor == null) || (!this.lovResourceDescriptor.getWsType().equals("lov")))
/*      */         {
/* 1045 */           JOptionPane.showMessageDialog(this, "The local list of values defined is not valid.\nPress the button \"Edit local resource\" to fix the problem.");
/* 1046 */           return;
/*      */         }
/*      */       }
/*      */       
/* 1050 */       if ((this.jRadioButtonRepo1.isSelected()) && (this.jTextFieldResource1.getText().trim().length() == 0))
/*      */       {
/* 1052 */         JOptionPane.showMessageDialog(this, "Please set a valid reference to a List Of Values in the Repository.");
/* 1053 */         this.jTextFieldResource1.requestFocusInWindow();
/*      */       }
/*      */       
/*      */     }
/* 1057 */     else if (rd.getControlType() == 2)
/*      */     {
/* 1059 */       if (this.jRadioButtonLocal.isSelected())
/*      */       {
/* 1061 */         if ((this.dataTypeResourceDescriptor == null) || (!this.dataTypeResourceDescriptor.getWsType().equals("dataType")))
/*      */         {
/* 1063 */           JOptionPane.showMessageDialog(this, "The local data type defined is not valid.\nPress the button \"Edit local resource\" to fix the problem.");
/* 1064 */           return;
/*      */         }
/*      */       }
/*      */       
/* 1068 */       if ((this.jRadioButtonRepo.isSelected()) && (this.jTextFieldResource.getText().trim().length() == 0))
/*      */       {
/* 1070 */         JOptionPane.showMessageDialog(this, "Please set a valid reference to a data type in the Repository.");
/* 1071 */         this.jTextFieldResource.requestFocusInWindow();
/*      */       }
/*      */       
/*      */     }
/* 1075 */     else if ((rd.getControlType() == 4) || (rd.getControlType() == 9) || (rd.getControlType() == 7) || (rd.getControlType() == 11))
/*      */     {
/*      */ 
/*      */ 
/*      */ 
/* 1080 */       if (this.jRadioButtonLocal1.isSelected())
/*      */       {
/* 1082 */         if ((this.queryResourceDescriptor == null) || (!this.queryResourceDescriptor.getWsType().equals("query")))
/*      */         {
/* 1084 */           JOptionPane.showMessageDialog(this, "The local query defined is not valid.\nPress the button \"Edit local resource\" to fix the problem.");
/* 1085 */           return;
/*      */         }
/*      */       }
/*      */       
/* 1089 */       if ((this.jRadioButtonRepo1.isSelected()) && (this.jTextFieldResource1.getText().trim().length() == 0))
/*      */       {
/* 1091 */         JOptionPane.showMessageDialog(this, "Please set a valid reference to a Query object in the Repository.");
/* 1092 */         this.jTextFieldResource1.requestFocusInWindow();
/* 1093 */         return;
/*      */       }
/*      */       
/* 1096 */       if (this.jTextFieldValueColumn.getText().trim().length() == 0)
/*      */       {
/* 1098 */         JOptionPane.showMessageDialog(this, "Please set the value column.");
/* 1099 */         return;
/*      */       }
/*      */       
/* 1102 */       if (this.jListColumns.getModel().getSize() == 0)
/*      */       {
/* 1104 */         JOptionPane.showMessageDialog(this, "Please set at least one visible column in the visible columns list.");
/* 1105 */         return;
/*      */       }
/*      */       
/* 1108 */       rd.setQueryValueColumn(this.jTextFieldValueColumn.getText());
/* 1109 */       int count = this.jListColumns.getModel().getSize();
/* 1110 */       String[] visibleColumns = new String[count];
/*      */       
/* 1112 */       for (int i = 0; i < count; i++)
/*      */       {
/* 1114 */         visibleColumns[i] = (this.jListColumns.getModel().getElementAt(i) + "");
/*      */       }
/* 1116 */       rd.setQueryVisibleColumns(visibleColumns);
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */     try
/*      */     {
/* 1126 */       validate(rd);
/*      */       
/* 1128 */       ResourceDescriptor rdChild = null;
/* 1129 */       if (rd.getControlType() != 1)
/*      */       {
/*      */ 
/*      */ 
/* 1133 */         if ((rd.getControlType() == 4) || (rd.getControlType() == 9) || (rd.getControlType() == 7) || (rd.getControlType() == 11))
/*      */         {
/*      */ 
/*      */ 
/*      */ 
/* 1138 */           if (this.jRadioButtonRepo1.isSelected())
/*      */           {
/*      */ 
/* 1141 */             rdChild = new ResourceDescriptor();
/* 1142 */             rdChild.setWsType("reference");
/* 1143 */             rdChild.setReferenceUri(this.jTextFieldResource1.getText().trim());
/*      */           }
/*      */           else
/*      */           {
/* 1147 */             rdChild = this.queryResourceDescriptor;
/*      */           }
/*      */         }
/* 1150 */         else if (rd.getControlType() == 2)
/*      */         {
/* 1152 */           if (this.jRadioButtonRepo.isSelected())
/*      */           {
/* 1154 */             rdChild = new ResourceDescriptor();
/* 1155 */             rdChild.setWsType("reference");
/* 1156 */             rdChild.setReferenceUri(this.jTextFieldResource.getText().trim());
/*      */           }
/*      */           else
/*      */           {
/* 1160 */             rdChild = this.dataTypeResourceDescriptor;
/*      */           }
/*      */         }
/* 1163 */         else if ((((rd.getControlType() == 3 ? 1 : 0) | (rd.getControlType() == 8 ? 1 : 0)) != 0) || (rd.getControlType() == 6) || (rd.getControlType() == 10))
/*      */         {
/*      */ 
/*      */ 
/*      */ 
/* 1168 */           if (this.jRadioButtonRepo.isSelected())
/*      */           {
/*      */ 
/* 1171 */             rdChild = new ResourceDescriptor();
/* 1172 */             rdChild.setWsType("reference");
/* 1173 */             rdChild.setReferenceUri(this.jTextFieldResource.getText().trim());
/*      */           }
/*      */           else
/*      */           {
/* 1177 */             rdChild = this.lovResourceDescriptor;
/*      */           }
/*      */         }
/*      */       }
/* 1181 */       if (rdChild != null)
/*      */       {
/* 1183 */         if (rd.getChildren() == null) rd.setChildren(new ArrayList());
/* 1184 */         rd.getChildren().add(rdChild);
/*      */       }
/*      */       
/* 1187 */       this.newResourceDescriptor = getServer().getWSClient().modifyReportUnitResource(getReportUnitUri(), rd, null);
/* 1188 */       setDialogResult(0);
/*      */       
/* 1190 */       if (this.resource != null)
/*      */       {
/* 1192 */         this.resource.setDescriptor(this.newResourceDescriptor);
/*      */       }
/*      */       
/* 1195 */       setVisible(false);
/* 1196 */       dispose();
/*      */     }
/*      */     catch (Exception ex) {
/* 1199 */       JOptionPane.showMessageDialog(this, IRPlugin.getFormattedString("messages.error.3", "Error:\n {0}", new Object[] { ex.getMessage() }));
/* 1200 */       ex.printStackTrace();
/* 1201 */       return;
/*      */     }
/*      */   }
/*      */   
/*      */   public int getDialogResult()
/*      */   {
/* 1207 */     return this.dialogResult;
/*      */   }
/*      */   
/*      */   public void setDialogResult(int dialogResult) {
/* 1211 */     this.dialogResult = dialogResult;
/*      */   }
/*      */   
/*      */   public JServer getServer()
/*      */   {
/* 1216 */     return this.server;
/*      */   }
/*      */   
/*      */   public void setServer(JServer server) {
/* 1220 */     this.server = server;
/*      */   }
/*      */   
/*      */   public String getParentFolder() {
/* 1224 */     return this.parentFolder;
/*      */   }
/*      */   
/*      */   public void setParentFolder(String parentFolder)
/*      */   {
/* 1229 */     this.parentFolder = parentFolder;
/*      */     
/* 1231 */     if ((this.reportUnitUri != null) && (this.reportUnitUri.length() > 0)) {
/* 1232 */       this.parentFolder = (this.reportUnitUri + "_files");
/*      */     }
/* 1234 */     this.jTextFieldUriString.setText(parentFolder);
/*      */   }
/*      */   
/*      */   public String getReportUnitUri()
/*      */   {
/* 1239 */     return this.reportUnitUri;
/*      */   }
/*      */   
/*      */   public void setReportUnitUri(String reportUnitUri) {
/* 1243 */     this.reportUnitUri = reportUnitUri;
/*      */     
/* 1245 */     if ((reportUnitUri != null) && (reportUnitUri.length() > 0))
/* 1246 */       setParentFolder(reportUnitUri + "_files");
/*      */   }
/*      */   
/*      */   public ResourceDescriptor getNewResourceDescriptor() {
/* 1250 */     return this.newResourceDescriptor;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   public void setResource(RepositoryFolder resource)
/*      */   {
/* 1259 */     this.resource = resource;
/*      */     
/* 1261 */     if (resource != null)
/*      */     {
/* 1263 */       setResource(resource.getDescriptor());
/*      */     }
/* 1265 */     this.jTextFieldName.setEditable(false);
/* 1266 */     this.jTextFieldName.setOpaque(false);
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   public void setResource(ResourceDescriptor descriptor)
/*      */   {
/* 1274 */     if (descriptor == null) return;
/* 1275 */     this.jTextFieldName.setText(descriptor.getName());
/* 1276 */     this.jTextFieldLabel.setText(descriptor.getLabel());
/* 1277 */     this.jEditorPaneDescription.setText(descriptor.getDescription());
/*      */     
/* 1279 */     System.out.println("Mandatory: " + descriptor.isMandatory());
/* 1280 */     System.out.println("ReadOnly: " + descriptor.isReadOnly());
/*      */     
/* 1282 */     this.jCheckBoxMandatory.setSelected(descriptor.isMandatory());
/* 1283 */     this.jCheckBoxReadOnly.setSelected(descriptor.isReadOnly());
/*      */     
/* 1285 */     Misc.setComboboxSelectedTagValue(this.jComboBoxType, "" + descriptor.getControlType());
/*      */     
/* 1287 */     if (descriptor.getQueryValueColumn() != null)
/*      */     {
/* 1289 */       this.jTextFieldValueColumn.setText(descriptor.getQueryValueColumn());
/*      */     }
/*      */     
/* 1292 */     if (descriptor.getQueryVisibleColumns() != null)
/*      */     {
/* 1294 */       String[] visibleColumns = descriptor.getQueryVisibleColumns();
/* 1295 */       DefaultListModel dlm = (DefaultListModel)this.jListColumns.getModel();
/* 1296 */       for (int i = 0; i < visibleColumns.length; i++)
/*      */       {
/* 1298 */         dlm.addElement(visibleColumns[i]);
/*      */       }
/*      */     }
/*      */     
/* 1302 */     if (descriptor.getChildren().size() > 0)
/*      */     {
/* 1304 */       ResourceDescriptor rd = (ResourceDescriptor)descriptor.getChildren().get(0);
/*      */       
/* 1306 */       if (rd.getWsType().equals("reference"))
/*      */       {
/*      */ 
/* 1309 */         if ((descriptor.getControlType() == 4) || (descriptor.getControlType() == 9) || (descriptor.getControlType() == 7) || (descriptor.getControlType() == 11))
/*      */         {
/*      */ 
/*      */ 
/*      */ 
/* 1314 */           this.jTextFieldResource1.setText(rd.getReferenceUri());
/* 1315 */           this.jRadioButtonRepo1.setSelected(true);
/*      */         }
/*      */         else
/*      */         {
/* 1319 */           this.jTextFieldResource.setText(rd.getReferenceUri());
/* 1320 */           this.jRadioButtonRepo.setSelected(true);
/*      */         }
/*      */       }
/*      */       else
/*      */       {
/* 1325 */         this.jRadioButtonLocal.setSelected(true);
/* 1326 */         if (rd.getWsType().equals("dataType"))
/*      */         {
/* 1328 */           this.dataTypeResourceDescriptor = rd;
/*      */         }
/* 1330 */         else if (rd.getWsType().equals("lov"))
/*      */         {
/* 1332 */           this.lovResourceDescriptor = rd;
/*      */         }
/* 1334 */         else if (rd.getWsType().equals("query"))
/*      */         {
/* 1336 */           this.queryResourceDescriptor = rd;
/*      */         }
/*      */       }
/*      */       
/* 1340 */       if ((descriptor.getControlType() == 4) || (descriptor.getControlType() == 9) || (descriptor.getControlType() == 7) || (descriptor.getControlType() == 11))
/*      */       {
/*      */ 
/*      */ 
/*      */ 
/* 1345 */         updateQueryResourceFromType();
/*      */       }
/*      */       else
/*      */       {
/* 1349 */         updateResourceFromType();
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   private JEditorPane jEditorPaneDescription;
/*      */   
/*      */   private JLabel jLabel1;
/*      */   
/*      */   private JLabel jLabelDescription;
/*      */   
/*      */   private JLabel jLabelLabel;
/*      */   
/*      */   private JLabel jLabelLocate;
/*      */   
/*      */   private JLabel jLabelLocate1;
/*      */   
/*      */   private JLabel jLabelLocate2;
/*      */   
/*      */   private JLabel jLabelLocate3;
/*      */   
/*      */   private JLabel jLabelMandatory;
/*      */   
/*      */   private JLabel jLabelName;
/*      */   
/*      */   private JLabel jLabelReadOnly;
/*      */   
/*      */   private JLabel jLabelType;
/*      */   
/*      */   private JLabel jLabelUriString;
/*      */   
/*      */   private JList jListColumns;
/*      */   
/*      */   private JPanel jPanel1;
/*      */   
/*      */   private JPanel jPanel2;
/*      */   
/*      */   private JPanel jPanel3;
/*      */   
/*      */   private JPanel jPanel4;
/*      */   
/*      */   private JPanel jPanel5;
/*      */   
/*      */   private JPanel jPanel6;
/*      */   
/*      */   private JPanel jPanel7;
/*      */   
/*      */   private JPanel jPanel8;
/*      */   private JPanel jPanelFields;
/*      */   private JPanel jPanelLocate;
/*      */   private JPanel jPanelLocateQuery;
/*      */   private JPanel jPanelQuery;
/*      */   private JPanel jPanelVisibleColumns;
/*      */   private JRadioButton jRadioButtonLocal;
/*      */   private JRadioButton jRadioButtonLocal1;
/*      */   private JRadioButton jRadioButtonRepo;
/*      */   private JRadioButton jRadioButtonRepo1;
/*      */   private JScrollPane jScrollPane1;
/*      */   private JScrollPane jScrollPane2;
/*      */   private JSeparator jSeparator1;
/*      */   private JSeparator jSeparator2;
/*      */   private JSeparator jSeparator4;
/*      */   private JTabbedPane jTabbedPane1;
/*      */   private JTabbedPane jTabbedPane2;
/*      */   private JTextField jTextFieldLabel;
/*      */   private JTextField jTextFieldName;
/*      */   private JTextField jTextFieldResource;
/*      */   private JTextField jTextFieldResource1;
/*      */   private JTextField jTextFieldUriString;
/*      */   private JTextField jTextFieldValueColumn;
/*      */   public void validate(ResourceDescriptor dataType)
/*      */     throws Exception
/*      */   {
/* 1423 */     ValidationUtils.validateName(dataType.getName());
/* 1424 */     ValidationUtils.validateLabel(dataType.getLabel());
/* 1425 */     ValidationUtils.validateDesc(dataType.getDescription());
/*      */   }
/*      */   
/*      */   public void updateResourceFromType()
/*      */   {
/* 1430 */     this.jTextFieldResource.setEnabled(this.jRadioButtonRepo.isSelected());
/* 1431 */     this.jButtonPickResource.setEnabled(this.jRadioButtonRepo.isSelected());
/*      */     
/* 1433 */     this.jButtonEditLocalResource.setEnabled(this.jRadioButtonLocal.isSelected());
/*      */   }
/*      */   
/*      */   public void updateQueryResourceFromType()
/*      */   {
/* 1438 */     this.jTextFieldResource1.setEnabled(this.jRadioButtonRepo1.isSelected());
/* 1439 */     this.jButtonPickResource1.setEnabled(this.jRadioButtonRepo1.isSelected());
/*      */     
/* 1441 */     this.jButtonEditLocalResource1.setEnabled(this.jRadioButtonLocal1.isSelected());
/*      */   }
/*      */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-ireport-plugin-2.0.1.jar!\com\jaspersoft\jasperserver\irplugin\gui\InputControlDialog.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */