/*      */ package com.jaspersoft.jasperserver.irplugin.gui;
/*      */ 
/*      */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ResourceDescriptor;
/*      */ import com.jaspersoft.jasperserver.irplugin.IRPlugin;
/*      */ import com.jaspersoft.jasperserver.irplugin.JServer;
/*      */ import com.jaspersoft.jasperserver.irplugin.RepositoryReportUnit;
/*      */ import com.jaspersoft.jasperserver.irplugin.gui.explorer.ResourceChooser;
/*      */ import it.businesslogic.ireport.Report;
/*      */ import it.businesslogic.ireport.gui.MainFrame;
/*      */ import java.awt.Container;
/*      */ import java.awt.Dialog;
/*      */ import java.awt.Dimension;
/*      */ import java.awt.GridBagConstraints;
/*      */ import java.awt.GridBagLayout;
/*      */ import java.awt.Insets;
/*      */ import java.awt.Window;
/*      */ import java.awt.event.ActionEvent;
/*      */ import java.awt.event.ActionListener;
/*      */ import java.io.File;
/*      */ import java.util.List;
/*      */ import javax.swing.AbstractButton;
/*      */ import javax.swing.BorderFactory;
/*      */ import javax.swing.ButtonGroup;
/*      */ import javax.swing.JButton;
/*      */ import javax.swing.JComboBox;
/*      */ import javax.swing.JComponent;
/*      */ import javax.swing.JDialog;
/*      */ import javax.swing.JEditorPane;
/*      */ import javax.swing.JFileChooser;
/*      */ import javax.swing.JLabel;
/*      */ import javax.swing.JOptionPane;
/*      */ import javax.swing.JPanel;
/*      */ import javax.swing.JRadioButton;
/*      */ import javax.swing.JScrollPane;
/*      */ import javax.swing.JSeparator;
/*      */ import javax.swing.JTabbedPane;
/*      */ import javax.swing.JTextField;
/*      */ import javax.swing.event.DocumentEvent;
/*      */ import javax.swing.event.DocumentListener;
/*      */ import javax.swing.text.Document;
/*      */ import javax.swing.text.JTextComponent;
/*      */ 
/*      */ public class ReportUnitDialog extends JDialog
/*      */ {
/*   45 */   private int dialogResult = 2;
/*      */   
/*   47 */   private JServer server = null;
/*   48 */   private String parentFolder = null;
/*      */   
/*   50 */   private ResourceDescriptor newResourceDescriptor = null;
/*   51 */   private ResourceDescriptor dataSourceDescriptor = null;
/*   52 */   private RepositoryReportUnit resource = null;
/*      */   
/*   54 */   private boolean controlsSupportActive = false;
/*   55 */   private boolean resourcesSupportActive = false;
/*      */   private ButtonGroup buttonGroup1;
/*      */   private ButtonGroup buttonGroup2;
/*      */   private JButton jButtonBrowse;
/*      */   private JButton jButtonClose;
/*      */   private JButton jButtonEditLocalDataSource;
/*      */   
/*      */   public ReportUnitDialog(java.awt.Frame parent, boolean modal) {
/*   63 */     super(parent, modal);
/*   64 */     initComponents();
/*      */     
/*   66 */     it.businesslogic.ireport.util.Misc.centerFrame(this);
/*   67 */     this.jTextFieldLabel.getDocument().addDocumentListener(new DocumentListener() {
/*      */       public void changedUpdate(DocumentEvent evt) {
/*   69 */         ReportUnitDialog.this.updateSaveButton();
/*      */       }
/*      */       
/*   72 */       public void insertUpdate(DocumentEvent evt) { ReportUnitDialog.this.updateSaveButton(); }
/*      */       
/*      */       public void removeUpdate(DocumentEvent evt) {
/*   75 */         ReportUnitDialog.this.updateSaveButton();
/*      */       }
/*      */       
/*   78 */     });
/*   79 */     this.jTextFieldFile.getDocument().addDocumentListener(new DocumentListener() {
/*      */       public void changedUpdate(DocumentEvent evt) {
/*   81 */         ReportUnitDialog.this.updateSaveButton();
/*      */       }
/*      */       
/*   84 */       public void insertUpdate(DocumentEvent evt) { ReportUnitDialog.this.updateSaveButton(); }
/*      */       
/*      */       public void removeUpdate(DocumentEvent evt) {
/*   87 */         ReportUnitDialog.this.updateSaveButton();
/*      */       }
/*      */       
/*   90 */     });
/*   91 */     this.jTextFieldName.getDocument().addDocumentListener(new DocumentListener() {
/*      */       public void changedUpdate(DocumentEvent evt) {
/*   93 */         ReportUnitDialog.this.updateSaveButton();
/*      */       }
/*      */       
/*   96 */       public void insertUpdate(DocumentEvent evt) { ReportUnitDialog.this.updateSaveButton(); }
/*      */       
/*      */       public void removeUpdate(DocumentEvent evt) {
/*   99 */         ReportUnitDialog.this.updateSaveButton();
/*      */       }
/*      */       
/*  102 */     });
/*  103 */     this.jTextFieldName.requestFocusInWindow();
/*  104 */     this.jRadioButtonRepo.setSelected(true);
/*  105 */     this.jRadioButtonLocal.setSelected(false);
/*      */     
/*  107 */     setControlsSupportActive(false);
/*  108 */     setResourcesSupportActive(false);
/*      */     
/*  110 */     updateResourceFromType();
/*      */     
/*      */ 
/*  113 */     if (!IRPlugin.getMainInstance().getBrandingProperties().getProperty("ireport.manage.datasources.enabled", "true").equals("true"))
/*      */     {
/*  115 */       this.jPanel3.removeAll();
/*  116 */       GridBagConstraints gridBagConstraints = new GridBagConstraints();
/*  117 */       gridBagConstraints.gridx = 0;
/*  118 */       gridBagConstraints.fill = 1;
/*  119 */       gridBagConstraints.weightx = 1.0D;
/*  120 */       gridBagConstraints.weighty = 1.0D;
/*  121 */       gridBagConstraints.insets = new Insets(4, 4, 4, 4);
/*  122 */       QualityLabel jlabel = new QualityLabel();
/*  123 */       jlabel.setText("<html><b>" + IRPlugin.getString("reportUnitDialog.useDefaultDatasource", "This server uses a default data source to run the reports and execute queries") + "</b></html>");
/*  124 */       this.jPanel3.add(jlabel, gridBagConstraints);
/*      */     }
/*      */     
/*  127 */     this.jButtonGetCurrentReport.setEnabled(MainFrame.getMainInstance().getActiveReportFrame() != null);
/*  128 */     applyI18n(); }
/*      */   
/*      */   private JButton jButtonGetCurrentReport;
/*      */   private JButton jButtonPickJrxml;
/*      */   private JButton jButtonPickResource;
/*      */   
/*  134 */   public void applyI18n() { this.jButtonClose.setText(IRPlugin.getString("reportUnitDialog.buttonCancel", "Cancel"));
/*  135 */     this.jButtonSave.setText(IRPlugin.getString("reportUnitDialog.buttonSave", "Save"));
/*  136 */     this.jLabel1.setText(IRPlugin.getString("reportUnitDialog.title", "Report unit"));
/*  137 */     this.jLabelDescription.setText(IRPlugin.getString("reportUnitDialog.labelDescription", "Description"));
/*  138 */     this.jLabelLabel.setText(IRPlugin.getString("reportUnitDialog.labelLabel", "Label"));
/*  139 */     this.jLabelName.setText(IRPlugin.getString("reportUnitDialog.labelName", "Name"));
/*  140 */     this.jLabelUriString.setText(IRPlugin.getString("reportUnitDialog.labelParentFolder", "Parent folder"));
/*      */     
/*  142 */     this.jButtonBrowse.setText(IRPlugin.getString("reportUnitDialog.buttonBrowse", "Browse"));
/*  143 */     this.jButtonEditLocalDataSource.setText(IRPlugin.getString("reportUnitDialog.buttonEditLocalResource", "Edit local datasource"));
/*  144 */     this.jButtonGetCurrentReport.setText(IRPlugin.getString("reportUnitDialog.buttonGetCurrentReport", "Get source from current opened report"));
/*  145 */     this.jButtonPickJrxml.setText(IRPlugin.getString("reportUnitDialog.buttonBrowse", "Browse"));
/*  146 */     this.jButtonPickResource.setText(IRPlugin.getString("reportUnitDialog.buttonBrowse", "Browse"));
/*  147 */     this.jLabelResourceFile.setText(IRPlugin.getString("reportUnitDialog.labelMainJRXML", "Main JRXML"));
/*  148 */     this.jLabelResourceType1.setText(IRPlugin.getString("reportUnitDialog.labelDatasource", "Datasource"));
/*  149 */     this.jRadioButtonLocal.setText(IRPlugin.getString("reportUnitDialog.radioLocal", "Locally Defined"));
/*  150 */     this.jRadioButtonLocal1.setText(IRPlugin.getString("reportUnitDialog.radioLocal", "Locally Defined"));
/*  151 */     this.jRadioButtonRepo.setText(IRPlugin.getString("reportUnitDialog.radioRepo", "From the repository"));
/*  152 */     this.jRadioButtonRepo1.setText(IRPlugin.getString("reportUnitDialog.radioRepo", "From the repository"));
/*      */     
/*  154 */     this.jLabelInputControlRenderingView.setText(IRPlugin.getString("reportUnitDialog.labelInputControlRenderingView", "JSP for running Input Controls (blank for default)"));
/*  155 */     this.jLabelReportRenderingView.setText(IRPlugin.getString("reportUnitDialog.labelReportRenderingView", "JSP for Report View (blank for default)"));
/*      */     
/*  157 */     this.jTabbedPane1.setTitleAt(0, IRPlugin.getString("reportUnitDialog.tabGeneral", "General"));
/*  158 */     this.jTabbedPane1.setTitleAt(1, IRPlugin.getString("reportUnitDialog.tabDetails", "Main report and Data Source"));
/*  159 */     this.jTabbedPane1.setTitleAt(2, IRPlugin.getString("reportUnitDialog.tabOther", "Other"));
/*      */   }
/*      */   
/*      */   private JButton jButtonSave;
/*      */   private JComboBox jComboBoxDatasources;
/*      */   private JEditorPane jEditorPaneDescription;
/*  165 */   private void updateSaveButton() { if ((this.jTextFieldLabel.getText().length() > 0) && (this.jTextFieldName.getText().length() > 0))
/*      */     {
/*      */ 
/*  168 */       this.jButtonSave.setEnabled(true);
/*      */     }
/*      */     else
/*      */     {
/*  172 */       this.jButtonSave.setEnabled(false);
/*      */     }
/*      */   }
/*      */   
/*      */   private JLabel jLabel1;
/*      */   private JLabel jLabelDescription;
/*      */   private JLabel jLabelInputControlRenderingView;
/*      */   private JLabel jLabelLabel;
/*      */   private JLabel jLabelName;
/*      */   private JLabel jLabelReportRenderingView;
/*      */   
/*      */   private void initComponents()
/*      */   {
/*  185 */     this.buttonGroup1 = new ButtonGroup();
/*  186 */     this.buttonGroup2 = new ButtonGroup();
/*  187 */     this.jPanel1 = new JPanel();
/*  188 */     this.jLabel1 = new JLabel();
/*  189 */     this.jSeparator1 = new JSeparator();
/*  190 */     this.jTabbedPane1 = new JTabbedPane();
/*  191 */     this.jPanelCommon = new JPanel();
/*  192 */     this.jLabelUriString = new JLabel();
/*  193 */     this.jTextFieldUriString = new JTextField();
/*  194 */     this.jLabelName = new JLabel();
/*  195 */     this.jTextFieldName = new JTextField();
/*  196 */     this.jSeparator2 = new JSeparator();
/*  197 */     this.jLabelLabel = new JLabel();
/*  198 */     this.jTextFieldLabel = new JTextField();
/*  199 */     this.jScrollPane1 = new JScrollPane();
/*  200 */     this.jEditorPaneDescription = new JEditorPane();
/*  201 */     this.jLabelDescription = new JLabel();
/*  202 */     this.jPanelMainReport = new JPanel();
/*  203 */     this.jLabelResourceFile = new JLabel();
/*  204 */     this.jRadioButtonRepo1 = new JRadioButton();
/*  205 */     this.jPanel6 = new JPanel();
/*  206 */     this.jTextFieldFileRepo = new JTextField();
/*  207 */     this.jButtonPickJrxml = new JButton();
/*  208 */     this.jRadioButtonLocal1 = new JRadioButton();
/*  209 */     this.jPanel8 = new JPanel();
/*  210 */     this.jTextFieldFile = new JTextField();
/*  211 */     this.jButtonBrowse = new JButton();
/*  212 */     this.jButtonGetCurrentReport = new JButton();
/*  213 */     this.jSeparator5 = new JSeparator();
/*  214 */     this.jLabelResourceType1 = new JLabel();
/*  215 */     this.jPanel3 = new JPanel();
/*  216 */     this.jRadioButtonRepo = new JRadioButton();
/*  217 */     this.jComboBoxDatasources = new JComboBox();
/*  218 */     this.jButtonPickResource = new JButton();
/*  219 */     this.jRadioButtonLocal = new JRadioButton();
/*  220 */     this.jButtonEditLocalDataSource = new JButton();
/*  221 */     this.jPanel9 = new JPanel();
/*  222 */     this.jPanelOther = new JPanel();
/*  223 */     this.jLabelInputControlRenderingView = new JLabel();
/*  224 */     this.jTextFieldInputControlRenderingView = new JTextField();
/*  225 */     this.jLabelReportRenderingView = new JLabel();
/*  226 */     this.jTextFieldReportRenderingView = new JTextField();
/*  227 */     this.jPanel10 = new JPanel();
/*  228 */     this.jSeparator4 = new JSeparator();
/*  229 */     this.jPanelButtons = new JPanel();
/*  230 */     this.jButtonSave = new JButton();
/*  231 */     this.jButtonClose = new JButton();
/*      */     
/*  233 */     getContentPane().setLayout(new GridBagLayout());
/*      */     
/*  235 */     setDefaultCloseOperation(2);
/*  236 */     setTitle("Report unit");
/*  237 */     this.jPanel1.setLayout(new GridBagLayout());
/*      */     
/*  239 */     this.jPanel1.setBackground(new java.awt.Color(255, 255, 255));
/*  240 */     this.jLabel1.setFont(new java.awt.Font("Dialog", 1, 12));
/*  241 */     this.jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/jaspersoft/jasperserver/irplugin/res/documents_label.png")));
/*  242 */     this.jLabel1.setText("Report unit");
/*  243 */     this.jLabel1.setVerticalAlignment(3);
/*  244 */     this.jLabel1.setVerticalTextPosition(3);
/*  245 */     GridBagConstraints gridBagConstraints = new GridBagConstraints();
/*  246 */     gridBagConstraints.fill = 1;
/*  247 */     gridBagConstraints.weightx = 1.0D;
/*  248 */     gridBagConstraints.weighty = 1.0D;
/*  249 */     this.jPanel1.add(this.jLabel1, gridBagConstraints);
/*      */     
/*  251 */     gridBagConstraints = new GridBagConstraints();
/*  252 */     gridBagConstraints.fill = 2;
/*  253 */     getContentPane().add(this.jPanel1, gridBagConstraints);
/*      */     
/*  255 */     this.jSeparator1.setMinimumSize(new Dimension(2, 2));
/*  256 */     this.jSeparator1.setPreferredSize(new Dimension(2, 2));
/*  257 */     gridBagConstraints = new GridBagConstraints();
/*  258 */     gridBagConstraints.gridx = 0;
/*  259 */     gridBagConstraints.fill = 2;
/*  260 */     gridBagConstraints.weightx = 1.0D;
/*  261 */     getContentPane().add(this.jSeparator1, gridBagConstraints);
/*      */     
/*  263 */     this.jPanelCommon.setLayout(new GridBagLayout());
/*      */     
/*  265 */     this.jPanelCommon.setPreferredSize(new Dimension(400, 185));
/*  266 */     this.jLabelUriString.setText("Parent folder");
/*  267 */     gridBagConstraints = new GridBagConstraints();
/*  268 */     gridBagConstraints.gridx = 0;
/*  269 */     gridBagConstraints.fill = 2;
/*  270 */     gridBagConstraints.insets = new Insets(4, 4, 4, 4);
/*  271 */     this.jPanelCommon.add(this.jLabelUriString, gridBagConstraints);
/*      */     
/*  273 */     this.jTextFieldUriString.setEditable(false);
/*  274 */     this.jTextFieldUriString.setBorder(BorderFactory.createEmptyBorder(1, 1, 1, 1));
/*  275 */     this.jTextFieldUriString.setOpaque(false);
/*  276 */     gridBagConstraints = new GridBagConstraints();
/*  277 */     gridBagConstraints.gridx = 1;
/*  278 */     gridBagConstraints.fill = 2;
/*  279 */     gridBagConstraints.weightx = 1.0D;
/*  280 */     gridBagConstraints.insets = new Insets(4, 4, 4, 4);
/*  281 */     this.jPanelCommon.add(this.jTextFieldUriString, gridBagConstraints);
/*      */     
/*  283 */     this.jLabelName.setText("Name");
/*  284 */     gridBagConstraints = new GridBagConstraints();
/*  285 */     gridBagConstraints.gridx = 0;
/*  286 */     gridBagConstraints.fill = 2;
/*  287 */     gridBagConstraints.insets = new Insets(0, 4, 4, 4);
/*  288 */     this.jPanelCommon.add(this.jLabelName, gridBagConstraints);
/*      */     
/*  290 */     gridBagConstraints = new GridBagConstraints();
/*  291 */     gridBagConstraints.gridx = 1;
/*  292 */     gridBagConstraints.fill = 2;
/*  293 */     gridBagConstraints.weightx = 1.0D;
/*  294 */     gridBagConstraints.insets = new Insets(0, 4, 4, 4);
/*  295 */     this.jPanelCommon.add(this.jTextFieldName, gridBagConstraints);
/*      */     
/*  297 */     this.jSeparator2.setMinimumSize(new Dimension(0, 2));
/*  298 */     gridBagConstraints = new GridBagConstraints();
/*  299 */     gridBagConstraints.gridx = 0;
/*  300 */     gridBagConstraints.gridwidth = 2;
/*  301 */     gridBagConstraints.fill = 2;
/*  302 */     gridBagConstraints.weightx = 1.0D;
/*  303 */     gridBagConstraints.insets = new Insets(4, 4, 6, 4);
/*  304 */     this.jPanelCommon.add(this.jSeparator2, gridBagConstraints);
/*      */     
/*  306 */     this.jLabelLabel.setText("Label");
/*  307 */     gridBagConstraints = new GridBagConstraints();
/*  308 */     gridBagConstraints.gridx = 0;
/*  309 */     gridBagConstraints.fill = 2;
/*  310 */     gridBagConstraints.insets = new Insets(0, 4, 4, 4);
/*  311 */     this.jPanelCommon.add(this.jLabelLabel, gridBagConstraints);
/*      */     
/*  313 */     gridBagConstraints = new GridBagConstraints();
/*  314 */     gridBagConstraints.gridx = 1;
/*  315 */     gridBagConstraints.fill = 2;
/*  316 */     gridBagConstraints.weightx = 1.0D;
/*  317 */     gridBagConstraints.insets = new Insets(4, 4, 4, 4);
/*  318 */     this.jPanelCommon.add(this.jTextFieldLabel, gridBagConstraints);
/*      */     
/*  320 */     this.jScrollPane1.setViewportView(this.jEditorPaneDescription);
/*      */     
/*  322 */     gridBagConstraints = new GridBagConstraints();
/*  323 */     gridBagConstraints.gridx = 1;
/*  324 */     gridBagConstraints.fill = 1;
/*  325 */     gridBagConstraints.weightx = 1.0D;
/*  326 */     gridBagConstraints.weighty = 1.0D;
/*  327 */     gridBagConstraints.insets = new Insets(0, 4, 4, 4);
/*  328 */     this.jPanelCommon.add(this.jScrollPane1, gridBagConstraints);
/*      */     
/*  330 */     this.jLabelDescription.setText("Description");
/*  331 */     gridBagConstraints = new GridBagConstraints();
/*  332 */     gridBagConstraints.gridx = 0;
/*  333 */     gridBagConstraints.fill = 2;
/*  334 */     gridBagConstraints.anchor = 11;
/*  335 */     gridBagConstraints.insets = new Insets(4, 4, 0, 4);
/*  336 */     this.jPanelCommon.add(this.jLabelDescription, gridBagConstraints);
/*      */     
/*  338 */     this.jTabbedPane1.addTab("Common", this.jPanelCommon);
/*      */     
/*  340 */     this.jPanelMainReport.setLayout(new GridBagLayout());
/*      */     
/*  342 */     this.jLabelResourceFile.setText("Main JRXML");
/*  343 */     gridBagConstraints = new GridBagConstraints();
/*  344 */     gridBagConstraints.gridx = 0;
/*  345 */     gridBagConstraints.gridwidth = 2;
/*  346 */     gridBagConstraints.fill = 2;
/*  347 */     gridBagConstraints.insets = new Insets(8, 4, 0, 4);
/*  348 */     this.jPanelMainReport.add(this.jLabelResourceFile, gridBagConstraints);
/*      */     
/*  350 */     this.buttonGroup2.add(this.jRadioButtonRepo1);
/*  351 */     this.jRadioButtonRepo1.setText("From the repository");
/*  352 */     this.jRadioButtonRepo1.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
/*  353 */     this.jRadioButtonRepo1.setMargin(new Insets(0, 0, 0, 0));
/*  354 */     this.jRadioButtonRepo1.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  356 */         ReportUnitDialog.this.jRadioButtonRepoActionPerformed1(evt);
/*      */       }
/*      */       
/*  359 */     });
/*  360 */     gridBagConstraints = new GridBagConstraints();
/*  361 */     gridBagConstraints.gridx = 0;
/*  362 */     gridBagConstraints.gridwidth = 2;
/*  363 */     gridBagConstraints.fill = 2;
/*  364 */     gridBagConstraints.weightx = 1.0D;
/*  365 */     gridBagConstraints.insets = new Insets(8, 8, 4, 4);
/*  366 */     this.jPanelMainReport.add(this.jRadioButtonRepo1, gridBagConstraints);
/*      */     
/*  368 */     this.jPanel6.setLayout(new GridBagLayout());
/*      */     
/*  370 */     this.jTextFieldFileRepo.setEnabled(false);
/*  371 */     gridBagConstraints = new GridBagConstraints();
/*  372 */     gridBagConstraints.gridx = 1;
/*  373 */     gridBagConstraints.fill = 2;
/*  374 */     gridBagConstraints.weightx = 1.0D;
/*  375 */     this.jPanel6.add(this.jTextFieldFileRepo, gridBagConstraints);
/*      */     
/*  377 */     this.jButtonPickJrxml.setText("Browse");
/*  378 */     this.jButtonPickJrxml.setEnabled(false);
/*  379 */     this.jButtonPickJrxml.setMinimumSize(new Dimension(73, 21));
/*  380 */     this.jButtonPickJrxml.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  382 */         ReportUnitDialog.this.jButton1ActionPerformed12(evt);
/*      */       }
/*      */       
/*  385 */     });
/*  386 */     this.jPanel6.add(this.jButtonPickJrxml, new GridBagConstraints());
/*      */     
/*  388 */     gridBagConstraints = new GridBagConstraints();
/*  389 */     gridBagConstraints.gridx = 0;
/*  390 */     gridBagConstraints.fill = 2;
/*  391 */     gridBagConstraints.weightx = 1.0D;
/*  392 */     gridBagConstraints.insets = new Insets(0, 30, 0, 4);
/*  393 */     this.jPanelMainReport.add(this.jPanel6, gridBagConstraints);
/*      */     
/*  395 */     this.buttonGroup2.add(this.jRadioButtonLocal1);
/*  396 */     this.jRadioButtonLocal1.setSelected(true);
/*  397 */     this.jRadioButtonLocal1.setText("Locally Defined");
/*  398 */     this.jRadioButtonLocal1.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
/*  399 */     this.jRadioButtonLocal1.setMargin(new Insets(0, 0, 0, 0));
/*  400 */     this.jRadioButtonLocal1.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  402 */         ReportUnitDialog.this.jRadioButtonLocalActionPerformed1(evt);
/*      */       }
/*      */       
/*  405 */     });
/*  406 */     gridBagConstraints = new GridBagConstraints();
/*  407 */     gridBagConstraints.gridx = 0;
/*  408 */     gridBagConstraints.gridwidth = 2;
/*  409 */     gridBagConstraints.fill = 2;
/*  410 */     gridBagConstraints.weightx = 1.0D;
/*  411 */     gridBagConstraints.insets = new Insets(8, 8, 4, 4);
/*  412 */     this.jPanelMainReport.add(this.jRadioButtonLocal1, gridBagConstraints);
/*      */     
/*  414 */     this.jPanel8.setLayout(new GridBagLayout());
/*      */     
/*  416 */     gridBagConstraints = new GridBagConstraints();
/*  417 */     gridBagConstraints.gridx = 1;
/*  418 */     gridBagConstraints.fill = 2;
/*  419 */     gridBagConstraints.weightx = 1.0D;
/*  420 */     this.jPanel8.add(this.jTextFieldFile, gridBagConstraints);
/*      */     
/*  422 */     this.jButtonBrowse.setText("Browse");
/*  423 */     this.jButtonBrowse.setMinimumSize(new Dimension(73, 21));
/*  424 */     this.jButtonBrowse.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  426 */         ReportUnitDialog.this.jButtonBrowseActionPerformed1(evt);
/*      */       }
/*      */       
/*  429 */     });
/*  430 */     this.jPanel8.add(this.jButtonBrowse, new GridBagConstraints());
/*      */     
/*  432 */     gridBagConstraints = new GridBagConstraints();
/*  433 */     gridBagConstraints.gridx = 0;
/*  434 */     gridBagConstraints.fill = 2;
/*  435 */     gridBagConstraints.weightx = 1.0D;
/*  436 */     gridBagConstraints.insets = new Insets(0, 30, 0, 4);
/*  437 */     this.jPanelMainReport.add(this.jPanel8, gridBagConstraints);
/*      */     
/*  439 */     this.jButtonGetCurrentReport.setText("Get source from current opened report");
/*  440 */     this.jButtonGetCurrentReport.setMinimumSize(new Dimension(73, 21));
/*  441 */     this.jButtonGetCurrentReport.setPreferredSize(new Dimension(219, 21));
/*  442 */     this.jButtonGetCurrentReport.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  444 */         ReportUnitDialog.this.jButton1ActionPerformed11(evt);
/*      */       }
/*      */       
/*  447 */     });
/*  448 */     gridBagConstraints = new GridBagConstraints();
/*  449 */     gridBagConstraints.gridx = 0;
/*  450 */     gridBagConstraints.anchor = 18;
/*  451 */     gridBagConstraints.insets = new Insets(2, 30, 2, 4);
/*  452 */     this.jPanelMainReport.add(this.jButtonGetCurrentReport, gridBagConstraints);
/*      */     
/*  454 */     this.jSeparator5.setMinimumSize(new Dimension(0, 2));
/*  455 */     gridBagConstraints = new GridBagConstraints();
/*  456 */     gridBagConstraints.gridx = 0;
/*  457 */     gridBagConstraints.gridwidth = 2;
/*  458 */     gridBagConstraints.fill = 2;
/*  459 */     gridBagConstraints.weightx = 1.0D;
/*  460 */     gridBagConstraints.insets = new Insets(6, 4, 6, 4);
/*  461 */     this.jPanelMainReport.add(this.jSeparator5, gridBagConstraints);
/*      */     
/*  463 */     this.jLabelResourceType1.setText("Datasource");
/*  464 */     gridBagConstraints = new GridBagConstraints();
/*  465 */     gridBagConstraints.gridx = 0;
/*  466 */     gridBagConstraints.fill = 2;
/*  467 */     gridBagConstraints.insets = new Insets(0, 4, 4, 4);
/*  468 */     this.jPanelMainReport.add(this.jLabelResourceType1, gridBagConstraints);
/*      */     
/*  470 */     this.jPanel3.setLayout(new GridBagLayout());
/*      */     
/*  472 */     this.buttonGroup1.add(this.jRadioButtonRepo);
/*  473 */     this.jRadioButtonRepo.setText("From the repository");
/*  474 */     this.jRadioButtonRepo.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
/*  475 */     this.jRadioButtonRepo.setMargin(new Insets(0, 0, 0, 0));
/*  476 */     this.jRadioButtonRepo.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  478 */         ReportUnitDialog.this.jRadioButtonRepoActionPerformed(evt);
/*      */       }
/*      */       
/*  481 */     });
/*  482 */     gridBagConstraints = new GridBagConstraints();
/*  483 */     gridBagConstraints.gridx = 0;
/*  484 */     gridBagConstraints.gridwidth = 2;
/*  485 */     gridBagConstraints.fill = 2;
/*  486 */     gridBagConstraints.weightx = 1.0D;
/*  487 */     gridBagConstraints.insets = new Insets(8, 8, 4, 4);
/*  488 */     this.jPanel3.add(this.jRadioButtonRepo, gridBagConstraints);
/*      */     
/*  490 */     this.jComboBoxDatasources.setEditable(true);
/*  491 */     this.jComboBoxDatasources.setEnabled(false);
/*  492 */     gridBagConstraints = new GridBagConstraints();
/*  493 */     gridBagConstraints.gridx = 0;
/*  494 */     gridBagConstraints.fill = 2;
/*  495 */     gridBagConstraints.weightx = 1.0D;
/*  496 */     gridBagConstraints.insets = new Insets(0, 30, 4, 2);
/*  497 */     this.jPanel3.add(this.jComboBoxDatasources, gridBagConstraints);
/*      */     
/*  499 */     this.jButtonPickResource.setText("Browse");
/*  500 */     this.jButtonPickResource.setEnabled(false);
/*  501 */     this.jButtonPickResource.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  503 */         ReportUnitDialog.this.jButtonPickResourceActionPerformed(evt);
/*      */       }
/*      */       
/*  506 */     });
/*  507 */     gridBagConstraints = new GridBagConstraints();
/*  508 */     gridBagConstraints.gridx = 1;
/*  509 */     gridBagConstraints.anchor = 18;
/*  510 */     gridBagConstraints.insets = new Insets(0, 0, 4, 8);
/*  511 */     this.jPanel3.add(this.jButtonPickResource, gridBagConstraints);
/*      */     
/*  513 */     this.buttonGroup1.add(this.jRadioButtonLocal);
/*  514 */     this.jRadioButtonLocal.setSelected(true);
/*  515 */     this.jRadioButtonLocal.setText("Locally Defined");
/*  516 */     this.jRadioButtonLocal.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
/*  517 */     this.jRadioButtonLocal.setMargin(new Insets(0, 0, 0, 0));
/*  518 */     this.jRadioButtonLocal.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  520 */         ReportUnitDialog.this.jRadioButtonLocalActionPerformed(evt);
/*      */       }
/*      */       
/*  523 */     });
/*  524 */     gridBagConstraints = new GridBagConstraints();
/*  525 */     gridBagConstraints.gridx = 0;
/*  526 */     gridBagConstraints.gridwidth = 2;
/*  527 */     gridBagConstraints.fill = 2;
/*  528 */     gridBagConstraints.weightx = 1.0D;
/*  529 */     gridBagConstraints.insets = new Insets(8, 8, 4, 4);
/*  530 */     this.jPanel3.add(this.jRadioButtonLocal, gridBagConstraints);
/*      */     
/*  532 */     this.jButtonEditLocalDataSource.setText("Edit local datasource");
/*  533 */     this.jButtonEditLocalDataSource.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  535 */         ReportUnitDialog.this.jButtonEditLocalDataSourceActionPerformed(evt);
/*      */       }
/*      */       
/*  538 */     });
/*  539 */     gridBagConstraints = new GridBagConstraints();
/*  540 */     gridBagConstraints.gridx = 0;
/*  541 */     gridBagConstraints.gridwidth = 2;
/*  542 */     gridBagConstraints.anchor = 18;
/*  543 */     gridBagConstraints.insets = new Insets(0, 30, 0, 0);
/*  544 */     this.jPanel3.add(this.jButtonEditLocalDataSource, gridBagConstraints);
/*      */     
/*  546 */     gridBagConstraints = new GridBagConstraints();
/*  547 */     gridBagConstraints.gridx = 0;
/*  548 */     gridBagConstraints.fill = 1;
/*  549 */     gridBagConstraints.weightx = 1.0D;
/*  550 */     this.jPanelMainReport.add(this.jPanel3, gridBagConstraints);
/*      */     
/*  552 */     gridBagConstraints = new GridBagConstraints();
/*  553 */     gridBagConstraints.gridx = 0;
/*  554 */     gridBagConstraints.weighty = 1.0D;
/*  555 */     this.jPanelMainReport.add(this.jPanel9, gridBagConstraints);
/*      */     
/*  557 */     this.jTabbedPane1.addTab("Main report and Data Source", this.jPanelMainReport);
/*      */     
/*  559 */     this.jPanelOther.setLayout(new GridBagLayout());
/*      */     
/*  561 */     this.jLabelInputControlRenderingView.setText("JSP for running Input Controls (blank for default)");
/*  562 */     gridBagConstraints = new GridBagConstraints();
/*  563 */     gridBagConstraints.gridx = 0;
/*  564 */     gridBagConstraints.gridwidth = 2;
/*  565 */     gridBagConstraints.fill = 2;
/*  566 */     gridBagConstraints.insets = new Insets(8, 4, 0, 4);
/*  567 */     this.jPanelOther.add(this.jLabelInputControlRenderingView, gridBagConstraints);
/*      */     
/*  569 */     gridBagConstraints = new GridBagConstraints();
/*  570 */     gridBagConstraints.gridx = 0;
/*  571 */     gridBagConstraints.fill = 2;
/*  572 */     gridBagConstraints.weightx = 1.0D;
/*  573 */     gridBagConstraints.insets = new Insets(0, 4, 4, 4);
/*  574 */     this.jPanelOther.add(this.jTextFieldInputControlRenderingView, gridBagConstraints);
/*      */     
/*  576 */     this.jLabelReportRenderingView.setText("JSP for Report View (blank for default)");
/*  577 */     gridBagConstraints = new GridBagConstraints();
/*  578 */     gridBagConstraints.gridx = 0;
/*  579 */     gridBagConstraints.gridwidth = 2;
/*  580 */     gridBagConstraints.fill = 2;
/*  581 */     gridBagConstraints.insets = new Insets(8, 4, 0, 4);
/*  582 */     this.jPanelOther.add(this.jLabelReportRenderingView, gridBagConstraints);
/*      */     
/*  584 */     gridBagConstraints = new GridBagConstraints();
/*  585 */     gridBagConstraints.gridx = 0;
/*  586 */     gridBagConstraints.fill = 2;
/*  587 */     gridBagConstraints.weightx = 1.0D;
/*  588 */     gridBagConstraints.insets = new Insets(0, 4, 4, 4);
/*  589 */     this.jPanelOther.add(this.jTextFieldReportRenderingView, gridBagConstraints);
/*      */     
/*  591 */     gridBagConstraints = new GridBagConstraints();
/*  592 */     gridBagConstraints.gridx = 0;
/*  593 */     gridBagConstraints.weighty = 1.0D;
/*  594 */     this.jPanelOther.add(this.jPanel10, gridBagConstraints);
/*      */     
/*  596 */     this.jTabbedPane1.addTab("Other", this.jPanelOther);
/*      */     
/*  598 */     gridBagConstraints = new GridBagConstraints();
/*  599 */     gridBagConstraints.gridx = 0;
/*  600 */     gridBagConstraints.fill = 1;
/*  601 */     gridBagConstraints.weightx = 1.0D;
/*  602 */     gridBagConstraints.weighty = 1.0D;
/*  603 */     gridBagConstraints.insets = new Insets(4, 4, 4, 4);
/*  604 */     getContentPane().add(this.jTabbedPane1, gridBagConstraints);
/*      */     
/*  606 */     this.jSeparator4.setMinimumSize(new Dimension(2, 2));
/*  607 */     this.jSeparator4.setPreferredSize(new Dimension(2, 2));
/*  608 */     gridBagConstraints = new GridBagConstraints();
/*  609 */     gridBagConstraints.gridx = 0;
/*  610 */     gridBagConstraints.fill = 2;
/*  611 */     gridBagConstraints.weightx = 1.0D;
/*  612 */     getContentPane().add(this.jSeparator4, gridBagConstraints);
/*      */     
/*  614 */     this.jPanelButtons.setLayout(new GridBagLayout());
/*      */     
/*  616 */     this.jPanelButtons.setMinimumSize(new Dimension(10, 30));
/*  617 */     this.jPanelButtons.setPreferredSize(new Dimension(10, 30));
/*  618 */     this.jButtonSave.setText("Create report unit");
/*  619 */     this.jButtonSave.setEnabled(false);
/*  620 */     this.jButtonSave.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  622 */         ReportUnitDialog.this.jButtonSaveActionPerformed(evt);
/*      */       }
/*      */       
/*  625 */     });
/*  626 */     gridBagConstraints = new GridBagConstraints();
/*  627 */     gridBagConstraints.anchor = 13;
/*  628 */     gridBagConstraints.weightx = 1.0D;
/*  629 */     gridBagConstraints.insets = new Insets(0, 0, 0, 4);
/*  630 */     this.jPanelButtons.add(this.jButtonSave, gridBagConstraints);
/*      */     
/*  632 */     this.jButtonClose.setText("Cancel");
/*  633 */     this.jButtonClose.addActionListener(new ActionListener() {
/*      */       public void actionPerformed(ActionEvent evt) {
/*  635 */         ReportUnitDialog.this.jButtonCloseActionPerformed(evt);
/*      */       }
/*      */       
/*  638 */     });
/*  639 */     this.jPanelButtons.add(this.jButtonClose, new GridBagConstraints());
/*      */     
/*  641 */     gridBagConstraints = new GridBagConstraints();
/*  642 */     gridBagConstraints.gridx = 0;
/*  643 */     gridBagConstraints.fill = 2;
/*  644 */     gridBagConstraints.insets = new Insets(0, 4, 0, 4);
/*  645 */     getContentPane().add(this.jPanelButtons, gridBagConstraints);
/*      */     
/*  647 */     pack();
/*      */   }
/*      */   
/*      */   private void jButton1ActionPerformed12(ActionEvent evt) {
/*  651 */     ResourceChooser rc = new ResourceChooser();
/*  652 */     rc.setServer(getServer());
/*  653 */     if (rc.showDialog(this, null) == 0) {
/*  654 */       ResourceDescriptor rd = rc.getSelectedDescriptor();
/*      */       
/*  656 */       if ((rd == null) || (rd.getUriString() == null)) {
/*  657 */         this.jTextFieldFileRepo.setText("");
/*      */       } else {
/*  659 */         if (!rd.getWsType().equals("jrxml"))
/*      */         {
/*  661 */           JOptionPane.showMessageDialog(MainFrame.getMainInstance(), IRPlugin.getString("reportUnitDialog.message.chooseJrxml", "Please choose a JRXML resource"), "", 2);
/*      */           
/*      */ 
/*  664 */           return;
/*      */         }
/*      */         
/*      */ 
/*  668 */         this.jTextFieldFileRepo.setText(rd.getUriString());
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */   private void jRadioButtonLocalActionPerformed1(ActionEvent evt)
/*      */   {
/*  675 */     updateJrxmlFromType();
/*      */   }
/*      */   
/*      */   private void jRadioButtonRepoActionPerformed1(ActionEvent evt) {
/*  679 */     updateJrxmlFromType();
/*      */   }
/*      */   
/*      */   private void jButton1ActionPerformed11(ActionEvent evt)
/*      */   {
/*  684 */     Report report = MainFrame.getMainInstance().getActiveReportFrame().getReport();
/*  685 */     if (report.getFilename() == null)
/*      */     {
/*  687 */       if (JOptionPane.showConfirmDialog(this, IRPlugin.getString("reportUnitDialog.message.saveNow", "Save the report now?")) == 0)
/*      */       {
/*      */ 
/*  690 */         MainFrame.getMainInstance().save(MainFrame.getMainInstance().getActiveReportFrame());
/*      */       }
/*      */       else
/*      */       {
/*  694 */         return;
/*      */       }
/*      */     }
/*  697 */     this.jTextFieldFile.setText(report.getFilename());
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private void jButtonEditLocalDataSourceActionPerformed(ActionEvent evt)
/*      */   {
/*  704 */     DataSourceDialog dtd = new DataSourceDialog(MainFrame.getMainInstance(), true);
/*  705 */     dtd.setServer(getServer());
/*  706 */     dtd.setParentFolder(getParentFolder() + "/<dataSource>");
/*  707 */     dtd.setDoNotStore(true);
/*  708 */     if (this.dataSourceDescriptor != null)
/*      */     {
/*  710 */       dtd.setResource(this.dataSourceDescriptor);
/*      */     }
/*      */     
/*  713 */     dtd.setVisible(true);
/*      */     
/*  715 */     if (dtd.getDialogResult() == 0)
/*      */     {
/*  717 */       this.dataSourceDescriptor = dtd.getNewResourceDescriptor();
/*      */     }
/*      */   }
/*      */   
/*      */   private void jRadioButtonLocalActionPerformed(ActionEvent evt)
/*      */   {
/*  723 */     updateResourceFromType();
/*      */   }
/*      */   
/*      */   private void jButtonPickResourceActionPerformed(ActionEvent evt) {
/*  727 */     ResourceChooser rc = new ResourceChooser();
/*  728 */     rc.setServer(getServer());
/*  729 */     if (rc.showDialog(this, null) == 0) {
/*  730 */       ResourceDescriptor rd = rc.getSelectedDescriptor();
/*  731 */       if ((rd == null) || (rd.getUriString() == null)) {
/*  732 */         this.jComboBoxDatasources.setSelectedItem("");
/*      */       } else {
/*  734 */         this.jComboBoxDatasources.setSelectedItem(rd.getUriString());
/*      */       }
/*  736 */       updateSaveButton();
/*      */     }
/*      */   }
/*      */   
/*      */   private void jRadioButtonRepoActionPerformed(ActionEvent evt) {
/*  741 */     updateResourceFromType();
/*      */   }
/*      */   
/*      */   private void jButtonCloseActionPerformed(ActionEvent evt)
/*      */   {
/*  746 */     setVisible(false);
/*  747 */     dispose();
/*      */   }
/*      */   
/*      */ 
/*      */   private void jButtonSaveActionPerformed(ActionEvent evt)
/*      */   {
/*  753 */     ResourceDescriptor rd = new ResourceDescriptor();
/*      */     
/*  755 */     File resourceFile = null;
/*      */     
/*  757 */     rd.setWsType("reportUnit");
/*  758 */     rd.setDescription(this.jEditorPaneDescription.getText().trim());
/*  759 */     rd.setName(this.jTextFieldName.getText());
/*  760 */     String uri = getParentFolder();
/*  761 */     if (!uri.endsWith("/")) uri = uri + "/";
/*  762 */     uri = uri + this.jTextFieldName.getText();
/*  763 */     rd.setUriString(uri);
/*  764 */     rd.setLabel(this.jTextFieldLabel.getText().trim());
/*  765 */     rd.setParentFolder(getParentFolder());
/*  766 */     rd.setIsNew(this.resource == null);
/*      */     
/*  768 */     if (this.jTextFieldInputControlRenderingView.getText().trim().length() > 0)
/*      */     {
/*  770 */       rd.setResourceProperty("PROP_RU_INPUTCONTROL_RENDERING_VIEW", this.jTextFieldInputControlRenderingView.getText().trim());
/*      */     }
/*      */     
/*  773 */     if (this.jTextFieldReportRenderingView.getText().trim().length() > 0)
/*      */     {
/*  775 */       rd.setResourceProperty("PROP_RU_REPORT_RENDERING_VIEW", this.jTextFieldReportRenderingView.getText().trim());
/*      */     }
/*      */     
/*      */ 
/*  779 */     if (IRPlugin.getMainInstance().getBrandingProperties().getProperty("ireport.manage.datasources.enabled", "true").equals("true"))
/*      */     {
/*      */       ResourceDescriptor tmpDataSourceDescriptor;
/*  782 */       if (this.jRadioButtonRepo.isSelected())
/*      */       {
/*  784 */         ResourceDescriptor tmpDataSourceDescriptor = new ResourceDescriptor();
/*  785 */         tmpDataSourceDescriptor.setWsType("datasource");
/*  786 */         tmpDataSourceDescriptor.setReferenceUri(this.jComboBoxDatasources.getSelectedItem() + "");
/*  787 */         tmpDataSourceDescriptor.setIsReference(true);
/*      */       }
/*      */       else
/*      */       {
/*  791 */         if (this.dataSourceDescriptor == null)
/*      */         {
/*  793 */           JOptionPane.showMessageDialog(this, IRPlugin.getString("reportUnitDialog.message.localDatasourceNotDefined", "The local datasource is not correctly defined.\nPress the button \"Edit local datasource\" to fix the problem."));
/*      */           
/*  795 */           return;
/*      */         }
/*  797 */         tmpDataSourceDescriptor = this.dataSourceDescriptor;
/*  798 */         tmpDataSourceDescriptor.setIsReference(false);
/*      */       }
/*      */       
/*  801 */       rd.getChildren().add(tmpDataSourceDescriptor);
/*      */     }
/*      */     
/*      */ 
/*  805 */     ResourceDescriptor jrxmlDescriptor = new ResourceDescriptor();
/*  806 */     jrxmlDescriptor.setWsType("jrxml");
/*      */     
/*  808 */     if (this.jRadioButtonRepo1.isSelected())
/*      */     {
/*  810 */       jrxmlDescriptor.setIsNew(true);
/*  811 */       jrxmlDescriptor.setMainReport(true);
/*  812 */       jrxmlDescriptor.setIsReference(true);
/*  813 */       jrxmlDescriptor.setReferenceUri(this.jTextFieldFileRepo.getText());
/*  814 */       rd.getChildren().add(jrxmlDescriptor);
/*      */ 
/*      */ 
/*      */     }
/*  818 */     else if ((this.resource == null) || (this.jTextFieldFile.getText().trim().length() > 0))
/*      */     {
/*  820 */       jrxmlDescriptor.setName(this.jTextFieldName.getText() + "_jrxml");
/*  821 */       jrxmlDescriptor.setLabel("Main jrxml");
/*  822 */       jrxmlDescriptor.setDescription("Main jrxml");
/*  823 */       jrxmlDescriptor.setIsNew(true);
/*  824 */       jrxmlDescriptor.setHasData(true);
/*  825 */       jrxmlDescriptor.setMainReport(true);
/*  826 */       resourceFile = new File(this.jTextFieldFile.getText());
/*      */       
/*  828 */       if (!resourceFile.exists())
/*      */       {
/*  830 */         JOptionPane.showMessageDialog(this, IRPlugin.getFormattedString("reportUnitDialog.message.fileNotFound", "{0}\n\nFile not found!", new Object[] { this.jTextFieldFile.getText() }));
/*      */         
/*  832 */         return;
/*      */       }
/*  834 */       rd.getChildren().add(jrxmlDescriptor);
/*      */     }
/*      */     
/*      */ 
/*      */     try
/*      */     {
/*  840 */       validate(rd);
/*  841 */       this.newResourceDescriptor = getServer().getWSClient().addOrModifyResource(rd, resourceFile);
/*  842 */       setDialogResult(0);
/*      */       
/*  844 */       if ((this.resource != null) && (this.newResourceDescriptor != null))
/*      */       {
/*  846 */         this.resource.setDescriptor(this.newResourceDescriptor);
/*      */       }
/*      */       
/*  849 */       setVisible(false);
/*  850 */       dispose();
/*      */     } catch (Exception ex) {
/*  852 */       JOptionPane.showMessageDialog(this, IRPlugin.getFormattedString("messages.error.3", "Error:\n {0}", new Object[] { ex.getMessage() }));
/*  853 */       ex.printStackTrace();
/*  854 */       return;
/*      */     }
/*      */   }
/*      */   
/*      */   private void jButtonBrowseActionPerformed1(ActionEvent evt) {
/*  859 */     String fileName = "";
/*  860 */     JFileChooser jfc = new JFileChooser(MainFrame.getMainInstance().getCurrentDirectory());
/*      */     
/*  862 */     jfc.setDialogTitle("Pick a file....");
/*      */     
/*  864 */     jfc.setFileFilter(new javax.swing.filechooser.FileFilter() {
/*      */       public boolean accept(File file) {
/*  866 */         String filename = file.getName();
/*  867 */         return (filename.toLowerCase().endsWith(".xml")) || (file.isDirectory()) || (filename.toLowerCase().endsWith(".jrxml"));
/*      */       }
/*      */       
/*  870 */       public String getDescription() { return "JasperReports XML *.xml, *.jrxml";
/*      */       }
/*      */ 
/*  873 */     });
/*  874 */     jfc.setMultiSelectionEnabled(false);
/*  875 */     jfc.setDialogType(0);
/*  876 */     if (jfc.showOpenDialog(this) == 0)
/*      */     {
/*  878 */       this.jTextFieldFile.setText(jfc.getSelectedFile() + "");
/*  879 */       updateSaveButton();
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   public static void main(String[] args)
/*      */   {
/*  887 */     java.awt.EventQueue.invokeLater(new Runnable() {
/*      */       public void run() {
/*  889 */         new ReportUnitDialog(new javax.swing.JFrame(), true).setVisible(true);
/*      */       }
/*      */     });
/*      */   }
/*      */   
/*      */   public int getDialogResult() {
/*  895 */     return this.dialogResult;
/*      */   }
/*      */   
/*      */   public void setDialogResult(int dialogResult) {
/*  899 */     this.dialogResult = dialogResult;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   public void setDatasources(List datasources)
/*      */   {
/*  907 */     this.jComboBoxDatasources.removeAllItems();
/*  908 */     for (int i = 0; i < datasources.size(); i++)
/*      */     {
/*  910 */       Object datasource = datasources.get(i);
/*  911 */       if ((datasource instanceof String))
/*      */       {
/*  913 */         this.jComboBoxDatasources.addItem(datasource);
/*      */       }
/*  915 */       else if ((datasource instanceof ResourceDescriptor))
/*      */       {
/*  917 */         this.jComboBoxDatasources.addItem(((ResourceDescriptor)datasource).getUriString());
/*      */       }
/*      */     }
/*      */     
/*  921 */     if (this.jComboBoxDatasources.getItemCount() > 0)
/*      */     {
/*  923 */       this.jComboBoxDatasources.setSelectedIndex(0);
/*      */     }
/*      */   }
/*      */   
/*      */   public JServer getServer() {
/*  928 */     return this.server;
/*      */   }
/*      */   
/*      */   public void setServer(JServer server) {
/*  932 */     this.server = server;
/*      */   }
/*      */   
/*      */   public String getParentFolder() {
/*  936 */     return this.parentFolder;
/*      */   }
/*      */   
/*      */   public void setParentFolder(String parentFolder) {
/*  940 */     this.parentFolder = parentFolder;
/*  941 */     this.jTextFieldUriString.setText(parentFolder);
/*      */   }
/*      */   
/*      */ 
/*      */   private JLabel jLabelResourceFile;
/*      */   
/*      */   private JLabel jLabelResourceType1;
/*      */   
/*      */   private JLabel jLabelUriString;
/*      */   
/*      */   private JPanel jPanel1;
/*      */   
/*      */   private JPanel jPanel10;
/*      */   
/*      */   private JPanel jPanel3;
/*      */   
/*      */   private JPanel jPanel6;
/*      */   
/*      */   private JPanel jPanel8;
/*      */   
/*      */   private JPanel jPanel9;
/*      */   
/*      */   private JPanel jPanelButtons;
/*      */   
/*      */   private JPanel jPanelCommon;
/*      */   
/*      */   private JPanel jPanelMainReport;
/*      */   
/*      */   private JPanel jPanelOther;
/*      */   
/*      */   private JRadioButton jRadioButtonLocal;
/*      */   
/*      */   private JRadioButton jRadioButtonLocal1;
/*      */   
/*      */   private JRadioButton jRadioButtonRepo;
/*      */   
/*      */   private JRadioButton jRadioButtonRepo1;
/*      */   
/*      */   private JScrollPane jScrollPane1;
/*      */   
/*      */   private JSeparator jSeparator1;
/*      */   
/*      */   private JSeparator jSeparator2;
/*      */   
/*      */   private JSeparator jSeparator4;
/*      */   
/*      */   private JSeparator jSeparator5;
/*      */   private JTabbedPane jTabbedPane1;
/*      */   private JTextField jTextFieldFile;
/*      */   private JTextField jTextFieldFileRepo;
/*      */   private JTextField jTextFieldInputControlRenderingView;
/*      */   private JTextField jTextFieldLabel;
/*      */   private JTextField jTextFieldName;
/*      */   private JTextField jTextFieldReportRenderingView;
/*      */   private JTextField jTextFieldUriString;
/*      */   public void updateResourceFromType()
/*      */   {
/*  998 */     this.jComboBoxDatasources.setEnabled(this.jRadioButtonRepo.isSelected());
/*  999 */     this.jButtonPickResource.setEnabled(this.jRadioButtonRepo.isSelected());
/*      */     
/* 1001 */     this.jButtonEditLocalDataSource.setEnabled(this.jRadioButtonLocal.isSelected());
/*      */   }
/*      */   
/*      */   public void updateJrxmlFromType()
/*      */   {
/* 1006 */     this.jTextFieldFileRepo.setEnabled(this.jRadioButtonRepo1.isSelected());
/* 1007 */     this.jButtonPickJrxml.setEnabled(this.jRadioButtonRepo1.isSelected());
/* 1008 */     this.jTextFieldFile.setEnabled(this.jRadioButtonLocal1.isSelected());
/* 1009 */     this.jButtonBrowse.setEnabled(this.jRadioButtonLocal1.isSelected());
/* 1010 */     this.jButtonGetCurrentReport.setEnabled(this.jRadioButtonLocal1.isSelected());
/*      */   }
/*      */   
/*      */   public ResourceDescriptor getNewResourceDescriptor() {
/* 1014 */     return this.newResourceDescriptor;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   public void setResource(RepositoryReportUnit resource)
/*      */   {
/* 1022 */     this.resource = resource;
/*      */     
/* 1024 */     if (resource != null)
/*      */     {
/* 1026 */       setResource(resource.getDescriptor());
/*      */     }
/* 1028 */     this.jTextFieldName.setEditable(false);
/* 1029 */     this.jTextFieldName.setOpaque(false);
/*      */     
/* 1031 */     this.jButtonSave.setText("Save Report Unit");
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   public void setResource(ResourceDescriptor descriptor)
/*      */   {
/* 1039 */     if (descriptor == null) return;
/* 1040 */     this.jTextFieldName.setText(descriptor.getName());
/* 1041 */     this.jTextFieldLabel.setText(descriptor.getLabel());
/* 1042 */     this.jEditorPaneDescription.setText(descriptor.getDescription());
/*      */     
/* 1044 */     if (descriptor.getResourcePropertyValue("PROP_RU_INPUTCONTROL_RENDERING_VIEW") != null) {
/* 1045 */       this.jTextFieldInputControlRenderingView.setText(descriptor.getResourcePropertyValue("PROP_RU_INPUTCONTROL_RENDERING_VIEW"));
/*      */     }
/* 1047 */     if (descriptor.getResourcePropertyValue("PROP_RU_REPORT_RENDERING_VIEW") != null) {
/* 1048 */       this.jTextFieldReportRenderingView.setText(descriptor.getResourcePropertyValue("PROP_RU_REPORT_RENDERING_VIEW"));
/*      */     }
/*      */     
/* 1051 */     for (int i = 0; i < descriptor.getChildren().size(); i++)
/*      */     {
/*      */ 
/* 1054 */       ResourceDescriptor rd = (ResourceDescriptor)descriptor.getChildren().get(i);
/* 1055 */       if (rd.getWsType().equals("datasource"))
/*      */       {
/* 1057 */         this.jComboBoxDatasources.setSelectedItem(rd.getReferenceUri());
/* 1058 */         this.jRadioButtonRepo.setSelected(true);
/* 1059 */         this.jRadioButtonLocal.setSelected(false);
/*      */       }
/* 1061 */       else if (RepositoryExplorer.isDataSource(rd))
/*      */       {
/* 1063 */         this.dataSourceDescriptor = rd;
/* 1064 */         this.jRadioButtonLocal.setSelected(true);
/* 1065 */         this.jRadioButtonRepo.setSelected(false);
/*      */       }
/* 1067 */       else if ((rd.getWsType().equals("jrxml")) && (rd.isMainReport()))
/*      */       {
/*      */ 
/* 1070 */         if (!rd.getUriString().startsWith(descriptor.getUriString()))
/*      */         {
/* 1072 */           this.jRadioButtonLocal1.setSelected(false);
/* 1073 */           this.jRadioButtonRepo1.setSelected(true);
/* 1074 */           this.jTextFieldFileRepo.setText(rd.getUriString());
/*      */         }
/*      */         else
/*      */         {
/* 1078 */           this.jRadioButtonLocal1.setSelected(true);
/* 1079 */           this.jRadioButtonRepo1.setSelected(false);
/*      */         }
/*      */       }
/*      */       
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/* 1087 */       updateResourceFromType();
/* 1088 */       updateJrxmlFromType();
/*      */     }
/*      */   }
/*      */   
/*      */   public RepositoryReportUnit getResource() {
/* 1093 */     return this.resource;
/*      */   }
/*      */   
/*      */   public boolean isControlsSupportActive() {
/* 1097 */     return this.controlsSupportActive;
/*      */   }
/*      */   
/*      */   public void setControlsSupportActive(boolean controlsSupportActive) {
/* 1101 */     this.controlsSupportActive = controlsSupportActive;
/*      */   }
/*      */   
/*      */   public boolean isResourcesSupportActive()
/*      */   {
/* 1106 */     return this.resourcesSupportActive;
/*      */   }
/*      */   
/*      */   public void setResourcesSupportActive(boolean resourcesSupportActive) {
/* 1110 */     this.resourcesSupportActive = resourcesSupportActive;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   public void validate(ResourceDescriptor dataType)
/*      */     throws Exception
/*      */   {
/* 1119 */     ValidationUtils.validateName(dataType.getName());
/* 1120 */     ValidationUtils.validateLabel(dataType.getLabel());
/* 1121 */     ValidationUtils.validateDesc(dataType.getDescription());
/*      */   }
/*      */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-ireport-plugin-2.0.1.jar!\com\jaspersoft\jasperserver\irplugin\gui\ReportUnitDialog.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */