/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.users.attributes;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.dto.authority.UserAttributesListWrapper;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.users.UsersAttributesParameter;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*    */ import javax.ws.rs.core.MultivaluedHashMap;
/*    */ import javax.ws.rs.core.MultivaluedMap;
/*    */ 
/*    */ 
/*    */ 
/*    */ public class BatchAttributeInterfaceAdapter
/*    */   extends AbstractAdapter
/*    */ {
/*    */   private final String uri;
/*    */   private MultivaluedMap<String, String> params;
/*    */   
/*    */   public BatchAttributeInterfaceAdapter(SessionStorage sessionStorage, String uri)
/*    */   {
/* 26 */     super(sessionStorage);
/* 27 */     this.uri = uri;
/* 28 */     this.params = new MultivaluedHashMap();
/*    */   }
/*    */   
/*    */   public BatchAttributeInterfaceAdapter param(UsersAttributesParameter usersAttributesParam, String value) {
/* 32 */     this.params.add(usersAttributesParam.getParamName(), value);
/* 33 */     return this;
/*    */   }
/*    */   
/*    */   public OperationResult<UserAttributesListWrapper> get() {
/* 37 */     JerseyRequest<UserAttributesListWrapper> request = buildRequest();
/* 38 */     request.addParams(this.params);
/* 39 */     return request.get();
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncGet(final Callback<OperationResult<UserAttributesListWrapper>, R> callback) {
/* 43 */     final JerseyRequest<UserAttributesListWrapper> request = buildRequest();
/* 44 */     request.addParams(this.params);
/* 45 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 48 */         callback.execute(request.get());
/*    */       }
/* 50 */     });
/* 51 */     ThreadPoolUtil.runAsynchronously(task);
/* 52 */     return task;
/*    */   }
/*    */   
/*    */   public OperationResult createOrUpdate(UserAttributesListWrapper attributesList) {
/* 56 */     return buildRequest().put(attributesList);
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncCreateOrUpdate(final UserAttributesListWrapper attributesList, final Callback<OperationResult<UserAttributesListWrapper>, R> callback) {
/* 60 */     final JerseyRequest<UserAttributesListWrapper> request = buildRequest();
/* 61 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 64 */         callback.execute(request.put(attributesList));
/*    */       }
/* 66 */     });
/* 67 */     ThreadPoolUtil.runAsynchronously(task);
/* 68 */     return task;
/*    */   }
/*    */   
/*    */   public OperationResult delete() {
/* 72 */     JerseyRequest<UserAttributesListWrapper> request = buildRequest();
/* 73 */     request.addParams(this.params);
/* 74 */     return request.delete();
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncDelete(final Callback<OperationResult<UserAttributesListWrapper>, R> callback) {
/* 78 */     final JerseyRequest<UserAttributesListWrapper> request = buildRequest();
/* 79 */     request.addParams(this.params);
/* 80 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 83 */         callback.execute(request.delete());
/*    */       }
/* 85 */     });
/* 86 */     ThreadPoolUtil.runAsynchronously(task);
/* 87 */     return task;
/*    */   }
/*    */   
/*    */   private JerseyRequest<UserAttributesListWrapper> buildRequest() {
/* 91 */     return JerseyRequest.buildRequest(this.sessionStorage, UserAttributesListWrapper.class, new String[] { this.uri, "/attributes" }, new DefaultErrorHandler());
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\authority\users\attributes\BatchAttributeInterfaceAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */