/*     */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.jobs;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.JRSVersion;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.MimeTypeUtil;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.RestClientConfiguration;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.Job;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.JobState;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SingleJobOperationsAdapter
/*     */   extends AbstractAdapter
/*     */ {
/*     */   private final String jobId;
/*     */   
/*     */   public SingleJobOperationsAdapter(SessionStorage sessionStorage, String jobId)
/*     */   {
/*  36 */     super(sessionStorage);
/*  37 */     this.jobId = jobId;
/*     */   }
/*     */   
/*     */   public OperationResult<Job> get() {
/*  41 */     JerseyRequest<Job> request = JerseyRequest.buildRequest(this.sessionStorage, Job.class, new String[] { "/jobs", this.jobId });
/*  42 */     if (this.sessionStorage.getConfiguration().getJrsVersion().compareTo(JRSVersion.v5_5_0) > 0) {
/*  43 */       request.setAccept(MimeTypeUtil.toCorrectAcceptMime(this.sessionStorage.getConfiguration(), "application/job+{mime}"));
/*     */     } else {
/*  45 */       request.setAccept("application/job+json");
/*     */     }
/*  47 */     return request.get();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncGet(final Callback<OperationResult<Job>, R> callback) {
/*  51 */     final JerseyRequest<Job> request = JerseyRequest.buildRequest(this.sessionStorage, Job.class, new String[] { "/jobs", this.jobId });
/*  52 */     if (this.sessionStorage.getConfiguration().getJrsVersion().compareTo(JRSVersion.v5_5_0) > 0) {
/*  53 */       request.setAccept(MimeTypeUtil.toCorrectAcceptMime(this.sessionStorage.getConfiguration(), "application/job+{mime}"));
/*     */     } else {
/*  55 */       request.setAccept("application/job+json");
/*     */     }
/*  57 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/*  60 */         callback.execute(request.get());
/*     */       }
/*  62 */     });
/*  63 */     ThreadPoolUtil.runAsynchronously(task);
/*  64 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult<JobState> state() {
/*  68 */     return JerseyRequest.buildRequest(this.sessionStorage, JobState.class, new String[] { "/jobs", this.jobId, "/state" }).get();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncState(final Callback<OperationResult<JobState>, R> callback) {
/*  72 */     final JerseyRequest<JobState> request = JerseyRequest.buildRequest(this.sessionStorage, JobState.class, new String[] { "/jobs", this.jobId, "/state" });
/*  73 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/*  76 */         callback.execute(request.get());
/*     */       }
/*  78 */     });
/*  79 */     ThreadPoolUtil.runAsynchronously(task);
/*  80 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult<Job> update(Job job) {
/*  84 */     JerseyRequest<Job> request = JerseyRequest.buildRequest(this.sessionStorage, Job.class, new String[] { "/jobs", this.jobId }, new JobValidationErrorHandler());
/*  85 */     if (this.sessionStorage.getConfiguration().getJrsVersion().compareTo(JRSVersion.v5_5_0) > 0) {
/*  86 */       request.setContentType(MimeTypeUtil.toCorrectContentMime(this.sessionStorage.getConfiguration(), "application/job+{mime}"));
/*  87 */       request.setAccept(MimeTypeUtil.toCorrectAcceptMime(this.sessionStorage.getConfiguration(), "application/job+{mime}"));
/*     */     } else {
/*  89 */       request.setContentType("application/job+json");
/*  90 */       request.setAccept("application/job+json");
/*     */     }
/*  92 */     return request.post(job);
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncUpdate(final Job job, final Callback<OperationResult<Job>, R> callback) {
/*  96 */     final JerseyRequest<Job> request = JerseyRequest.buildRequest(this.sessionStorage, Job.class, new String[] { "/jobs", this.jobId }, new JobValidationErrorHandler());
/*  97 */     if (this.sessionStorage.getConfiguration().getJrsVersion().compareTo(JRSVersion.v5_5_0) > 0) {
/*  98 */       request.setContentType(MimeTypeUtil.toCorrectContentMime(this.sessionStorage.getConfiguration(), "application/job+{mime}"));
/*  99 */       request.setAccept(MimeTypeUtil.toCorrectAcceptMime(this.sessionStorage.getConfiguration(), "application/job+{mime}"));
/*     */     } else {
/* 101 */       request.setContentType("application/job+json");
/* 102 */       request.setAccept("application/job+json");
/*     */     }
/* 104 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 107 */         callback.execute(request.post(job));
/*     */       }
/* 109 */     });
/* 110 */     ThreadPoolUtil.runAsynchronously(task);
/* 111 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult delete() {
/* 115 */     return JerseyRequest.buildRequest(this.sessionStorage, Object.class, new String[] { "/jobs", this.jobId }).delete();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncDelete(final Callback<OperationResult, R> callback) {
/* 119 */     final JerseyRequest request = JerseyRequest.buildRequest(this.sessionStorage, Object.class, new String[] { "/jobs", this.jobId });
/* 120 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 123 */         callback.execute(request.delete());
/*     */       }
/* 125 */     });
/* 126 */     ThreadPoolUtil.runAsynchronously(task);
/* 127 */     return task;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\jobs\SingleJobOperationsAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */