/*     */ package com.sun.xml.bind.v2.model.impl;
/*     */ 
/*     */ import com.sun.istack.FinalArrayList;
/*     */ import com.sun.xml.bind.v2.model.annotation.AnnotationReader;
/*     */ import com.sun.xml.bind.v2.model.core.ElementPropertyInfo;
/*     */ import com.sun.xml.bind.v2.model.core.ID;
/*     */ import com.sun.xml.bind.v2.model.core.NonElement;
/*     */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*     */ import com.sun.xml.bind.v2.model.core.TypeInfo;
/*     */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*     */ import com.sun.xml.bind.v2.runtime.IllegalAnnotationException;
/*     */ import java.util.AbstractList;
/*     */ import java.util.Collections;
/*     */ import java.util.List;
/*     */ import javax.xml.bind.annotation.XmlElement;
/*     */ import javax.xml.bind.annotation.XmlElement.DEFAULT;
/*     */ import javax.xml.bind.annotation.XmlElements;
/*     */ import javax.xml.bind.annotation.XmlList;
/*     */ import javax.xml.namespace.QName;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ class ElementPropertyInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>
/*     */   extends ERPropertyInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>
/*     */   implements ElementPropertyInfo<TypeT, ClassDeclT>
/*     */ {
/*     */   private List<TypeRefImpl<TypeT, ClassDeclT>> types;
/*  36 */   private final List<TypeInfo<TypeT, ClassDeclT>> ref = new AbstractList() {
/*     */     public TypeInfo<TypeT, ClassDeclT> get(int index) {
/*  38 */       return ((TypeRefImpl)ElementPropertyInfoImpl.this.getTypes().get(index)).getTarget();
/*     */     }
/*     */     
/*     */     public int size() {
/*  42 */       return ElementPropertyInfoImpl.this.getTypes().size();
/*     */     }
/*     */   };
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private Boolean isRequired;
/*     */   
/*     */ 
/*     */ 
/*     */   private final boolean isValueList;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   ElementPropertyInfoImpl(ClassInfoImpl<TypeT, ClassDeclT, FieldT, MethodT> parent, PropertySeed<TypeT, ClassDeclT, FieldT, MethodT> propertySeed)
/*     */   {
/*  60 */     super(parent, propertySeed);
/*     */     
/*  62 */     this.isValueList = this.seed.hasAnnotation(XmlList.class);
/*     */   }
/*     */   
/*     */   public List<? extends TypeRefImpl<TypeT, ClassDeclT>> getTypes()
/*     */   {
/*  67 */     if (this.types == null) {
/*  68 */       this.types = new FinalArrayList();
/*  69 */       XmlElement[] ann = null;
/*     */       
/*  71 */       XmlElement xe = (XmlElement)this.seed.readAnnotation(XmlElement.class);
/*  72 */       XmlElements xes = (XmlElements)this.seed.readAnnotation(XmlElements.class);
/*     */       
/*  74 */       if ((xe != null) && (xes != null)) {
/*  75 */         this.parent.builder.reportError(new IllegalAnnotationException(Messages.MUTUALLY_EXCLUSIVE_ANNOTATIONS.format(new Object[] { nav().getClassName(this.parent.getClazz()) + '#' + this.seed.getName(), xe.annotationType().getName(), xes.annotationType().getName() }), xe, xes));
/*     */       }
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  82 */       this.isRequired = Boolean.valueOf(true);
/*     */       
/*  84 */       if (xe != null) {
/*  85 */         ann = new XmlElement[] { xe };
/*     */       }
/*  87 */       else if (xes != null) {
/*  88 */         ann = xes.value();
/*     */       }
/*  90 */       if (ann == null)
/*     */       {
/*  92 */         TypeT t = getIndividualType();
/*  93 */         if ((!nav().isPrimitive(t)) || (isCollection())) {
/*  94 */           this.isRequired = Boolean.valueOf(false);
/*     */         }
/*  96 */         this.types.add(createTypeRef(calcXmlName((XmlElement)null), t, isCollection(), null));
/*     */       } else {
/*  98 */         for (XmlElement item : ann)
/*     */         {
/* 100 */           QName name = calcXmlName(item);
/* 101 */           TypeT type = reader().getClassValue(item, "type");
/* 102 */           if (type.equals(nav().ref(XmlElement.DEFAULT.class))) type = getIndividualType();
/* 103 */           if (((!nav().isPrimitive(type)) || (isCollection())) && (!item.required()))
/* 104 */             this.isRequired = Boolean.valueOf(false);
/* 105 */           this.types.add(createTypeRef(name, type, item.nillable(), getDefaultValue(item.defaultValue())));
/*     */         }
/*     */       }
/* 108 */       this.types = Collections.unmodifiableList(this.types);
/* 109 */       assert (!this.types.contains(null));
/*     */     }
/* 111 */     return this.types;
/*     */   }
/*     */   
/*     */   private String getDefaultValue(String value) {
/* 115 */     if (value.equals("\000")) {
/* 116 */       return null;
/*     */     }
/* 118 */     return value;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected TypeRefImpl<TypeT, ClassDeclT> createTypeRef(QName name, TypeT type, boolean isNillable, String defaultValue)
/*     */   {
/* 125 */     return new TypeRefImpl(this, name, type, isNillable, defaultValue);
/*     */   }
/*     */   
/*     */   public boolean isValueList() {
/* 129 */     return this.isValueList;
/*     */   }
/*     */   
/*     */   public boolean isRequired() {
/* 133 */     if (this.isRequired == null)
/* 134 */       getTypes();
/* 135 */     return this.isRequired.booleanValue();
/*     */   }
/*     */   
/*     */   public List<? extends TypeInfo<TypeT, ClassDeclT>> ref() {
/* 139 */     return this.ref;
/*     */   }
/*     */   
/*     */   public final PropertyKind kind() {
/* 143 */     return PropertyKind.ELEMENT;
/*     */   }
/*     */   
/*     */   protected void link() {
/* 147 */     super.link();
/* 148 */     for (TypeRefImpl<TypeT, ClassDeclT> ref : getTypes()) {
/* 149 */       ref.link();
/*     */     }
/*     */     
/* 152 */     if (isValueList())
/*     */     {
/*     */ 
/* 155 */       if (id() != ID.IDREF)
/*     */       {
/*     */ 
/*     */ 
/* 159 */         for (TypeRefImpl<TypeT, ClassDeclT> ref : this.types) {
/* 160 */           if (!ref.getTarget().isSimpleType()) {
/* 161 */             this.parent.builder.reportError(new IllegalAnnotationException(Messages.XMLLIST_NEEDS_SIMPLETYPE.format(new Object[] { nav().getTypeName(ref.getTarget().getType()) }), this));
/*     */             
/*     */ 
/* 164 */             break;
/*     */           }
/*     */         }
/*     */       }
/*     */       
/* 169 */       if (!isCollection()) {
/* 170 */         this.parent.builder.reportError(new IllegalAnnotationException(Messages.XMLLIST_ON_SINGLE_PROPERTY.format(new Object[0]), this));
/*     */       }
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\impl\ElementPropertyInfoImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */