/*     */ package com.sun.xml.bind.v2.model.impl;
/*     */ 
/*     */ import com.sun.xml.bind.v2.model.annotation.AnnotationReader;
/*     */ import com.sun.xml.bind.v2.model.core.ClassInfo;
/*     */ import com.sun.xml.bind.v2.model.core.Element;
/*     */ import com.sun.xml.bind.v2.model.core.ElementInfo;
/*     */ import com.sun.xml.bind.v2.model.core.NonElement;
/*     */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*     */ import com.sun.xml.bind.v2.model.core.ReferencePropertyInfo;
/*     */ import com.sun.xml.bind.v2.model.core.WildcardMode;
/*     */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*     */ import com.sun.xml.bind.v2.runtime.IllegalAnnotationException;
/*     */ import java.util.Collections;
/*     */ import java.util.LinkedHashSet;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ import javax.xml.bind.JAXBElement;
/*     */ import javax.xml.bind.annotation.XmlAnyElement;
/*     */ import javax.xml.bind.annotation.XmlElementRef;
/*     */ import javax.xml.bind.annotation.XmlElementRef.DEFAULT;
/*     */ import javax.xml.bind.annotation.XmlElementRefs;
/*     */ import javax.xml.bind.annotation.XmlMixed;
/*     */ import javax.xml.namespace.QName;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ class ReferencePropertyInfoImpl<T, C, F, M>
/*     */   extends ERPropertyInfoImpl<T, C, F, M>
/*     */   implements ReferencePropertyInfo<T, C>
/*     */ {
/*     */   private Set<Element<T, C>> types;
/*     */   private final boolean isMixed;
/*     */   private final WildcardMode wildcard;
/*     */   private final C domHandler;
/*     */   
/*     */   public ReferencePropertyInfoImpl(ClassInfoImpl<T, C, F, M> classInfo, PropertySeed<T, C, F, M> seed)
/*     */   {
/*  50 */     super(classInfo, seed);
/*     */     
/*  52 */     this.isMixed = (seed.readAnnotation(XmlMixed.class) != null);
/*     */     
/*  54 */     XmlAnyElement xae = (XmlAnyElement)seed.readAnnotation(XmlAnyElement.class);
/*  55 */     if (xae == null) {
/*  56 */       this.wildcard = null;
/*  57 */       this.domHandler = null;
/*     */     } else {
/*  59 */       this.wildcard = (xae.lax() ? WildcardMode.LAX : WildcardMode.SKIP);
/*  60 */       this.domHandler = nav().asDecl(reader().getClassValue(xae, "value"));
/*     */     }
/*     */   }
/*     */   
/*     */   public Set<? extends Element<T, C>> ref() {
/*  65 */     return getElements();
/*     */   }
/*     */   
/*     */   public PropertyKind kind() {
/*  69 */     return PropertyKind.REFERENCE;
/*     */   }
/*     */   
/*     */   public Set<? extends Element<T, C>> getElements() {
/*  73 */     if (this.types == null)
/*  74 */       calcTypes(false);
/*  75 */     assert (this.types != null);
/*  76 */     return this.types;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void calcTypes(boolean last)
/*     */   {
/*  87 */     this.types = new LinkedHashSet();
/*  88 */     XmlElementRefs refs = (XmlElementRefs)this.seed.readAnnotation(XmlElementRefs.class);
/*  89 */     XmlElementRef ref = (XmlElementRef)this.seed.readAnnotation(XmlElementRef.class);
/*     */     
/*  91 */     if ((refs != null) && (ref != null)) {
/*  92 */       this.parent.builder.reportError(new IllegalAnnotationException(Messages.MUTUALLY_EXCLUSIVE_ANNOTATIONS.format(new Object[] { nav().getClassName(this.parent.getClazz()) + '#' + this.seed.getName(), ref.annotationType().getName(), refs.annotationType().getName() }), ref, refs));
/*     */     }
/*     */     
/*     */     XmlElementRef[] ann;
/*     */     
/*     */     XmlElementRef[] ann;
/*     */     
/*  99 */     if (refs != null) {
/* 100 */       ann = refs.value();
/*     */     } else { XmlElementRef[] ann;
/* 102 */       if (ref != null) {
/* 103 */         ann = new XmlElementRef[] { ref };
/*     */       } else {
/* 105 */         ann = null;
/*     */       }
/*     */     }
/* 108 */     if (ann != null) {
/* 109 */       Navigator<T, C, F, M> nav = nav();
/* 110 */       AnnotationReader<T, C, F, M> reader = reader();
/*     */       
/* 112 */       T defaultType = nav.ref(XmlElementRef.DEFAULT.class);
/* 113 */       C je = nav.asDecl(JAXBElement.class);
/*     */       
/* 115 */       for (XmlElementRef r : ann)
/*     */       {
/* 117 */         T type = reader.getClassValue(r, "type");
/* 118 */         if (type.equals(defaultType)) type = nav.erasure(getIndividualType());
/* 119 */         boolean yield; boolean yield; if (nav.getBaseClass(type, je) != null) {
/* 120 */           yield = addGenericElement(r);
/*     */         } else {
/* 122 */           yield = addAllSubtypes(type);
/*     */         }
/* 124 */         if ((last) && (!yield))
/*     */         {
/*     */ 
/* 127 */           if (type.equals(nav.ref(JAXBElement.class)))
/*     */           {
/* 129 */             this.parent.builder.reportError(new IllegalAnnotationException(Messages.NO_XML_ELEMENT_DECL.format(new Object[] { getEffectiveNamespaceFor(r), r.name() }), this));
/*     */ 
/*     */           }
/*     */           else
/*     */           {
/*     */ 
/* 135 */             this.parent.builder.reportError(new IllegalAnnotationException(Messages.INVALID_XML_ELEMENT_REF.format(new Object[0]), this));
/*     */           }
/*     */           
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 143 */           return;
/*     */         }
/*     */       }
/*     */     }
/*     */     
/* 148 */     this.types = Collections.unmodifiableSet(this.types);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private boolean addGenericElement(XmlElementRef r)
/*     */   {
/* 156 */     String nsUri = getEffectiveNamespaceFor(r);
/*     */     
/* 158 */     return addGenericElement(this.parent.owner.getElementInfo(this.parent.getClazz(), new QName(nsUri, r.name())));
/*     */   }
/*     */   
/*     */   private String getEffectiveNamespaceFor(XmlElementRef r) {
/* 162 */     String nsUri = r.namespace();
/* 163 */     if (nsUri.length() == 0)
/* 164 */       nsUri = this.parent.builder.defaultNsUri;
/* 165 */     return nsUri;
/*     */   }
/*     */   
/*     */   private boolean addGenericElement(ElementInfo<T, C> ei) {
/* 169 */     if (ei == null)
/* 170 */       return false;
/* 171 */     this.types.add(ei);
/* 172 */     for (ElementInfo<T, C> subst : ei.getSubstitutionMembers())
/* 173 */       addGenericElement(subst);
/* 174 */     return true;
/*     */   }
/*     */   
/*     */   private boolean addAllSubtypes(T type) {
/* 178 */     Navigator<T, C, F, M> nav = nav();
/*     */     
/*     */ 
/* 181 */     NonElement<T, C> t = this.parent.builder.getClassInfo(nav.asDecl(type), this);
/* 182 */     if (!(t instanceof ClassInfo))
/*     */     {
/* 184 */       return false;
/*     */     }
/* 186 */     boolean result = false;
/*     */     
/* 188 */     ClassInfo<T, C> c = (ClassInfo)t;
/* 189 */     if (c.isElement()) {
/* 190 */       this.types.add(c.asElement());
/* 191 */       result = true;
/*     */     }
/*     */     
/*     */ 
/* 195 */     for (ClassInfo<T, C> ci : this.parent.owner.beans().values()) {
/* 196 */       if ((ci.isElement()) && (nav.isSubClassOf(ci.getType(), type))) {
/* 197 */         this.types.add(ci.asElement());
/* 198 */         result = true;
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 203 */     for (ElementInfo<T, C> ei : this.parent.owner.getElementMappings(null).values()) {
/* 204 */       if (nav.isSubClassOf(ei.getType(), type)) {
/* 205 */         this.types.add(ei);
/* 206 */         result = true;
/*     */       }
/*     */     }
/*     */     
/* 210 */     return result;
/*     */   }
/*     */   
/*     */   protected void link()
/*     */   {
/* 215 */     super.link();
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 220 */     calcTypes(true);
/*     */   }
/*     */   
/*     */ 
/*     */   public final boolean isMixed()
/*     */   {
/* 226 */     return this.isMixed;
/*     */   }
/*     */   
/*     */   public final WildcardMode getWildcard() {
/* 230 */     return this.wildcard;
/*     */   }
/*     */   
/*     */   public final C getDOMHandler() {
/* 234 */     return (C)this.domHandler;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\impl\ReferencePropertyInfoImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */