/*     */ package com.sun.xml.bind.v2.model.nav;
/*     */ 
/*     */ import java.lang.reflect.MalformedParameterizedTypeException;
/*     */ import java.lang.reflect.ParameterizedType;
/*     */ import java.lang.reflect.Type;
/*     */ import java.lang.reflect.TypeVariable;
/*     */ import java.util.Arrays;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ class ParameterizedTypeImpl
/*     */   implements ParameterizedType
/*     */ {
/*     */   private Type[] actualTypeArguments;
/*     */   private Class<?> rawType;
/*     */   private Type ownerType;
/*     */   
/*     */   ParameterizedTypeImpl(Class<?> rawType, Type[] actualTypeArguments, Type ownerType)
/*     */   {
/*  21 */     this.actualTypeArguments = actualTypeArguments;
/*  22 */     this.rawType = rawType;
/*  23 */     if (ownerType != null) {
/*  24 */       this.ownerType = ownerType;
/*     */     } else {
/*  26 */       this.ownerType = rawType.getDeclaringClass();
/*     */     }
/*  28 */     validateConstructorArguments();
/*     */   }
/*     */   
/*     */   private void validateConstructorArguments() {
/*  32 */     TypeVariable[] formals = this.rawType.getTypeParameters();
/*     */     
/*  34 */     if (formals.length != this.actualTypeArguments.length) {
/*  35 */       throw new MalformedParameterizedTypeException();
/*     */     }
/*  37 */     for (int i = 0; i < this.actualTypeArguments.length; i++) {}
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public Type[] getActualTypeArguments()
/*     */   {
/*  44 */     return (Type[])this.actualTypeArguments.clone();
/*     */   }
/*     */   
/*     */   public Class<?> getRawType() {
/*  48 */     return this.rawType;
/*     */   }
/*     */   
/*     */   public Type getOwnerType() {
/*  52 */     return this.ownerType;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean equals(Object o)
/*     */   {
/*  64 */     if ((o instanceof ParameterizedType))
/*     */     {
/*  66 */       ParameterizedType that = (ParameterizedType)o;
/*     */       
/*  68 */       if (this == that) {
/*  69 */         return true;
/*     */       }
/*  71 */       Type thatOwner = that.getOwnerType();
/*  72 */       Type thatRawType = that.getRawType();
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  94 */       return (this.ownerType == null ? thatOwner == null : this.ownerType.equals(thatOwner)) && (this.rawType == null ? thatRawType == null : this.rawType.equals(thatRawType)) && (Arrays.equals(this.actualTypeArguments, that.getActualTypeArguments()));
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 104 */     return false;
/*     */   }
/*     */   
/*     */   public int hashCode()
/*     */   {
/* 109 */     return Arrays.hashCode(this.actualTypeArguments) ^ (this.ownerType == null ? 0 : this.ownerType.hashCode()) ^ (this.rawType == null ? 0 : this.rawType.hashCode());
/*     */   }
/*     */   
/*     */ 
/*     */   public String toString()
/*     */   {
/* 115 */     StringBuilder sb = new StringBuilder();
/*     */     
/* 117 */     if (this.ownerType != null) {
/* 118 */       if ((this.ownerType instanceof Class)) {
/* 119 */         sb.append(((Class)this.ownerType).getName());
/*     */       } else {
/* 121 */         sb.append(this.ownerType.toString());
/*     */       }
/* 123 */       sb.append(".");
/*     */       
/* 125 */       if ((this.ownerType instanceof ParameterizedTypeImpl))
/*     */       {
/*     */ 
/* 128 */         sb.append(this.rawType.getName().replace(((ParameterizedTypeImpl)this.ownerType).rawType.getName() + "$", ""));
/*     */       }
/*     */       else
/* 131 */         sb.append(this.rawType.getName());
/*     */     } else {
/* 133 */       sb.append(this.rawType.getName());
/*     */     }
/* 135 */     if ((this.actualTypeArguments != null) && (this.actualTypeArguments.length > 0))
/*     */     {
/* 137 */       sb.append("<");
/* 138 */       boolean first = true;
/* 139 */       for (Type t : this.actualTypeArguments) {
/* 140 */         if (!first)
/* 141 */           sb.append(", ");
/* 142 */         if ((t instanceof Class)) {
/* 143 */           sb.append(((Class)t).getName());
/*     */         } else
/* 145 */           sb.append(t.toString());
/* 146 */         first = false;
/*     */       }
/* 148 */       sb.append(">");
/*     */     }
/*     */     
/* 151 */     return sb.toString();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\nav\ParameterizedTypeImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */