/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import com.sun.istack.NotNull;
/*     */ import com.sun.xml.bind.api.TypeReference;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallerImpl;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext;
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.io.OutputStream;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import javax.xml.bind.MarshalException;
/*     */ import javax.xml.bind.Marshaller;
/*     */ import javax.xml.bind.UnmarshalException;
/*     */ import javax.xml.bind.Unmarshaller;
/*     */ import javax.xml.bind.annotation.adapters.XmlAdapter;
/*     */ import javax.xml.namespace.NamespaceContext;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.stream.XMLStreamReader;
/*     */ import javax.xml.stream.XMLStreamWriter;
/*     */ import javax.xml.transform.Result;
/*     */ import javax.xml.transform.Source;
/*     */ import org.w3c.dom.Node;
/*     */ import org.xml.sax.ContentHandler;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class BridgeAdapter<OnWire, InMemory>
/*     */   extends InternalBridge<InMemory>
/*     */ {
/*     */   private final InternalBridge<OnWire> core;
/*     */   private final Class<? extends XmlAdapter<OnWire, InMemory>> adapter;
/*     */   
/*     */   public BridgeAdapter(InternalBridge<OnWire> core, Class<? extends XmlAdapter<OnWire, InMemory>> adapter)
/*     */   {
/*  39 */     super(core.getContext());
/*  40 */     this.core = core;
/*  41 */     this.adapter = adapter;
/*     */   }
/*     */   
/*     */   public void marshal(Marshaller m, InMemory inMemory, XMLStreamWriter output) throws JAXBException {
/*  45 */     this.core.marshal(m, adaptM(m, inMemory), output);
/*     */   }
/*     */   
/*     */   public void marshal(Marshaller m, InMemory inMemory, OutputStream output, NamespaceContext nsc) throws JAXBException {
/*  49 */     this.core.marshal(m, adaptM(m, inMemory), output, nsc);
/*     */   }
/*     */   
/*     */   public void marshal(Marshaller m, InMemory inMemory, Node output) throws JAXBException {
/*  53 */     this.core.marshal(m, adaptM(m, inMemory), output);
/*     */   }
/*     */   
/*     */   public void marshal(Marshaller context, InMemory inMemory, ContentHandler contentHandler) throws JAXBException {
/*  57 */     this.core.marshal(context, adaptM(context, inMemory), contentHandler);
/*     */   }
/*     */   
/*     */   public void marshal(Marshaller context, InMemory inMemory, Result result) throws JAXBException {
/*  61 */     this.core.marshal(context, adaptM(context, inMemory), result);
/*     */   }
/*     */   
/*     */   private OnWire adaptM(Marshaller m, InMemory v) throws JAXBException {
/*  65 */     XMLSerializer serializer = ((MarshallerImpl)m).serializer;
/*  66 */     serializer.setThreadAffinity();
/*  67 */     serializer.pushCoordinator();
/*     */     try {
/*  69 */       return (OnWire)_adaptM(serializer, v);
/*     */     } finally {
/*  71 */       serializer.popCoordinator();
/*  72 */       serializer.resetThreadAffinity();
/*     */     }
/*     */   }
/*     */   
/*     */   private OnWire _adaptM(XMLSerializer serializer, InMemory v) throws MarshalException {
/*  77 */     XmlAdapter<OnWire, InMemory> a = serializer.getAdapter(this.adapter);
/*     */     try {
/*  79 */       return (OnWire)a.marshal(v);
/*     */     } catch (Exception e) {
/*  81 */       serializer.handleError(e, v, null);
/*  82 */       throw new MarshalException(e);
/*     */     }
/*     */   }
/*     */   
/*     */   @NotNull
/*     */   public InMemory unmarshal(Unmarshaller u, XMLStreamReader in) throws JAXBException {
/*  88 */     return (InMemory)adaptU(u, this.core.unmarshal(u, in));
/*     */   }
/*     */   
/*     */   @NotNull
/*  92 */   public InMemory unmarshal(Unmarshaller u, Source in) throws JAXBException { return (InMemory)adaptU(u, this.core.unmarshal(u, in)); }
/*     */   
/*     */   @NotNull
/*     */   public InMemory unmarshal(Unmarshaller u, InputStream in) throws JAXBException {
/*  96 */     return (InMemory)adaptU(u, this.core.unmarshal(u, in));
/*     */   }
/*     */   
/*     */   @NotNull
/* 100 */   public InMemory unmarshal(Unmarshaller u, Node n) throws JAXBException { return (InMemory)adaptU(u, this.core.unmarshal(u, n)); }
/*     */   
/*     */ 
/*     */ 
/* 104 */   public TypeReference getTypeReference() { return this.core.getTypeReference(); }
/*     */   
/*     */   @NotNull
/*     */   private InMemory adaptU(Unmarshaller _u, OnWire v) throws JAXBException {
/* 108 */     UnmarshallerImpl u = (UnmarshallerImpl)_u;
/* 109 */     XmlAdapter<OnWire, InMemory> a = u.coordinator.getAdapter(this.adapter);
/* 110 */     u.coordinator.setThreadAffinity();
/* 111 */     u.coordinator.pushCoordinator();
/*     */     try {
/* 113 */       return (InMemory)a.unmarshal(v);
/*     */     } catch (Exception e) {
/* 115 */       throw new UnmarshalException(e);
/*     */     } finally {
/* 117 */       u.coordinator.popCoordinator();
/* 118 */       u.coordinator.resetThreadAffinity();
/*     */     }
/*     */   }
/*     */   
/*     */   void marshal(InMemory o, XMLSerializer out) throws IOException, SAXException, XMLStreamException {
/*     */     try {
/* 124 */       this.core.marshal(_adaptM(XMLSerializer.getInstance(), o), out);
/*     */     }
/*     */     catch (MarshalException e) {}
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\BridgeAdapter.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */