/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import com.sun.xml.bind.api.AccessorException;
/*     */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*     */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*     */ import com.sun.xml.bind.v2.model.nav.ReflectionNavigator;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeClassInfo;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeElementInfo;
/*     */ import com.sun.xml.bind.v2.runtime.property.Property;
/*     */ import com.sun.xml.bind.v2.runtime.property.PropertyFactory;
/*     */ import com.sun.xml.bind.v2.runtime.property.UnmarshallerChain;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.ChildLoader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Discarder;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Intercepter;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Loader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.TagName;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext.State;
/*     */ import com.sun.xml.bind.v2.util.QNameMap;
/*     */ import com.sun.xml.bind.v2.util.QNameMap.Entry;
/*     */ import java.io.IOException;
/*     */ import java.lang.reflect.Type;
/*     */ import javax.xml.bind.JAXBElement;
/*     */ import javax.xml.bind.JAXBElement.GlobalScope;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class ElementBeanInfoImpl
/*     */   extends JaxBeanInfo<JAXBElement>
/*     */ {
/*     */   private Loader loader;
/*     */   private final Property property;
/*     */   private final QName tagName;
/*     */   public final Class expectedType;
/*     */   private final Class scope;
/*     */   
/*     */   ElementBeanInfoImpl(JAXBContextImpl grammar, RuntimeElementInfo rei)
/*     */   {
/*  45 */     super(grammar, rei, rei.getType(), true, false, true);
/*     */     
/*  47 */     this.property = PropertyFactory.create(grammar, rei.getProperty());
/*     */     
/*  49 */     this.tagName = rei.getElementName();
/*  50 */     this.expectedType = Navigator.REFLECTION.erasure((Type)rei.getContentInMemoryType());
/*  51 */     this.scope = (rei.getScope() == null ? JAXBElement.GlobalScope.class : (Class)rei.getScope().getClazz());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected ElementBeanInfoImpl(final JAXBContextImpl grammar)
/*     */   {
/*  63 */     super(grammar, null, JAXBElement.class, true, false, true);
/*  64 */     this.tagName = null;
/*  65 */     this.expectedType = null;
/*  66 */     this.scope = null;
/*     */     
/*  68 */     this.property = new Property() {
/*     */       public void reset(JAXBElement o) {
/*  70 */         throw new UnsupportedOperationException();
/*     */       }
/*     */       
/*     */       public void serializeBody(JAXBElement e, XMLSerializer target, Object outerPeer) throws SAXException, IOException, XMLStreamException {
/*  74 */         Class scope = e.getScope();
/*  75 */         if (e.isGlobalScope()) scope = null;
/*  76 */         QName n = e.getName();
/*  77 */         ElementBeanInfoImpl bi = grammar.getElement(scope, n);
/*  78 */         if (bi == null)
/*     */         {
/*     */           JaxBeanInfo tbi;
/*     */           try {
/*  82 */             tbi = grammar.getBeanInfo(e.getDeclaredType(), true);
/*     */           }
/*     */           catch (JAXBException x) {
/*  85 */             target.reportError(null, x);
/*  86 */             return;
/*     */           }
/*  88 */           Object value = e.getValue();
/*  89 */           target.startElement(n.getNamespaceURI(), n.getLocalPart(), n.getPrefix(), null);
/*  90 */           if (value == null) {
/*  91 */             target.writeXsiNilTrue();
/*     */           } else {
/*  93 */             target.childAsXsiType(value, "value", tbi);
/*     */           }
/*  95 */           target.endElement();
/*     */         } else {
/*     */           try {
/*  98 */             bi.property.serializeBody(e, target, e);
/*     */           } catch (AccessorException x) {
/* 100 */             target.reportError(null, x);
/*     */           }
/*     */         }
/*     */       }
/*     */       
/*     */       public void serializeURIs(JAXBElement o, XMLSerializer target) {}
/*     */       
/*     */       public boolean hasSerializeURIAction()
/*     */       {
/* 109 */         return false;
/*     */       }
/*     */       
/*     */       public String getIdValue(JAXBElement o) {
/* 113 */         return null;
/*     */       }
/*     */       
/*     */       public PropertyKind getKind() {
/* 117 */         return PropertyKind.ELEMENT;
/*     */       }
/*     */       
/*     */       public void buildChildElementUnmarshallers(UnmarshallerChain chain, QNameMap<ChildLoader> handlers) {}
/*     */       
/*     */       public Accessor getElementPropertyAccessor(String nsUri, String localName)
/*     */       {
/* 124 */         throw new UnsupportedOperationException();
/*     */       }
/*     */       
/*     */ 
/*     */       public void wrapUp() {}
/*     */     };
/*     */   }
/*     */   
/*     */ 
/*     */   private final class IntercepterLoader
/*     */     extends Loader
/*     */     implements Intercepter
/*     */   {
/*     */     private final Loader core;
/*     */     
/*     */ 
/*     */     public IntercepterLoader(Loader core)
/*     */     {
/* 142 */       this.core = core;
/*     */     }
/*     */     
/*     */     public final void startElement(UnmarshallingContext.State state, TagName ea) throws SAXException {
/* 146 */       state.loader = this.core;
/* 147 */       state.intercepter = this;
/*     */       
/*     */ 
/*     */ 
/*     */ 
/* 152 */       UnmarshallingContext context = state.getContext();
/*     */       
/*     */ 
/* 155 */       Object child = context.getOuterPeer();
/*     */       
/* 157 */       if ((child != null) && (ElementBeanInfoImpl.this.jaxbType != child.getClass())) {
/* 158 */         child = null;
/*     */       }
/* 160 */       if (child != null) {
/* 161 */         ElementBeanInfoImpl.this.reset((JAXBElement)child, context);
/*     */       }
/* 163 */       if (child == null) {
/* 164 */         child = context.createInstance(ElementBeanInfoImpl.this);
/*     */       }
/* 166 */       fireBeforeUnmarshal(ElementBeanInfoImpl.this, child, state);
/*     */       
/* 168 */       context.recordOuterPeer(child);
/* 169 */       UnmarshallingContext.State p = state.prev;
/* 170 */       p.backup = p.target;
/* 171 */       p.target = child;
/*     */       
/* 173 */       this.core.startElement(state, ea);
/*     */     }
/*     */     
/*     */     public Object intercept(UnmarshallingContext.State state, Object o) throws SAXException {
/* 177 */       JAXBElement e = (JAXBElement)state.target;
/* 178 */       state.target = state.backup;
/* 179 */       state.backup = null;
/*     */       
/* 181 */       if (o != null)
/*     */       {
/*     */ 
/* 184 */         e.setValue(o);
/*     */       }
/* 186 */       fireAfterUnmarshal(ElementBeanInfoImpl.this, e, state);
/*     */       
/* 188 */       return e;
/*     */     }
/*     */   }
/*     */   
/*     */   public String getElementNamespaceURI(JAXBElement e) {
/* 193 */     return e.getName().getNamespaceURI();
/*     */   }
/*     */   
/*     */   public String getElementLocalName(JAXBElement e) {
/* 197 */     return e.getName().getLocalPart();
/*     */   }
/*     */   
/*     */   public Loader getLoader(JAXBContextImpl context, boolean typeSubstitutionCapable) {
/* 201 */     if (this.loader == null)
/*     */     {
/* 203 */       UnmarshallerChain c = new UnmarshallerChain(context);
/* 204 */       QNameMap<ChildLoader> result = new QNameMap();
/* 205 */       this.property.buildChildElementUnmarshallers(c, result);
/* 206 */       if (result.size() == 1)
/*     */       {
/* 208 */         this.loader = new IntercepterLoader(((ChildLoader)result.getOne().getValue()).loader);
/*     */       }
/*     */       else
/* 211 */         this.loader = Discarder.INSTANCE;
/*     */     }
/* 213 */     return this.loader;
/*     */   }
/*     */   
/*     */   public final JAXBElement createInstance(UnmarshallingContext context) {
/* 217 */     return createInstanceFromValue(null);
/*     */   }
/*     */   
/*     */   public final JAXBElement createInstanceFromValue(Object o) {
/* 221 */     return new JAXBElement(this.tagName, this.expectedType, this.scope, o);
/*     */   }
/*     */   
/*     */   public boolean reset(JAXBElement e, UnmarshallingContext context) {
/* 225 */     e.setValue(null);
/* 226 */     return true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getId(JAXBElement e, XMLSerializer target)
/*     */   {
/* 235 */     Object o = e.getValue();
/* 236 */     if ((o instanceof String)) {
/* 237 */       return (String)o;
/*     */     }
/* 239 */     return null;
/*     */   }
/*     */   
/*     */   public void serializeBody(JAXBElement element, XMLSerializer target) throws SAXException, IOException, XMLStreamException {
/*     */     try {
/* 244 */       this.property.serializeBody(element, target, null);
/*     */     } catch (AccessorException x) {
/* 246 */       target.reportError(null, x);
/*     */     }
/*     */   }
/*     */   
/*     */   public void serializeRoot(JAXBElement e, XMLSerializer target) throws SAXException, IOException, XMLStreamException {
/* 251 */     serializeBody(e, target);
/*     */   }
/*     */   
/*     */ 
/*     */   public void serializeAttributes(JAXBElement e, XMLSerializer target) {}
/*     */   
/*     */ 
/*     */   public void serializeURIs(JAXBElement e, XMLSerializer target) {}
/*     */   
/*     */ 
/*     */   public final Transducer<JAXBElement> getTransducer()
/*     */   {
/* 263 */     return null;
/*     */   }
/*     */   
/*     */   public void wrapUp() {
/* 267 */     super.wrapUp();
/* 268 */     this.property.wrapUp();
/*     */   }
/*     */   
/*     */   public void link(JAXBContextImpl grammar) {
/* 272 */     super.link(grammar);
/* 273 */     getLoader(grammar, true);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\ElementBeanInfoImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */