/*     */ package com.sun.xml.bind.v2.runtime.output;
/*     */ 
/*     */ import com.sun.xml.bind.v2.runtime.Name;
/*     */ import java.io.IOException;
/*     */ import java.io.OutputStream;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class IndentingUTF8XmlOutput
/*     */   extends UTF8XmlOutput
/*     */ {
/*     */   private final Encoded indent8;
/*     */   private final int unitLen;
/*  36 */   private int depth = 0;
/*     */   
/*  38 */   private boolean seenText = false;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public IndentingUTF8XmlOutput(OutputStream out, String indentStr, Encoded[] localNames)
/*     */   {
/*  47 */     super(out, localNames);
/*     */     
/*  49 */     if (indentStr != null) {
/*  50 */       Encoded e = new Encoded(indentStr);
/*  51 */       this.indent8 = new Encoded();
/*  52 */       this.indent8.ensureSize(e.len * 8);
/*  53 */       this.unitLen = e.len;
/*  54 */       for (int i = 0; i < 8; i++)
/*  55 */         System.arraycopy(e.buf, 0, this.indent8.buf, this.unitLen * i, this.unitLen);
/*     */     } else {
/*  57 */       this.indent8 = null;
/*  58 */       this.unitLen = 0;
/*     */     }
/*     */   }
/*     */   
/*     */   public void beginStartTag(int prefix, String localName) throws IOException
/*     */   {
/*  64 */     indentStartTag();
/*  65 */     super.beginStartTag(prefix, localName);
/*     */   }
/*     */   
/*     */   public void beginStartTag(Name name) throws IOException
/*     */   {
/*  70 */     indentStartTag();
/*  71 */     super.beginStartTag(name);
/*     */   }
/*     */   
/*     */   private void indentStartTag() throws IOException {
/*  75 */     closeStartTag();
/*  76 */     if (!this.seenText)
/*  77 */       printIndent();
/*  78 */     this.depth += 1;
/*  79 */     this.seenText = false;
/*     */   }
/*     */   
/*     */   public void endTag(Name name) throws IOException
/*     */   {
/*  84 */     indentEndTag();
/*  85 */     super.endTag(name);
/*     */   }
/*     */   
/*     */   public void endTag(int prefix, String localName) throws IOException
/*     */   {
/*  90 */     indentEndTag();
/*  91 */     super.endTag(prefix, localName);
/*     */   }
/*     */   
/*     */   private void indentEndTag() throws IOException {
/*  95 */     this.depth -= 1;
/*  96 */     if ((!this.closeStartTagPending) && (!this.seenText))
/*  97 */       printIndent();
/*  98 */     this.seenText = false;
/*     */   }
/*     */   
/*     */   private void printIndent() throws IOException {
/* 102 */     write(10);
/* 103 */     int i = this.depth % 8;
/*     */     
/* 105 */     write(this.indent8.buf, 0, i * this.unitLen);
/*     */     
/* 107 */     i >>= 3;
/* 109 */     for (; 
/* 109 */         i > 0; i--) {
/* 110 */       this.indent8.write(this);
/*     */     }
/*     */   }
/*     */   
/*     */   public void text(String value, boolean needSP) throws IOException {
/* 115 */     this.seenText = true;
/* 116 */     super.text(value, needSP);
/*     */   }
/*     */   
/*     */   public void text(Pcdata value, boolean needSP) throws IOException
/*     */   {
/* 121 */     this.seenText = true;
/* 122 */     super.text(value, needSP);
/*     */   }
/*     */   
/*     */   public void endDocument(boolean fragment) throws IOException, SAXException, XMLStreamException
/*     */   {
/* 127 */     write(10);
/* 128 */     super.endDocument(fragment);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\output\IndentingUTF8XmlOutput.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */