/*     */ package com.sun.xml.bind.v2.runtime.output;
/*     */ 
/*     */ import com.sun.xml.bind.util.AttributesImpl;
/*     */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*     */ import java.io.IOException;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.ContentHandler;
/*     */ import org.xml.sax.SAXException;
/*     */ import org.xml.sax.helpers.LocatorImpl;
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SAXOutput
/*     */   extends XmlOutputAbstractImpl
/*     */ {
/*     */   protected final ContentHandler out;
/*     */   private String elementNsUri;
/*     */   private String elementLocalName;
/*     */   private String elementQName;
/*     */   
/*     */   public SAXOutput(ContentHandler out)
/*     */   {
/*  23 */     this.out = out;
/*  24 */     out.setDocumentLocator(new LocatorImpl());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*  29 */   private char[] buf = new char['Ā'];
/*     */   
/*  31 */   private final AttributesImpl atts = new AttributesImpl();
/*     */   
/*     */ 
/*     */   public void startDocument(XMLSerializer serializer, boolean fragment, int[] nsUriIndex2prefixIndex, NamespaceContextImpl nsContext)
/*     */     throws SAXException, IOException, XMLStreamException
/*     */   {
/*  37 */     super.startDocument(serializer, fragment, nsUriIndex2prefixIndex, nsContext);
/*  38 */     if (!fragment)
/*  39 */       this.out.startDocument();
/*     */   }
/*     */   
/*     */   public void endDocument(boolean fragment) throws SAXException, IOException, XMLStreamException {
/*  43 */     if (!fragment)
/*  44 */       this.out.endDocument();
/*  45 */     super.endDocument(fragment);
/*     */   }
/*     */   
/*     */   public void beginStartTag(int prefix, String localName) {
/*  49 */     this.elementNsUri = this.nsContext.getNamespaceURI(prefix);
/*  50 */     this.elementLocalName = localName;
/*  51 */     this.elementQName = getQName(prefix, localName);
/*  52 */     this.atts.clear();
/*     */   }
/*     */   
/*     */   public void attribute(int prefix, String localName, String value) { String qname;
/*     */     String nsUri;
/*     */     String qname;
/*  58 */     if (prefix == -1) {
/*  59 */       String nsUri = "";
/*  60 */       qname = localName;
/*     */     } else {
/*  62 */       nsUri = this.nsContext.getNamespaceURI(prefix);
/*  63 */       qname = this.nsContext.getPrefix(prefix) + ':' + localName;
/*     */     }
/*  65 */     this.atts.addAttribute(nsUri, localName, qname, "CDATA", value);
/*     */   }
/*     */   
/*     */   public void endStartTag() throws SAXException {
/*  69 */     NamespaceContextImpl.Element ns = this.nsContext.getCurrent();
/*  70 */     if (ns != null) {
/*  71 */       int sz = ns.count();
/*  72 */       for (int i = 0; i < sz; i++) {
/*  73 */         String p = ns.getPrefix(i);
/*  74 */         String uri = ns.getNsUri(i);
/*  75 */         if ((uri.length() != 0) || (ns.getBase() != 1))
/*     */         {
/*  77 */           this.out.startPrefixMapping(p, uri); }
/*     */       }
/*     */     }
/*  80 */     this.out.startElement(this.elementNsUri, this.elementLocalName, this.elementQName, this.atts);
/*     */   }
/*     */   
/*     */   public void endTag(int prefix, String localName) throws SAXException {
/*  84 */     this.out.endElement(this.nsContext.getNamespaceURI(prefix), localName, getQName(prefix, localName));
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  90 */     NamespaceContextImpl.Element ns = this.nsContext.getCurrent();
/*  91 */     if (ns != null) {
/*  92 */       int sz = ns.count();
/*  93 */       for (int i = sz - 1; i >= 0; i--) {
/*  94 */         String p = ns.getPrefix(i);
/*  95 */         String uri = ns.getNsUri(i);
/*  96 */         if ((uri.length() != 0) || (ns.getBase() != 1))
/*     */         {
/*  98 */           this.out.endPrefixMapping(p);
/*     */         }
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   private String getQName(int prefix, String localName) {
/* 105 */     String p = this.nsContext.getPrefix(prefix);
/* 106 */     String qname; String qname; if (p.length() == 0) {
/* 107 */       qname = localName;
/*     */     } else
/* 109 */       qname = p + ':' + localName;
/* 110 */     return qname;
/*     */   }
/*     */   
/*     */   public void text(String value, boolean needsSP) throws IOException, SAXException, XMLStreamException {
/* 114 */     int vlen = value.length();
/* 115 */     if (this.buf.length <= vlen) {
/* 116 */       this.buf = new char[Math.max(this.buf.length * 2, vlen + 1)];
/*     */     }
/* 118 */     if (needsSP) {
/* 119 */       value.getChars(0, vlen, this.buf, 1);
/* 120 */       this.buf[0] = ' ';
/*     */     } else {
/* 122 */       value.getChars(0, vlen, this.buf, 0);
/*     */     }
/* 124 */     this.out.characters(this.buf, 0, vlen + (needsSP ? 1 : 0));
/*     */   }
/*     */   
/*     */   public void text(Pcdata value, boolean needsSP) throws IOException, SAXException, XMLStreamException {
/* 128 */     int vlen = value.length();
/* 129 */     if (this.buf.length <= vlen) {
/* 130 */       this.buf = new char[Math.max(this.buf.length * 2, vlen + 1)];
/*     */     }
/* 132 */     if (needsSP) {
/* 133 */       value.writeTo(this.buf, 1);
/* 134 */       this.buf[0] = ' ';
/*     */     } else {
/* 136 */       value.writeTo(this.buf, 0);
/*     */     }
/* 138 */     this.out.characters(this.buf, 0, vlen + (needsSP ? 1 : 0));
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\output\SAXOutput.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */