/*     */ package com.sun.xml.bind.v2.runtime.property;
/*     */ 
/*     */ import com.sun.xml.bind.v2.ClassFactory;
/*     */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*     */ import com.sun.xml.bind.v2.model.core.WildcardMode;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeElement;
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeReferencePropertyInfo;
/*     */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*     */ import com.sun.xml.bind.v2.runtime.JaxBeanInfo;
/*     */ import com.sun.xml.bind.v2.runtime.Name;
/*     */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Accessor;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.ListIterator;
/*     */ import com.sun.xml.bind.v2.runtime.reflect.Lister;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.ChildLoader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Loader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Receiver;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext.State;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.WildcardLoader;
/*     */ import com.sun.xml.bind.v2.util.QNameMap;
/*     */ import com.sun.xml.bind.v2.util.QNameMap.Entry;
/*     */ import java.io.IOException;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import javax.xml.bind.annotation.DomHandler;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ class ArrayReferenceNodeProperty<BeanT, ListT, ItemT>
/*     */   extends ArrayERProperty<BeanT, ListT, ItemT>
/*     */ {
/*  36 */   private final QNameMap<JaxBeanInfo> expectedElements = new QNameMap();
/*     */   
/*     */   private final boolean isMixed;
/*     */   private final DomHandler domHandler;
/*     */   private final WildcardMode wcMode;
/*     */   
/*     */   public ArrayReferenceNodeProperty(JAXBContextImpl p, RuntimeReferencePropertyInfo prop)
/*     */   {
/*  44 */     super(p, prop, prop.getXmlName(), prop.isCollectionNillable());
/*     */     
/*  46 */     for (RuntimeElement e : prop.getElements()) {
/*  47 */       JaxBeanInfo bi = p.getOrCreate(e);
/*  48 */       this.expectedElements.put(e.getElementName().getNamespaceURI(), e.getElementName().getLocalPart(), bi);
/*     */     }
/*     */     
/*  51 */     this.isMixed = prop.isMixed();
/*     */     
/*  53 */     if (prop.getWildcard() != null) {
/*  54 */       this.domHandler = ((DomHandler)ClassFactory.create((Class)prop.getDOMHandler()));
/*  55 */       this.wcMode = prop.getWildcard();
/*     */     } else {
/*  57 */       this.domHandler = null;
/*  58 */       this.wcMode = null;
/*     */     }
/*     */   }
/*     */   
/*     */   protected final void serializeListBody(BeanT o, XMLSerializer w, ListT list) throws IOException, XMLStreamException, SAXException {
/*  63 */     ListIterator<ItemT> itr = this.lister.iterator(list, w);
/*     */     
/*  65 */     while (itr.hasNext()) {
/*     */       try {
/*  67 */         ItemT item = itr.next();
/*  68 */         if (item != null) {
/*  69 */           if ((this.isMixed) && (item.getClass() == String.class)) {
/*  70 */             w.text((String)item, null);
/*     */           } else {
/*  72 */             JaxBeanInfo bi = w.grammar.getBeanInfo(item, true);
/*  73 */             if ((bi.jaxbType == Object.class) && (this.domHandler != null))
/*     */             {
/*     */ 
/*  76 */               w.writeDom(item, this.domHandler, o, this.fieldName);
/*     */             } else
/*  78 */               bi.serializeRoot(item, w);
/*     */           }
/*     */         }
/*     */       } catch (JAXBException e) {
/*  82 */         w.reportError(this.fieldName, e);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public void createBodyUnmarshaller(UnmarshallerChain chain, QNameMap<ChildLoader> loaders)
/*     */   {
/*  89 */     int offset = chain.allocateOffset();
/*     */     
/*  91 */     Receiver recv = new ArrayERProperty.ReceiverImpl(this, offset);
/*     */     
/*  93 */     for (QNameMap.Entry<JaxBeanInfo> n : this.expectedElements.entrySet()) {
/*  94 */       JaxBeanInfo beanInfo = (JaxBeanInfo)n.getValue();
/*  95 */       loaders.put(n.nsUri, n.localName, new ChildLoader(beanInfo.getLoader(chain.context, true), recv));
/*     */     }
/*     */     
/*  98 */     if (this.isMixed)
/*     */     {
/* 100 */       loaders.put(TEXT_HANDLER, new ChildLoader(new MixedTextoader(recv), null));
/*     */     }
/*     */     
/*     */ 
/* 104 */     if (this.domHandler != null) {
/* 105 */       loaders.put(CATCH_ALL, new ChildLoader(new WildcardLoader(this.domHandler, this.wcMode), recv));
/*     */     }
/*     */   }
/*     */   
/*     */   private static final class MixedTextoader extends Loader
/*     */   {
/*     */     private final Receiver recv;
/*     */     
/*     */     public MixedTextoader(Receiver recv)
/*     */     {
/* 115 */       super();
/* 116 */       this.recv = recv;
/*     */     }
/*     */     
/*     */     public void text(UnmarshallingContext.State state, CharSequence text) throws SAXException {
/* 120 */       this.recv.receive(state, text.toString());
/*     */     }
/*     */   }
/*     */   
/*     */   public PropertyKind getKind()
/*     */   {
/* 126 */     return PropertyKind.REFERENCE;
/*     */   }
/*     */   
/*     */ 
/*     */   public Accessor getElementPropertyAccessor(String nsUri, String localName)
/*     */   {
/* 132 */     if (this.wrapperTagName != null) {
/* 133 */       if (this.wrapperTagName.equals(nsUri, localName)) {
/* 134 */         return this.acc;
/*     */       }
/* 136 */     } else if (this.expectedElements.containsKey(nsUri, localName)) {
/* 137 */       return this.acc;
/*     */     }
/* 139 */     return null;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\property\ArrayReferenceNodeProperty.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */