/*     */ package com.sun.xml.bind.v2.runtime.unmarshaller;
/*     */ 
/*     */ import com.sun.xml.bind.WhiteSpaceProcessor;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import javax.xml.bind.UnmarshallerHandler;
/*     */ import org.xml.sax.Attributes;
/*     */ import org.xml.sax.Locator;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class SAXConnector
/*     */   implements UnmarshallerHandler
/*     */ {
/*     */   private LocatorEx loc;
/*  25 */   private final StringBuilder buffer = new StringBuilder();
/*     */   private final XmlVisitor next;
/*     */   private final UnmarshallingContext context;
/*     */   private final XmlVisitor.TextPredictor predictor;
/*     */   
/*     */   private static final class TagNameImpl
/*     */     extends TagName
/*     */   {
/*     */     String qname;
/*     */     
/*  35 */     public String getQname() { return this.qname; }
/*     */   }
/*     */   
/*  38 */   private final TagNameImpl tagName = new TagNameImpl(null);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public SAXConnector(XmlVisitor next, LocatorEx externalLocator)
/*     */   {
/*  49 */     this.next = next;
/*  50 */     this.context = next.getContext();
/*  51 */     this.predictor = next.getPredictor();
/*  52 */     this.loc = externalLocator;
/*     */   }
/*     */   
/*     */   public Object getResult() throws JAXBException, IllegalStateException {
/*  56 */     return this.context.getResult();
/*     */   }
/*     */   
/*     */   public UnmarshallingContext getContext() {
/*  60 */     return this.context;
/*     */   }
/*     */   
/*     */   public void setDocumentLocator(Locator locator) {
/*  64 */     if (this.loc != null) {
/*  65 */       return;
/*     */     }
/*  67 */     this.loc = new LocatorExWrapper(locator);
/*     */   }
/*     */   
/*     */   public void startDocument() throws SAXException {
/*  71 */     this.next.startDocument(this.loc, null);
/*     */   }
/*     */   
/*     */   public void endDocument() throws SAXException {
/*  75 */     this.next.endDocument();
/*     */   }
/*     */   
/*     */   public void startPrefixMapping(String prefix, String uri) throws SAXException {
/*  79 */     this.next.startPrefixMapping(prefix, uri);
/*     */   }
/*     */   
/*     */   public void endPrefixMapping(String prefix) throws SAXException {
/*  83 */     this.next.endPrefixMapping(prefix);
/*     */   }
/*     */   
/*     */   public void startElement(String uri, String local, String qname, Attributes atts) throws SAXException
/*     */   {
/*  88 */     if ((uri == null) || (uri.length() == 0))
/*  89 */       uri = "";
/*  90 */     if ((local == null) || (local.length() == 0))
/*  91 */       local = qname;
/*  92 */     if ((qname == null) || (qname.length() == 0)) {
/*  93 */       qname = local;
/*     */     }
/*  95 */     processText(true);
/*     */     
/*  97 */     this.tagName.uri = uri;
/*  98 */     this.tagName.local = local;
/*  99 */     this.tagName.qname = qname;
/* 100 */     this.tagName.atts = atts;
/* 101 */     this.next.startElement(this.tagName);
/*     */   }
/*     */   
/*     */   public void endElement(String uri, String localName, String qName) throws SAXException {
/* 105 */     processText(false);
/* 106 */     this.tagName.uri = uri;
/* 107 */     this.tagName.local = localName;
/* 108 */     this.tagName.qname = qName;
/* 109 */     this.next.endElement(this.tagName);
/*     */   }
/*     */   
/*     */   public final void characters(char[] buf, int start, int len)
/*     */   {
/* 114 */     if (this.predictor.expectText())
/* 115 */       this.buffer.append(buf, start, len);
/*     */   }
/*     */   
/*     */   public final void ignorableWhitespace(char[] buf, int start, int len) {
/* 119 */     characters(buf, start, len);
/*     */   }
/*     */   
/*     */ 
/*     */   public void processingInstruction(String target, String data) {}
/*     */   
/*     */ 
/*     */   public void skippedEntity(String name) {}
/*     */   
/*     */   private void processText(boolean ignorable)
/*     */     throws SAXException
/*     */   {
/* 131 */     if ((this.predictor.expectText()) && ((!ignorable) || (!WhiteSpaceProcessor.isWhiteSpace(this.buffer))))
/* 132 */       this.next.text(this.buffer);
/* 133 */     this.buffer.setLength(0);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\unmarshaller\SAXConnector.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */