/*     */ package com.sun.xml.txw2.output;
/*     */ 
/*     */ import com.sun.xml.txw2.TxwException;
/*     */ import java.io.BufferedWriter;
/*     */ import java.io.FileOutputStream;
/*     */ import java.io.IOException;
/*     */ import java.io.OutputStream;
/*     */ import java.io.OutputStreamWriter;
/*     */ import java.io.UnsupportedEncodingException;
/*     */ import java.io.Writer;
/*     */ import javax.xml.transform.stream.StreamResult;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class StreamSerializer
/*     */   implements XmlSerializer
/*     */ {
/*     */   private final SaxSerializer serializer;
/*     */   private final XMLWriter writer;
/*     */   
/*     */   public StreamSerializer(OutputStream out)
/*     */   {
/*  27 */     this(createWriter(out));
/*     */   }
/*     */   
/*     */   public StreamSerializer(OutputStream out, String encoding) throws UnsupportedEncodingException {
/*  31 */     this(createWriter(out, encoding));
/*     */   }
/*     */   
/*     */   public StreamSerializer(Writer out) {
/*  35 */     this(new StreamResult(out));
/*     */   }
/*     */   
/*     */   public StreamSerializer(StreamResult streamResult) {
/*  39 */     if (streamResult.getWriter() != null) {
/*  40 */       this.writer = createWriter(streamResult.getWriter());
/*  41 */     } else if (streamResult.getOutputStream() != null) {
/*  42 */       this.writer = createWriter(streamResult.getOutputStream());
/*  43 */     } else if (streamResult.getSystemId() != null) {
/*  44 */       String fileURL = streamResult.getSystemId();
/*     */       
/*  46 */       fileURL = convertURL(fileURL);
/*     */       try
/*     */       {
/*  49 */         this.writer = createWriter(new FileOutputStream(fileURL));
/*     */       } catch (IOException e) {
/*  51 */         throw new TxwException(e);
/*     */       }
/*     */     } else {
/*  54 */       throw new IllegalArgumentException();
/*     */     }
/*     */     
/*  57 */     this.serializer = new SaxSerializer(this.writer, this.writer);
/*     */   }
/*     */   
/*     */   private StreamSerializer(XMLWriter writer) {
/*  61 */     this.writer = writer;
/*     */     
/*  63 */     this.serializer = new SaxSerializer(writer, writer);
/*     */   }
/*     */   
/*     */   private String convertURL(String url) {
/*  67 */     url = url.replace('\\', '/');
/*  68 */     url = url.replaceAll("//", "/");
/*  69 */     url = url.replaceAll("//", "/");
/*  70 */     if (url.startsWith("file:/")) {
/*  71 */       if (url.substring(6).indexOf(":") > 0) {
/*  72 */         url = url.substring(6);
/*     */       } else
/*  74 */         url = url.substring(5);
/*     */     }
/*  76 */     return url;
/*     */   }
/*     */   
/*     */   public void startDocument()
/*     */   {
/*  81 */     this.serializer.startDocument();
/*     */   }
/*     */   
/*     */   public void beginStartTag(String uri, String localName, String prefix) {
/*  85 */     this.serializer.beginStartTag(uri, localName, prefix);
/*     */   }
/*     */   
/*     */   public void writeAttribute(String uri, String localName, String prefix, StringBuilder value) {
/*  89 */     this.serializer.writeAttribute(uri, localName, prefix, value);
/*     */   }
/*     */   
/*     */   public void writeXmlns(String prefix, String uri) {
/*  93 */     this.serializer.writeXmlns(prefix, uri);
/*     */   }
/*     */   
/*     */   public void endStartTag(String uri, String localName, String prefix) {
/*  97 */     this.serializer.endStartTag(uri, localName, prefix);
/*     */   }
/*     */   
/*     */   public void endTag() {
/* 101 */     this.serializer.endTag();
/*     */   }
/*     */   
/*     */   public void text(StringBuilder text) {
/* 105 */     this.serializer.text(text);
/*     */   }
/*     */   
/*     */   public void cdata(StringBuilder text) {
/* 109 */     this.serializer.cdata(text);
/*     */   }
/*     */   
/*     */   public void comment(StringBuilder comment) {
/* 113 */     this.serializer.comment(comment);
/*     */   }
/*     */   
/*     */   public void endDocument() {
/* 117 */     this.serializer.endDocument();
/*     */   }
/*     */   
/*     */   public void flush() {
/* 121 */     this.serializer.flush();
/*     */     try {
/* 123 */       this.writer.flush();
/*     */     } catch (IOException e) {
/* 125 */       throw new TxwException(e);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   private static final XMLWriter createWriter(Writer w)
/*     */   {
/* 132 */     DataWriter dw = new DataWriter(new BufferedWriter(w));
/* 133 */     dw.setIndentStep("  ");
/* 134 */     return dw;
/*     */   }
/*     */   
/*     */   private static final XMLWriter createWriter(OutputStream os, String encoding) throws UnsupportedEncodingException {
/* 138 */     XMLWriter writer = createWriter(new OutputStreamWriter(os, encoding));
/* 139 */     writer.setEncoding(encoding);
/* 140 */     return writer;
/*     */   }
/*     */   
/*     */   private static final XMLWriter createWriter(OutputStream os) {
/*     */     try {
/* 145 */       return createWriter(os, "UTF-8");
/*     */     }
/*     */     catch (UnsupportedEncodingException e) {
/* 148 */       throw new Error(e);
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\txw2\output\StreamSerializer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */