/*     */ package org.codehaus.jackson.map.type;
/*     */ 
/*     */ import java.util.Collection;
/*     */ import org.codehaus.jackson.type.JavaType;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class CollectionLikeType
/*     */   extends TypeBase
/*     */ {
/*     */   protected final JavaType _elementType;
/*     */   
/*     */   protected CollectionLikeType(Class<?> collT, JavaType elemT)
/*     */   {
/*  31 */     super(collT, elemT.hashCode());
/*  32 */     this._elementType = elemT;
/*     */   }
/*     */   
/*     */   protected JavaType _narrow(Class<?> subclass)
/*     */   {
/*  37 */     return new CollectionLikeType(subclass, this._elementType);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public JavaType narrowContentsBy(Class<?> contentClass)
/*     */   {
/*  44 */     if (contentClass == this._elementType.getRawClass()) {
/*  45 */       return this;
/*     */     }
/*  47 */     return new CollectionLikeType(this._class, this._elementType.narrowBy(contentClass)).copyHandlers(this);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public JavaType widenContentsBy(Class<?> contentClass)
/*     */   {
/*  54 */     if (contentClass == this._elementType.getRawClass()) {
/*  55 */       return this;
/*     */     }
/*  57 */     return new CollectionLikeType(this._class, this._elementType.widenBy(contentClass)).copyHandlers(this);
/*     */   }
/*     */   
/*     */ 
/*     */   public static CollectionLikeType construct(Class<?> rawType, JavaType elemT)
/*     */   {
/*  63 */     return new CollectionLikeType(rawType, elemT);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public CollectionLikeType withTypeHandler(Object h)
/*     */   {
/*  70 */     CollectionLikeType newInstance = new CollectionLikeType(this._class, this._elementType);
/*  71 */     newInstance._typeHandler = h;
/*  72 */     return newInstance;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public CollectionLikeType withContentTypeHandler(Object h)
/*     */   {
/*  79 */     return new CollectionLikeType(this._class, this._elementType.withTypeHandler(h));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isContainerType()
/*     */   {
/*  89 */     return true;
/*     */   }
/*     */   
/*  92 */   public boolean isCollectionLikeType() { return true; }
/*     */   
/*     */   public JavaType getContentType() {
/*  95 */     return this._elementType;
/*     */   }
/*     */   
/*  98 */   public int containedTypeCount() { return 1; }
/*     */   
/*     */   public JavaType containedType(int index)
/*     */   {
/* 102 */     return index == 0 ? this._elementType : null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String containedTypeName(int index)
/*     */   {
/* 111 */     if (index == 0) return "E";
/* 112 */     return null;
/*     */   }
/*     */   
/*     */   public StringBuilder getErasedSignature(StringBuilder sb)
/*     */   {
/* 117 */     return _classSignature(this._class, sb, true);
/*     */   }
/*     */   
/*     */   public StringBuilder getGenericSignature(StringBuilder sb)
/*     */   {
/* 122 */     _classSignature(this._class, sb, false);
/* 123 */     sb.append('<');
/* 124 */     this._elementType.getGenericSignature(sb);
/* 125 */     sb.append(">;");
/* 126 */     return sb;
/*     */   }
/*     */   
/*     */   protected String buildCanonicalName()
/*     */   {
/* 131 */     StringBuilder sb = new StringBuilder();
/* 132 */     sb.append(this._class.getName());
/* 133 */     if (this._elementType != null) {
/* 134 */       sb.append('<');
/* 135 */       sb.append(this._elementType.toCanonical());
/* 136 */       sb.append('>');
/*     */     }
/* 138 */     return sb.toString();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isTrueCollectionType()
/*     */   {
/* 156 */     return Collection.class.isAssignableFrom(this._class);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean equals(Object o)
/*     */   {
/* 168 */     if (o == this) return true;
/* 169 */     if (o == null) return false;
/* 170 */     if (o.getClass() != getClass()) { return false;
/*     */     }
/* 172 */     CollectionLikeType other = (CollectionLikeType)o;
/* 173 */     return (this._class == other._class) && (this._elementType.equals(other._elementType));
/*     */   }
/*     */   
/*     */ 
/*     */   public String toString()
/*     */   {
/* 179 */     return "[collection-like type; class " + this._class.getName() + ", contains " + this._elementType + "]";
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\type\CollectionLikeType.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */