/*     */ package org.codehaus.janino;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.io.Reader;
/*     */ import java.io.StringReader;
/*     */ import org.codehaus.commons.compiler.CausedException;
/*     */ import org.codehaus.commons.compiler.CompileException;
/*     */ import org.codehaus.commons.compiler.Cookable;
/*     */ import org.codehaus.commons.compiler.IClassBodyEvaluator;
/*     */ import org.codehaus.commons.compiler.Location;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ClassBodyEvaluator
/*     */   extends SimpleCompiler
/*     */   implements IClassBodyEvaluator
/*     */ {
/*  50 */   protected static final Class[] ZERO_CLASSES = new Class[0];
/*     */   
/*  52 */   private String[] optionalDefaultImports = null;
/*  53 */   protected String className = "SC";
/*  54 */   private Class optionalExtendedType = null;
/*  55 */   private Class[] implementedTypes = ZERO_CLASSES;
/*  56 */   private Class result = null;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ClassBodyEvaluator(String classBody)
/*     */     throws CompileException
/*     */   {
/*  67 */     cook(classBody);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ClassBodyEvaluator(String optionalFileName, InputStream is)
/*     */     throws CompileException, IOException
/*     */   {
/*  79 */     cook(optionalFileName, is);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ClassBodyEvaluator(String optionalFileName, Reader reader)
/*     */     throws CompileException, IOException
/*     */   {
/*  91 */     cook(optionalFileName, reader);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ClassBodyEvaluator(Scanner scanner, ClassLoader optionalParentClassLoader)
/*     */     throws CompileException, IOException
/*     */   {
/* 108 */     setParentClassLoader(optionalParentClassLoader);
/* 109 */     cook(scanner);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ClassBodyEvaluator(Scanner scanner, Class optionalExtendedType, Class[] implementedTypes, ClassLoader optionalParentClassLoader)
/*     */     throws CompileException, IOException
/*     */   {
/* 132 */     setExtendedClass(optionalExtendedType);
/* 133 */     setImplementedInterfaces(implementedTypes);
/* 134 */     setParentClassLoader(optionalParentClassLoader);
/* 135 */     cook(scanner);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ClassBodyEvaluator(Scanner scanner, String className, Class optionalExtendedType, Class[] implementedTypes, ClassLoader optionalParentClassLoader)
/*     */     throws CompileException, IOException
/*     */   {
/* 161 */     setClassName(className);
/* 162 */     setExtendedClass(optionalExtendedType);
/* 163 */     setImplementedInterfaces(implementedTypes);
/* 164 */     setParentClassLoader(optionalParentClassLoader);
/* 165 */     cook(scanner);
/*     */   }
/*     */   
/*     */   public ClassBodyEvaluator() {}
/*     */   
/*     */   public void setDefaultImports(String[] optionalDefaultImports) {
/* 171 */     assertNotCooked();
/* 172 */     this.optionalDefaultImports = optionalDefaultImports;
/*     */   }
/*     */   
/*     */   public void setClassName(String className) {
/* 176 */     if (className == null) throw new NullPointerException();
/* 177 */     assertNotCooked();
/* 178 */     this.className = className;
/*     */   }
/*     */   
/*     */   public void setExtendedClass(Class optionalExtendedType) {
/* 182 */     assertNotCooked();
/* 183 */     this.optionalExtendedType = optionalExtendedType; }
/*     */   
/*     */   /**
/*     */    * @deprecated
/*     */    */
/* 188 */   public void setExtendedType(Class optionalExtendedClass) { setExtendedClass(optionalExtendedClass); }
/*     */   
/*     */   public void setImplementedInterfaces(Class[] implementedTypes)
/*     */   {
/* 192 */     if (implementedTypes == null) {
/* 193 */       throw new NullPointerException("Zero implemented types must be specified as \"new Class[0]\", not \"null\"");
/*     */     }
/*     */     
/*     */ 
/* 197 */     assertNotCooked();
/* 198 */     this.implementedTypes = implementedTypes; }
/*     */   
/*     */   /**
/*     */    * @deprecated
/*     */    */
/* 203 */   public void setImplementedTypes(Class[] implementedInterfaces) { setImplementedInterfaces(implementedInterfaces); }
/*     */   
/*     */   public void cook(Scanner scanner) throws CompileException, IOException
/*     */   {
/* 207 */     setUpClassLoaders();
/*     */     
/* 209 */     Java.CompilationUnit compilationUnit = makeCompilationUnit(scanner);
/*     */     
/*     */ 
/* 212 */     Java.ClassDeclaration cd = addPackageMemberClassDeclaration(scanner.location(), compilationUnit);
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 218 */     Parser parser = new Parser(scanner);
/* 219 */     while (!scanner.peek().isEOF()) {
/* 220 */       parser.parseClassBodyDeclaration(cd);
/*     */     }
/*     */     
/*     */ 
/* 224 */     this.result = compileToClass(compilationUnit, this.className);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final Java.CompilationUnit makeCompilationUnit(Scanner optionalScanner)
/*     */     throws CompileException, IOException
/*     */   {
/* 239 */     Java.CompilationUnit cu = new Java.CompilationUnit(optionalScanner == null ? null : optionalScanner.getFileName());
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 246 */     if (this.optionalDefaultImports != null) {
/* 247 */       for (int i = 0; i < this.optionalDefaultImports.length; i++) {
/* 248 */         Scanner s = new Scanner(null, new StringReader(this.optionalDefaultImports[i]));
/* 249 */         cu.addImportDeclaration(new Parser(s).parseImportDeclarationBody());
/* 250 */         if (!s.peek().isEOF()) {
/* 251 */           throw new CompileException("Unexpected token \"" + s.peek() + "\" in default import", s.location());
/*     */         }
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 257 */     if (optionalScanner != null) {
/* 258 */       Parser parser = new Parser(optionalScanner);
/* 259 */       while (optionalScanner.peek().isKeyword("import")) {
/* 260 */         cu.addImportDeclaration(parser.parseImportDeclaration());
/*     */       }
/*     */     }
/*     */     
/* 264 */     return cu;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected Java.PackageMemberClassDeclaration addPackageMemberClassDeclaration(Location location, Java.CompilationUnit compilationUnit)
/*     */     throws CompileException
/*     */   {
/* 280 */     String cn = this.className;
/* 281 */     int idx = cn.lastIndexOf('.');
/* 282 */     if (idx != -1) {
/* 283 */       compilationUnit.setPackageDeclaration(new Java.PackageDeclaration(location, cn.substring(0, idx)));
/* 284 */       cn = cn.substring(idx + 1);
/*     */     }
/* 286 */     Java.PackageMemberClassDeclaration tlcd = new Java.PackageMemberClassDeclaration(location, null, (short)1, cn, classToType(location, this.optionalExtendedType), classesToTypes(location, this.implementedTypes));
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 294 */     compilationUnit.addPackageMemberTypeDeclaration(tlcd);
/* 295 */     return tlcd;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final Class compileToClass(Java.CompilationUnit compilationUnit, String newClassName)
/*     */     throws CompileException
/*     */   {
/* 311 */     ClassLoader cl = compileToClassLoader(compilationUnit);
/*     */     
/*     */     try
/*     */     {
/* 315 */       return cl.loadClass(newClassName);
/*     */     } catch (ClassNotFoundException ex) {
/* 317 */       throw new JaninoRuntimeException("SNO: Generated compilation unit does not declare class \"" + newClassName + "\"");
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public Class getClazz()
/*     */   {
/* 326 */     if (getClass() != ClassBodyEvaluator.class) {
/* 327 */       throw new IllegalStateException("Must not be called on derived instances");
/*     */     }
/* 329 */     if (this.result == null) throw new IllegalStateException("Must only be called after \"cook()\"");
/* 330 */     return this.result;
/*     */   }
/*     */   
/*     */   public Object createInstance(Reader reader) throws CompileException, IOException {
/* 334 */     cook(reader);
/*     */     try
/*     */     {
/* 337 */       return getClazz().newInstance();
/*     */     } catch (InstantiationException ie) {
/* 339 */       CompileException ce = new CompileException("Class is abstract, an interface, an array class, a primitive type, or void; or has no zero-parameter constructor", null);
/*     */       
/*     */ 
/*     */ 
/* 343 */       ce.initCause(ie);
/* 344 */       throw ce;
/*     */     } catch (IllegalAccessException iae) {
/* 346 */       CompileException ce = new CompileException("The class or its zero-parameter constructor is not accessible", null);
/*     */       
/*     */ 
/*     */ 
/* 350 */       ce.initCause(iae);
/* 351 */       throw ce;
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static Object createFastClassBodyEvaluator(Scanner scanner, Class optionalBaseType, ClassLoader optionalParentClassLoader)
/*     */     throws CompileException, IOException
/*     */   {
/* 379 */     return createFastClassBodyEvaluator(scanner, "SC", (optionalBaseType != null) && (!optionalBaseType.isInterface()) ? optionalBaseType : null, (optionalBaseType != null) && (optionalBaseType.isInterface()) ? new Class[] { optionalBaseType } : new Class[0], optionalParentClassLoader);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static Object createFastClassBodyEvaluator(Scanner scanner, String className, Class optionalExtendedClass, Class[] implementedInterfaces, ClassLoader optionalParentClassLoader)
/*     */     throws CompileException, IOException
/*     */   {
/* 415 */     ClassBodyEvaluator cbe = new ClassBodyEvaluator();
/* 416 */     cbe.setClassName(className);
/* 417 */     cbe.setExtendedClass(optionalExtendedClass);
/* 418 */     cbe.setImplementedInterfaces(implementedInterfaces);
/* 419 */     cbe.setParentClassLoader(optionalParentClassLoader);
/* 420 */     cbe.cook(scanner);
/* 421 */     Class c = cbe.getClazz();
/*     */     try {
/* 423 */       return c.newInstance();
/*     */     } catch (InstantiationException e) {
/* 425 */       throw new CompileException("Cannot instantiate abstract class -- one or more method implementations are missing", null);
/*     */ 
/*     */     }
/*     */     catch (IllegalAccessException e)
/*     */     {
/*     */ 
/* 431 */       throw new JaninoRuntimeException(e.toString());
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\ClassBodyEvaluator.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */