/*     */ package org.codehaus.janino;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.io.Reader;
/*     */ import java.io.StringReader;
/*     */ import java.lang.reflect.InvocationTargetException;
/*     */ import java.lang.reflect.Method;
/*     */ import java.util.ArrayList;
/*     */ import java.util.HashMap;
/*     */ import java.util.HashSet;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ import org.codehaus.commons.compiler.CompileException;
/*     */ import org.codehaus.commons.compiler.Cookable;
/*     */ import org.codehaus.commons.compiler.IScriptEvaluator;
/*     */ import org.codehaus.commons.compiler.Location;
/*     */ import org.codehaus.janino.util.Traverser;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ScriptEvaluator
/*     */   extends ClassBodyEvaluator
/*     */   implements IScriptEvaluator
/*     */ {
/*  46 */   protected boolean[] optionalStaticMethod = null;
/*  47 */   protected Class[] optionalReturnTypes = null;
/*  48 */   protected String[] optionalMethodNames = null;
/*  49 */   protected String[][] optionalParameterNames = (String[][])null;
/*  50 */   protected Class[][] optionalParameterTypes = (Class[][])null;
/*  51 */   protected Class[][] optionalThrownExceptions = (Class[][])null;
/*     */   
/*  53 */   private Method[] result = null;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ScriptEvaluator(String script)
/*     */     throws CompileException
/*     */   {
/*  66 */     cook(script);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ScriptEvaluator(String script, Class returnType)
/*     */     throws CompileException
/*     */   {
/*  83 */     setReturnType(returnType);
/*  84 */     cook(script);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ScriptEvaluator(String script, Class returnType, String[] parameterNames, Class[] parameterTypes)
/*     */     throws CompileException
/*     */   {
/* 105 */     setReturnType(returnType);
/* 106 */     setParameters(parameterNames, parameterTypes);
/* 107 */     cook(script);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ScriptEvaluator(String script, Class returnType, String[] parameterNames, Class[] parameterTypes, Class[] thrownExceptions)
/*     */     throws CompileException
/*     */   {
/* 131 */     setReturnType(returnType);
/* 132 */     setParameters(parameterNames, parameterTypes);
/* 133 */     setThrownExceptions(thrownExceptions);
/* 134 */     cook(script);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ScriptEvaluator(String optionalFileName, InputStream is, Class returnType, String[] parameterNames, Class[] parameterTypes, Class[] thrownExceptions, ClassLoader optionalParentClassLoader)
/*     */     throws CompileException, IOException
/*     */   {
/* 162 */     setReturnType(returnType);
/* 163 */     setParameters(parameterNames, parameterTypes);
/* 164 */     setThrownExceptions(thrownExceptions);
/* 165 */     setParentClassLoader(optionalParentClassLoader);
/* 166 */     cook(optionalFileName, is);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ScriptEvaluator(String optionalFileName, Reader reader, Class returnType, String[] parameterNames, Class[] parameterTypes, Class[] thrownExceptions, ClassLoader optionalParentClassLoader)
/*     */     throws CompileException, IOException
/*     */   {
/* 194 */     setReturnType(returnType);
/* 195 */     setParameters(parameterNames, parameterTypes);
/* 196 */     setThrownExceptions(thrownExceptions);
/* 197 */     setParentClassLoader(optionalParentClassLoader);
/* 198 */     cook(optionalFileName, reader);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ScriptEvaluator(Scanner scanner, Class returnType, String[] parameterNames, Class[] parameterTypes, Class[] thrownExceptions, ClassLoader optionalParentClassLoader)
/*     */     throws CompileException, IOException
/*     */   {
/* 225 */     setReturnType(returnType);
/* 226 */     setParameters(parameterNames, parameterTypes);
/* 227 */     setThrownExceptions(thrownExceptions);
/* 228 */     setParentClassLoader(optionalParentClassLoader);
/* 229 */     cook(scanner);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ScriptEvaluator(Scanner scanner, Class optionalExtendedType, Class[] implementedTypes, Class returnType, String[] parameterNames, Class[] parameterTypes, Class[] thrownExceptions, ClassLoader optionalParentClassLoader)
/*     */     throws CompileException, IOException
/*     */   {
/* 262 */     setExtendedClass(optionalExtendedType);
/* 263 */     setImplementedInterfaces(implementedTypes);
/* 264 */     setReturnType(returnType);
/* 265 */     setParameters(parameterNames, parameterTypes);
/* 266 */     setThrownExceptions(thrownExceptions);
/* 267 */     setParentClassLoader(optionalParentClassLoader);
/* 268 */     cook(scanner);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ScriptEvaluator(Scanner scanner, String className, Class optionalExtendedType, Class[] implementedTypes, boolean staticMethod, Class returnType, String methodName, String[] parameterNames, Class[] parameterTypes, Class[] thrownExceptions, ClassLoader optionalParentClassLoader)
/*     */     throws CompileException, IOException
/*     */   {
/* 310 */     setClassName(className);
/* 311 */     setExtendedClass(optionalExtendedType);
/* 312 */     setImplementedInterfaces(implementedTypes);
/* 313 */     setStaticMethod(staticMethod);
/* 314 */     setReturnType(returnType);
/* 315 */     setMethodName(methodName);
/* 316 */     setParameters(parameterNames, parameterTypes);
/* 317 */     setThrownExceptions(thrownExceptions);
/* 318 */     setParentClassLoader(optionalParentClassLoader);
/* 319 */     cook(scanner);
/*     */   }
/*     */   
/*     */   public ScriptEvaluator() {}
/*     */   
/*     */   public void setStaticMethod(boolean staticMethod) {
/* 325 */     setStaticMethod(new boolean[] { staticMethod });
/*     */   }
/*     */   
/*     */   public void setReturnType(Class returnType) {
/* 329 */     setReturnTypes(new Class[] { returnType });
/*     */   }
/*     */   
/*     */   public void setMethodName(String methodName) {
/* 333 */     setMethodNames(new String[] { methodName });
/*     */   }
/*     */   
/*     */   public void setParameters(String[] parameterNames, Class[] parameterTypes) {
/* 337 */     setParameters(new String[][] { parameterNames }, new Class[][] { parameterTypes });
/*     */   }
/*     */   
/*     */   public void setThrownExceptions(Class[] thrownExceptions) {
/* 341 */     setThrownExceptions(new Class[][] { thrownExceptions });
/*     */   }
/*     */   
/*     */   public final void cook(Scanner scanner) throws CompileException, IOException {
/* 345 */     cook(new Scanner[] { scanner });
/*     */   }
/*     */   
/*     */   public Object evaluate(Object[] arguments) throws InvocationTargetException {
/* 349 */     return evaluate(0, arguments);
/*     */   }
/*     */   
/*     */   public Method getMethod() {
/* 353 */     return getMethod(0);
/*     */   }
/*     */   
/*     */   public void setStaticMethod(boolean[] staticMethod) {
/* 357 */     assertNotCooked();
/* 358 */     this.optionalStaticMethod = ((boolean[])staticMethod.clone());
/*     */   }
/*     */   
/*     */   public void setReturnTypes(Class[] returnTypes) {
/* 362 */     assertNotCooked();
/* 363 */     this.optionalReturnTypes = ((Class[])returnTypes.clone());
/*     */   }
/*     */   
/*     */   public void setMethodNames(String[] methodNames) {
/* 367 */     assertNotCooked();
/* 368 */     this.optionalMethodNames = ((String[])methodNames.clone());
/*     */   }
/*     */   
/*     */   public void setParameters(String[][] parameterNames, Class[][] parameterTypes) {
/* 372 */     assertNotCooked();
/* 373 */     this.optionalParameterNames = ((String[][])parameterNames.clone());
/* 374 */     this.optionalParameterTypes = ((Class[][])parameterTypes.clone());
/*     */   }
/*     */   
/*     */   public void setThrownExceptions(Class[][] thrownExceptions) {
/* 378 */     assertNotCooked();
/* 379 */     this.optionalThrownExceptions = ((Class[][])thrownExceptions.clone());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void cook(Scanner[] scanners)
/*     */     throws CompileException, IOException
/*     */   {
/* 406 */     if (scanners == null) { throw new NullPointerException();
/*     */     }
/*     */     
/*     */ 
/* 410 */     int count = scanners.length;
/*     */     
/*     */ 
/* 413 */     if ((this.optionalMethodNames != null) && (this.optionalMethodNames.length != count)) {
/* 414 */       throw new IllegalStateException("methodName");
/*     */     }
/* 416 */     if ((this.optionalParameterNames != null) && (this.optionalParameterNames.length != count)) {
/* 417 */       throw new IllegalStateException("parameterNames");
/*     */     }
/* 419 */     if ((this.optionalParameterTypes != null) && (this.optionalParameterTypes.length != count)) {
/* 420 */       throw new IllegalStateException("parameterTypes");
/*     */     }
/* 422 */     if ((this.optionalReturnTypes != null) && (this.optionalReturnTypes.length != count)) {
/* 423 */       throw new IllegalStateException("returnTypes");
/*     */     }
/* 425 */     if ((this.optionalStaticMethod != null) && (this.optionalStaticMethod.length != count)) {
/* 426 */       throw new IllegalStateException("staticMethod");
/*     */     }
/* 428 */     if ((this.optionalThrownExceptions != null) && (this.optionalThrownExceptions.length != count)) {
/* 429 */       throw new IllegalStateException("thrownExceptions");
/*     */     }
/*     */     
/* 432 */     setUpClassLoaders();
/*     */     
/*     */ 
/* 435 */     Java.CompilationUnit compilationUnit = makeCompilationUnit(count == 1 ? scanners[0] : null);
/*     */     
/*     */ 
/* 438 */     Java.ClassDeclaration cd = addPackageMemberClassDeclaration(scanners[0].location(), compilationUnit);
/*     */     
/*     */     String[] methodNames;
/*     */     
/* 442 */     if (this.optionalMethodNames == null) {
/* 443 */       String[] methodNames = new String[count];
/* 444 */       for (int i = 0; i < count; i++) methodNames[i] = ("eval" + i);
/*     */     }
/*     */     else {
/* 447 */       methodNames = this.optionalMethodNames;
/*     */     }
/*     */     
/*     */ 
/* 451 */     for (int i = 0; i < count; i++) {
/* 452 */       Scanner scanner = scanners[i];
/*     */       
/* 454 */       List statements = makeStatements(i, scanner);
/*     */       
/*     */ 
/*     */ 
/* 458 */       boolean staticMethod = (this.optionalStaticMethod == null) || (this.optionalStaticMethod[i] != 0);
/* 459 */       Class returnType = this.optionalReturnTypes == null ? getDefaultReturnType() : this.optionalReturnTypes[i];
/*     */       
/*     */ 
/*     */ 
/*     */ 
/* 464 */       String[] parameterNames = this.optionalParameterNames == null ? new String[0] : this.optionalParameterNames[i];
/*     */       
/*     */ 
/*     */ 
/*     */ 
/* 469 */       Class[] parameterTypes = this.optionalParameterTypes == null ? new Class[0] : this.optionalParameterTypes[i];
/*     */       
/*     */ 
/*     */ 
/*     */ 
/* 474 */       Class[] thrownExceptions = this.optionalThrownExceptions == null ? new Class[0] : this.optionalThrownExceptions[i];
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 480 */       cd.addDeclaredMethod(makeMethodDeclaration(scanner.location(), staticMethod, returnType, methodNames[i], parameterTypes, parameterNames, thrownExceptions, statements));
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 493 */     Class c = compileToClass(compilationUnit, this.className);
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 499 */     this.result = new Method[count];
/* 500 */     if (count <= 10) {
/* 501 */       for (int i = 0; i < count; i++) {
/*     */         try {
/* 503 */           this.result[i] = c.getDeclaredMethod(methodNames[i], this.optionalParameterTypes == null ? new Class[0] : this.optionalParameterTypes[i]);
/*     */ 
/*     */         }
/*     */         catch (NoSuchMethodException ex)
/*     */         {
/* 508 */           throw new JaninoRuntimeException("SNO: Loaded class does not declare method \"" + methodNames[i] + "\"");
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */         }
/*     */         
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */       }
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     }
/*     */     else
/*     */     {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 543 */       Method[] ma = c.getDeclaredMethods();
/* 544 */       Map dms = new HashMap(2 * count);
/* 545 */       for (int i = 0; i < ma.length; i++) {
/* 546 */         Method m = ma[i];
/* 547 */         dms.put(new Object()
/*     */         {
/*     */           private final String name;
/*     */           private final Class[] parameterTypes;
/*     */           
/*     */           public boolean equals(Object o)
/*     */           {
/* 525 */             if (!(o instanceof 1MethodWrapper)) return false;
/* 526 */             1MethodWrapper that = (1MethodWrapper)o;
/* 527 */             if (!this.name.equals(that.name)) return false;
/* 528 */             int cnt = this.parameterTypes.length;
/* 529 */             if (cnt != that.parameterTypes.length) return false;
/* 530 */             for (int i = 0; i < cnt; i++) {
/* 531 */               if (!this.parameterTypes[i].equals(that.parameterTypes[i])) return false;
/*     */             }
/* 533 */             return true;
/*     */           }
/*     */           
/* 536 */           public int hashCode() { int hc = this.name.hashCode();
/* 537 */             for (int i = 0; i < this.parameterTypes.length; i++) {
/* 538 */               hc ^= this.parameterTypes[i].hashCode();
/*     */             }
/* 540 */             return hc;
/*     */ 
/*     */ 
/*     */           }
/*     */           
/*     */ 
/*     */ 
/* 547 */         }, m);
/*     */       }
/* 549 */       for (int i = 0; i < count; i++) {
/* 550 */         Method m = (Method)dms.get(new Object()
/*     */         {
/*     */           private final String name;
/*     */           private final Class[] parameterTypes;
/*     */           
/*     */           public boolean equals(Object o)
/*     */           {
/* 525 */             if (!(o instanceof 1MethodWrapper)) return false;
/* 526 */             1MethodWrapper that = (1MethodWrapper)o;
/* 527 */             if (!this.name.equals(that.name)) return false;
/* 528 */             int cnt = this.parameterTypes.length;
/* 529 */             if (cnt != that.parameterTypes.length) return false;
/* 530 */             for (int i = 0; i < cnt; i++) {
/* 531 */               if (!this.parameterTypes[i].equals(that.parameterTypes[i])) return false;
/*     */             }
/* 533 */             return true;
/*     */           }
/*     */           
/* 536 */           public int hashCode() { int hc = this.name.hashCode();
/* 537 */             for (int i = 0; i < this.parameterTypes.length; i++) {
/* 538 */               hc ^= this.parameterTypes[i].hashCode();
/*     */             }
/* 540 */             return hc;
/*     */           }
/*     */         });
/*     */         
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 554 */         if (m == null) {
/* 555 */           throw new JaninoRuntimeException("SNO: Loaded class does not declare method \"" + methodNames[i] + "\"");
/*     */         }
/*     */         
/*     */ 
/*     */ 
/*     */ 
/* 561 */         this.result[i] = m;
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   public final void cook(Reader[] readers) throws CompileException, IOException {
/* 567 */     cook(new String[readers.length], readers);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void cook(String[] optionalFileNames, Reader[] readers)
/*     */     throws CompileException, IOException
/*     */   {
/* 585 */     Scanner[] scanners = new Scanner[readers.length];
/* 586 */     for (int i = 0; i < readers.length; i++) {
/* 587 */       scanners[i] = new Scanner(optionalFileNames == null ? null : optionalFileNames[i], readers[i]);
/*     */     }
/* 589 */     cook(scanners);
/*     */   }
/*     */   
/*     */   public final void cook(String[] strings) throws CompileException {
/* 593 */     cook(null, strings);
/*     */   }
/*     */   
/*     */ 
/*     */   public final void cook(String[] optionalFileNames, String[] strings)
/*     */     throws CompileException
/*     */   {
/* 600 */     Reader[] readers = new Reader[strings.length];
/* 601 */     for (int i = 0; i < strings.length; i++) readers[i] = new StringReader(strings[i]);
/*     */     try {
/* 603 */       cook(optionalFileNames, readers);
/*     */     } catch (IOException ex) {
/* 605 */       throw new JaninoRuntimeException("SNO: IOException despite StringReader");
/*     */     }
/*     */   }
/*     */   
/*     */   protected Class getDefaultReturnType() {
/* 610 */     return Void.TYPE;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected List makeStatements(int idx, Scanner scanner)
/*     */     throws CompileException, IOException
/*     */   {
/* 621 */     List statements = new ArrayList();
/* 622 */     Parser parser = new Parser(scanner);
/* 623 */     while (!scanner.peek().isEOF()) {
/* 624 */       statements.add(parser.parseBlockStatement());
/*     */     }
/*     */     
/* 627 */     return statements;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected void compileToMethods(Java.CompilationUnit compilationUnit, String[] methodNames, Class[][] parameterTypes)
/*     */     throws CompileException
/*     */   {
/* 637 */     Class c = compileToClass(compilationUnit, this.className);
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 643 */     this.result = new Method[methodNames.length];
/* 644 */     for (int i = 0; i < this.result.length; i++) {
/*     */       try {
/* 646 */         this.result[i] = c.getMethod(methodNames[i], parameterTypes[i]);
/*     */       } catch (NoSuchMethodException ex) {
/* 648 */         throw new JaninoRuntimeException("SNO: Loaded class does not declare method \"" + this.optionalMethodNames[i] + "\"");
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected Java.MethodDeclarator makeMethodDeclaration(Location location, boolean staticMethod, Class returnType, String methodName, Class[] parameterTypes, String[] parameterNames, Class[] thrownExceptions, List statements)
/*     */   {
/* 677 */     if (parameterNames.length != parameterTypes.length) {
/* 678 */       throw new JaninoRuntimeException("Lengths of \"parameterNames\" (" + parameterNames.length + ") and \"parameterTypes\" (" + parameterTypes.length + ") do not match");
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 687 */     Java.FunctionDeclarator.FormalParameter[] fps = new Java.FunctionDeclarator.FormalParameter[parameterNames.length];
/*     */     
/*     */ 
/* 690 */     for (int i = 0; i < fps.length; i++) {
/* 691 */       fps[i] = new Java.FunctionDeclarator.FormalParameter(location, true, classToType(location, parameterTypes[i]), parameterNames[i]);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 699 */     return new Java.MethodDeclarator(location, null, (short)(staticMethod ? 9 : 1), classToType(location, returnType), methodName, fps, classesToTypes(location, thrownExceptions), statements);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public static Object createFastScriptEvaluator(String script, Class interfaceToImplement, String[] parameterNames)
/*     */     throws CompileException
/*     */   {
/* 724 */     ScriptEvaluator se = new ScriptEvaluator();
/* 725 */     return se.createFastEvaluator(script, interfaceToImplement, parameterNames);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public static Object createFastScriptEvaluator(Scanner scanner, Class interfaceToImplement, String[] parameterNames, ClassLoader optionalParentClassLoader)
/*     */     throws CompileException, IOException
/*     */   {
/* 738 */     ScriptEvaluator se = new ScriptEvaluator();
/* 739 */     se.setParentClassLoader(optionalParentClassLoader);
/* 740 */     return se.createFastEvaluator(scanner, interfaceToImplement, parameterNames);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public static Object createFastScriptEvaluator(Scanner scanner, String className, Class optionalExtendedType, Class interfaceToImplement, String[] parameterNames, ClassLoader optionalParentClassLoader)
/*     */     throws CompileException, IOException
/*     */   {
/* 755 */     ScriptEvaluator se = new ScriptEvaluator();
/* 756 */     se.setClassName(className);
/* 757 */     se.setExtendedClass(optionalExtendedType);
/* 758 */     se.setParentClassLoader(optionalParentClassLoader);
/* 759 */     return se.createFastEvaluator(scanner, interfaceToImplement, parameterNames);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public static Object createFastScriptEvaluator(Scanner scanner, String[] optionalDefaultImports, String className, Class optionalExtendedClass, Class interfaceToImplement, String[] parameterNames, ClassLoader optionalParentClassLoader)
/*     */     throws CompileException, IOException
/*     */   {
/* 785 */     ScriptEvaluator se = new ScriptEvaluator();
/* 786 */     se.setDefaultImports(optionalDefaultImports);
/* 787 */     se.setClassName(className);
/* 788 */     se.setExtendedClass(optionalExtendedClass);
/* 789 */     se.setParentClassLoader(optionalParentClassLoader);
/* 790 */     return se.createFastEvaluator(scanner, interfaceToImplement, parameterNames);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public final Object createInstance(Reader reader)
/*     */   {
/* 797 */     throw new UnsupportedOperationException("createInstance");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public Object createFastEvaluator(Reader reader, Class interfaceToImplement, String[] parameterNames)
/*     */     throws CompileException, IOException
/*     */   {
/* 805 */     return createFastEvaluator(new Scanner(null, reader), interfaceToImplement, parameterNames);
/*     */   }
/*     */   
/*     */ 
/*     */   public Object createFastEvaluator(String script, Class interfaceToImplement, String[] parameterNames)
/*     */     throws CompileException
/*     */   {
/*     */     try
/*     */     {
/* 814 */       return createFastEvaluator(new StringReader(script), interfaceToImplement, parameterNames);
/*     */ 
/*     */     }
/*     */     catch (IOException ex)
/*     */     {
/*     */ 
/* 820 */       throw new JaninoRuntimeException("IOException despite StringReader");
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Object createFastEvaluator(Scanner scanner, Class interfaceToImplement, String[] parameterNames)
/*     */     throws CompileException, IOException
/*     */   {
/* 837 */     if (!interfaceToImplement.isInterface()) {
/* 838 */       throw new JaninoRuntimeException("\"" + interfaceToImplement + "\" is not an interface");
/*     */     }
/*     */     
/* 841 */     Method[] methods = interfaceToImplement.getDeclaredMethods();
/* 842 */     if (methods.length != 1) {
/* 843 */       throw new JaninoRuntimeException("Interface \"" + interfaceToImplement + "\" must declare exactly one method");
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 849 */     Method methodToImplement = methods[0];
/*     */     
/* 851 */     setImplementedInterfaces(new Class[] { interfaceToImplement });
/* 852 */     setStaticMethod(false);
/* 853 */     setReturnType(methodToImplement.getReturnType());
/* 854 */     setMethodName(methodToImplement.getName());
/* 855 */     setParameters(parameterNames, methodToImplement.getParameterTypes());
/* 856 */     setThrownExceptions(methodToImplement.getExceptionTypes());
/* 857 */     cook(scanner);
/* 858 */     Class c = getMethod().getDeclaringClass();
/*     */     try {
/* 860 */       return c.newInstance();
/*     */     }
/*     */     catch (InstantiationException e) {
/* 863 */       throw new JaninoRuntimeException(e.toString());
/*     */     }
/*     */     catch (IllegalAccessException e) {
/* 866 */       throw new JaninoRuntimeException(e.toString());
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static String[] guessParameterNames(Scanner scanner)
/*     */     throws CompileException, IOException
/*     */   {
/* 887 */     Parser parser = new Parser(scanner);
/*     */     
/*     */ 
/* 890 */     while (scanner.peek().isKeyword("import")) { parser.parseImportDeclaration();
/*     */     }
/*     */     
/* 893 */     Java.Block block = new Java.Block(scanner.location());
/* 894 */     while (!scanner.peek().isEOF()) { block.addStatement(parser.parseBlockStatement());
/*     */     }
/*     */     
/* 897 */     Set localVariableNames = new HashSet();
/* 898 */     Set parameterNames = new HashSet();
/* 899 */     new Traverser() { private final Set val$localVariableNames;
/*     */       
/* 901 */       public void traverseLocalVariableDeclarationStatement(Java.LocalVariableDeclarationStatement lvds) { for (int i = 0; i < lvds.variableDeclarators.length; i++) {
/* 902 */           this.val$localVariableNames.add(lvds.variableDeclarators[i].name);
/*     */         }
/* 904 */         super.traverseLocalVariableDeclarationStatement(lvds);
/*     */       }
/*     */       
/*     */ 
/*     */       private final Set val$parameterNames;
/*     */       public void traverseAmbiguousName(Java.AmbiguousName an)
/*     */       {
/* 911 */         for (int i = 0; i < an.identifiers.length; i++) {
/* 912 */           if (Character.isUpperCase(an.identifiers[i].charAt(0))) { return;
/*     */           }
/*     */         }
/*     */         
/* 916 */         if (this.val$localVariableNames.contains(an.identifiers[0])) { return;
/*     */         }
/*     */         
/* 919 */         this.val$parameterNames.add(an.identifiers[0]); } }.traverseBlock(block);
/*     */     
/*     */ 
/*     */ 
/* 923 */     return (String[])parameterNames.toArray(new String[parameterNames.size()]);
/*     */   }
/*     */   
/*     */   public Object evaluate(int idx, Object[] arguments) throws InvocationTargetException {
/* 927 */     if (this.result == null) throw new IllegalStateException("Must only be called after \"cook()\"");
/*     */     try {
/* 929 */       return this.result[idx].invoke(null, arguments);
/*     */     } catch (IllegalAccessException ex) {
/* 931 */       throw new JaninoRuntimeException(ex.toString());
/*     */     }
/*     */   }
/*     */   
/*     */   public Method getMethod(int idx) {
/* 936 */     if (this.result == null) throw new IllegalStateException("Must only be called after \"cook()\"");
/* 937 */     return this.result[idx];
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\ScriptEvaluator.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */