/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.roles;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.dto.authority.RolesListWrapper;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*    */ import javax.ws.rs.core.MultivaluedHashMap;
/*    */ import javax.ws.rs.core.MultivaluedMap;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class BatchRolesRequestAdapter
/*    */   extends AbstractAdapter
/*    */ {
/*    */   private final MultivaluedMap<String, String> params;
/*    */   private final String uri;
/*    */   
/*    */   public BatchRolesRequestAdapter(SessionStorage sessionStorage, String organizationId)
/*    */   {
/* 41 */     super(sessionStorage);
/* 42 */     this.params = new MultivaluedHashMap();
/* 43 */     if (organizationId != null) {
/* 44 */       this.uri = ("/organizations/" + organizationId + "/roles");
/*    */     } else {
/* 46 */       this.uri = "/roles";
/*    */     }
/*    */   }
/*    */   
/*    */   public BatchRolesRequestAdapter param(RolesParameter rolesParam, String value) {
/* 51 */     this.params.add(rolesParam.getParamName(), value);
/* 52 */     return this;
/*    */   }
/*    */   
/*    */   public OperationResult<RolesListWrapper> get() {
/* 56 */     JerseyRequest<RolesListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, RolesListWrapper.class, new String[] { this.uri }, new DefaultErrorHandler());
/* 57 */     request.addParams(this.params);
/* 58 */     return request.get();
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncGet(final Callback<OperationResult<RolesListWrapper>, R> callback) {
/* 62 */     final JerseyRequest<RolesListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, RolesListWrapper.class, new String[] { this.uri }, new DefaultErrorHandler());
/* 63 */     request.addParams(this.params);
/* 64 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 67 */         callback.execute(request.get());
/*    */       }
/* 69 */     });
/* 70 */     ThreadPoolUtil.runAsynchronously(task);
/* 71 */     return task;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\authority\roles\BatchRolesRequestAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */