/*    */ package com.netapp.asup.data.function;
/*    */ 
/*    */ import com.netapp.asup.client.arma.ARMAObject;
/*    */ import com.netapp.asup.client.arma.data.ARMAObjectInstanceIterator;
/*    */ import com.netapp.asup.exception.ARMAException;
/*    */ import com.netapp.asup.util.StringUtils;
/*    */ import java.util.LinkedHashSet;
/*    */ import java.util.Map;
/*    */ import java.util.Set;
/*    */ 
/*    */ 
/*    */ public class PathResultOutput
/*    */ {
/*    */   private Map<String, Set<ResultOutputField>> pathVsFilterOutput;
/*    */   
/*    */   public PathResultOutput(Map<String, Set<ResultOutputField>> pathVsFilterOutput)
/*    */   {
/* 18 */     this.pathVsFilterOutput = pathVsFilterOutput;
/*    */   }
/*    */   
/*    */   public ARMAObjectInstanceIterator getIterator(ARMAObject object, String path) throws ARMAException
/*    */   {
/* 23 */     if (StringUtils.isEmpty(path)) {
/* 24 */       throw new IllegalArgumentException("Path cannot be null or empty:" + path);
/*    */     }
/*    */     
/* 27 */     if (null == object) {
/* 28 */       throw new IllegalArgumentException("Source object cannot be null:" + object);
/*    */     }
/*    */     
/*    */ 
/* 32 */     Set<ResultOutputField> outputList = (Set)this.pathVsFilterOutput.get(path);
/*    */     
/* 34 */     if (null == outputList)
/*    */     {
/* 36 */       outputList = new LinkedHashSet();
/*    */     }
/*    */     
/*    */ 
/* 40 */     String[] split = path.split("/");
/* 41 */     ARMAObject jumpToNode = object.jumpToNode(split[(split.length - 1)]);
/*    */     
/* 43 */     return new ResultInstanceIterator(jumpToNode, outputList);
/*    */   }
/*    */   
/*    */   public String toString()
/*    */   {
/* 48 */     return "FilterOutput [pathVsFilterOutput=" + this.pathVsFilterOutput + "]";
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\function\PathResultOutput.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */