/*    */ package com.netapp.asup.data.function.sort;
/*    */ 
/*    */ import com.netapp.asup.client.arma.data.ARMAObjectInstance;
/*    */ import com.netapp.asup.data.function.Function;
/*    */ import com.netapp.asup.data.function.aggregation.ARMAPathInstanceIterator;
/*    */ import com.netapp.asupdata.client.ARMA.ARMAObjectInstanceImpl;
/*    */ import java.util.ArrayList;
/*    */ import java.util.Collections;
/*    */ import java.util.HashMap;
/*    */ import java.util.List;
/*    */ import java.util.Map;
/*    */ import org.apache.avro.Schema;
/*    */ import org.apache.avro.Schema.Field;
/*    */ import org.apache.avro.generic.GenericData.Array;
/*    */ import org.apache.avro.generic.GenericData.Record;
/*    */ import org.apache.avro.generic.GenericRecord;
/*    */ import org.apache.avro.util.Utf8;
/*    */ 
/*    */ 
/*    */ 
/*    */ public class SortFunction
/*    */   implements Function
/*    */ {
/*    */   private static final String SORT_OUTPUT = "sortOutput";
/*    */   private static final String SORT_INPUT = "sortInput";
/*    */   
/*    */   public GenericRecord execute(ARMAObjectInstance instance, GenericRecord input, Schema outputSchema)
/*    */     throws Exception
/*    */   {
/* 30 */     Map<Utf8, GenericData.Array<GenericRecord>> inputMap = (Map)input.get("sortInput");
/*    */     
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/* 38 */     Map<Utf8, GenericData.Array<GenericRecord>> outputMap = new HashMap();
/*    */     
/* 40 */     for (Utf8 key : inputMap.keySet())
/*    */     {
/* 42 */       ARMAPathInstanceIterator armaPathInstanceIterator = new ARMAPathInstanceIterator(instance, key.toString().split("/"));
/*    */       
/*    */ 
/* 45 */       List<ARMAObjectInstanceImpl> instances = new ArrayList();
/* 46 */       while (armaPathInstanceIterator.hasNext()) {
/* 47 */         instances.add((ARMAObjectInstanceImpl)armaPathInstanceIterator.next());
/*    */       }
/*    */       
/*    */ 
/* 51 */       GenericData.Array<GenericRecord> sortFields = (GenericData.Array)inputMap.get(key);
/*    */       
/* 53 */       PathComparator pathComparator = new PathComparator(sortFields);
/*    */       
/* 55 */       Collections.sort(instances, pathComparator);
/*    */       
/* 57 */       outputMap.put(key, getOutputInstances(instances, outputSchema));
/*    */     }
/*    */     
/* 60 */     GenericRecord output = new GenericData.Record(outputSchema);
/* 61 */     output.put("sortOutput", outputMap);
/*    */     
/* 63 */     return output;
/*    */   }
/*    */   
/*    */ 
/*    */   private GenericData.Array<GenericRecord> getOutputInstances(List<ARMAObjectInstanceImpl> instances, Schema outputSchema)
/*    */   {
/* 69 */     Schema sortOutputArray = outputSchema.getField("sortOutput").schema().getValueType();
/*    */     
/*    */ 
/* 72 */     GenericData.Array<GenericRecord> sortOutputRecord = new GenericData.Array(instances.size(), sortOutputArray);
/*    */     
/*    */ 
/* 75 */     for (ARMAObjectInstanceImpl armaObjectInstance : instances)
/*    */     {
/* 77 */       GenericRecord filterOutputRecord = new GenericData.Record(sortOutputArray.getElementType());
/*    */       
/* 79 */       filterOutputRecord.put("systemId", armaObjectInstance.getSystemId());
/*    */       
/* 81 */       filterOutputRecord.put("instanceKey", armaObjectInstance.getInstanceKey());
/*    */       
/* 83 */       sortOutputRecord.add(filterOutputRecord);
/*    */     }
/* 85 */     return sortOutputRecord;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\function\sort\SortFunction.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */