/*    */ package com.sun.xml.bind.v2.model.impl;
/*    */ 
/*    */ import com.sun.xml.bind.v2.model.core.MapPropertyInfo;
/*    */ import com.sun.xml.bind.v2.model.core.NonElement;
/*    */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*    */ import com.sun.xml.bind.v2.model.core.TypeInfo;
/*    */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*    */ import java.util.Arrays;
/*    */ import java.util.Collection;
/*    */ import java.util.Map;
/*    */ import javax.xml.bind.annotation.XmlElementWrapper;
/*    */ import javax.xml.namespace.QName;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ class MapPropertyInfoImpl<T, C, F, M>
/*    */   extends PropertyInfoImpl<T, C, F, M>
/*    */   implements MapPropertyInfo<T, C>
/*    */ {
/*    */   private final QName xmlName;
/*    */   private boolean nil;
/*    */   private final T keyType;
/*    */   private final T valueType;
/*    */   private NonElement<T, C> keyTypeInfo;
/*    */   private NonElement<T, C> valueTypeInfo;
/*    */   
/*    */   public MapPropertyInfoImpl(ClassInfoImpl<T, C, F, M> ci, PropertySeed<T, C, F, M> seed)
/*    */   {
/* 31 */     super(ci, seed);
/*    */     
/* 33 */     XmlElementWrapper xe = (XmlElementWrapper)seed.readAnnotation(XmlElementWrapper.class);
/* 34 */     this.xmlName = calcXmlName(xe);
/* 35 */     this.nil = ((xe != null) && (xe.nillable()));
/*    */     
/* 37 */     T raw = getRawType();
/* 38 */     T bt = nav().getBaseClass(raw, nav().asDecl(Map.class));
/* 39 */     assert (bt != null);
/*    */     
/* 41 */     if (nav().isParameterizedType(bt)) {
/* 42 */       this.keyType = nav().getTypeArgument(bt, 0);
/* 43 */       this.valueType = nav().getTypeArgument(bt, 1);
/*    */     } else {
/* 45 */       this.keyType = (this.valueType = nav().ref(Object.class));
/*    */     }
/*    */   }
/*    */   
/*    */   public Collection<? extends TypeInfo<T, C>> ref() {
/* 50 */     return Arrays.asList(new NonElement[] { getKeyType(), getValueType() });
/*    */   }
/*    */   
/*    */   public final PropertyKind kind() {
/* 54 */     return PropertyKind.MAP;
/*    */   }
/*    */   
/*    */   public QName getXmlName() {
/* 58 */     return this.xmlName;
/*    */   }
/*    */   
/*    */   public boolean isCollectionNillable() {
/* 62 */     return this.nil;
/*    */   }
/*    */   
/*    */   public NonElement<T, C> getKeyType() {
/* 66 */     if (this.keyTypeInfo == null)
/* 67 */       this.keyTypeInfo = getTarget(this.keyType);
/* 68 */     return this.keyTypeInfo;
/*    */   }
/*    */   
/*    */   public NonElement<T, C> getValueType() {
/* 72 */     if (this.valueTypeInfo == null)
/* 73 */       this.valueTypeInfo = getTarget(this.valueType);
/* 74 */     return this.valueTypeInfo;
/*    */   }
/*    */   
/*    */   public NonElement<T, C> getTarget(T type) {
/* 78 */     assert (this.parent.builder != null) : "this method must be called during the build stage";
/* 79 */     return this.parent.builder.getTypeInfo(type, this);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\impl\MapPropertyInfoImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */