/*    */ package com.sun.xml.bind.v2.runtime.output;
/*    */ 
/*    */ import com.sun.xml.bind.v2.runtime.Name;
/*    */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*    */ import java.io.IOException;
/*    */ import javax.xml.stream.XMLStreamException;
/*    */ import org.xml.sax.SAXException;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public final class ForkXmlOutput
/*    */   extends XmlOutputAbstractImpl
/*    */ {
/*    */   private final XmlOutput lhs;
/*    */   private final XmlOutput rhs;
/*    */   
/*    */   public ForkXmlOutput(XmlOutput lhs, XmlOutput rhs)
/*    */   {
/* 21 */     this.lhs = lhs;
/* 22 */     this.rhs = rhs;
/*    */   }
/*    */   
/*    */   public void startDocument(XMLSerializer serializer, boolean fragment, int[] nsUriIndex2prefixIndex, NamespaceContextImpl nsContext) throws IOException, SAXException, XMLStreamException
/*    */   {
/* 27 */     this.lhs.startDocument(serializer, fragment, nsUriIndex2prefixIndex, nsContext);
/* 28 */     this.rhs.startDocument(serializer, fragment, nsUriIndex2prefixIndex, nsContext);
/*    */   }
/*    */   
/*    */   public void endDocument(boolean fragment) throws IOException, SAXException, XMLStreamException
/*    */   {
/* 33 */     this.lhs.endDocument(fragment);
/* 34 */     this.rhs.endDocument(fragment);
/*    */   }
/*    */   
/*    */   public void beginStartTag(Name name) throws IOException, XMLStreamException
/*    */   {
/* 39 */     this.lhs.beginStartTag(name);
/* 40 */     this.rhs.beginStartTag(name);
/*    */   }
/*    */   
/*    */   public void attribute(Name name, String value) throws IOException, XMLStreamException
/*    */   {
/* 45 */     this.lhs.attribute(name, value);
/* 46 */     this.rhs.attribute(name, value);
/*    */   }
/*    */   
/*    */   public void endTag(Name name) throws IOException, SAXException, XMLStreamException
/*    */   {
/* 51 */     this.lhs.endTag(name);
/* 52 */     this.rhs.endTag(name);
/*    */   }
/*    */   
/*    */   public void flush() throws IOException, XMLStreamException
/*    */   {
/* 57 */     this.lhs.flush();
/* 58 */     this.rhs.flush();
/*    */   }
/*    */   
/*    */   public void beginStartTag(int prefix, String localName) throws IOException, XMLStreamException {
/* 62 */     this.lhs.beginStartTag(prefix, localName);
/* 63 */     this.rhs.beginStartTag(prefix, localName);
/*    */   }
/*    */   
/*    */   public void attribute(int prefix, String localName, String value) throws IOException, XMLStreamException {
/* 67 */     this.lhs.attribute(prefix, localName, value);
/* 68 */     this.rhs.attribute(prefix, localName, value);
/*    */   }
/*    */   
/*    */   public void endStartTag() throws IOException, SAXException {
/* 72 */     this.lhs.endStartTag();
/* 73 */     this.rhs.endStartTag();
/*    */   }
/*    */   
/*    */   public void endTag(int prefix, String localName) throws IOException, SAXException, XMLStreamException {
/* 77 */     this.lhs.endTag(prefix, localName);
/* 78 */     this.rhs.endTag(prefix, localName);
/*    */   }
/*    */   
/*    */   public void text(String value, boolean needsSeparatingWhitespace) throws IOException, SAXException, XMLStreamException {
/* 82 */     this.lhs.text(value, needsSeparatingWhitespace);
/* 83 */     this.rhs.text(value, needsSeparatingWhitespace);
/*    */   }
/*    */   
/*    */   public void text(Pcdata value, boolean needsSeparatingWhitespace) throws IOException, SAXException, XMLStreamException {
/* 87 */     this.lhs.text(value, needsSeparatingWhitespace);
/* 88 */     this.rhs.text(value, needsSeparatingWhitespace);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\output\ForkXmlOutput.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */