/*    */ package com.sun.xml.bind.v2.runtime.reflect;
/*    */ 
/*    */ import com.sun.xml.bind.api.AccessorException;
/*    */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*    */ import java.util.Map;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ final class PrimitiveArrayListerByte<BeanT>
/*    */   extends Lister<BeanT, byte[], Byte, ByteArrayPack>
/*    */ {
/*    */   static void register()
/*    */   {
/* 19 */     Lister.primitiveArrayListers.put(Byte.TYPE, new PrimitiveArrayListerByte());
/*    */   }
/*    */   
/*    */   public ListIterator<Byte> iterator(final byte[] objects, XMLSerializer context) {
/* 23 */     new ListIterator() {
/* 24 */       int idx = 0;
/*    */       
/* 26 */       public boolean hasNext() { return this.idx < objects.length; }
/*    */       
/*    */       public Byte next()
/*    */       {
/* 30 */         return Byte.valueOf(objects[(this.idx++)]);
/*    */       }
/*    */     };
/*    */   }
/*    */   
/*    */   public ByteArrayPack startPacking(BeanT current, Accessor<BeanT, byte[]> acc) {
/* 36 */     return new ByteArrayPack();
/*    */   }
/*    */   
/*    */   public void addToPack(ByteArrayPack objects, Byte o) {
/* 40 */     objects.add(o);
/*    */   }
/*    */   
/*    */   public void endPacking(ByteArrayPack pack, BeanT bean, Accessor<BeanT, byte[]> acc) throws AccessorException {
/* 44 */     acc.set(bean, pack.build());
/*    */   }
/*    */   
/*    */   public void reset(BeanT o, Accessor<BeanT, byte[]> acc) throws AccessorException {
/* 48 */     acc.set(o, new byte[0]);
/*    */   }
/*    */   
/*    */   static final class ByteArrayPack {
/* 52 */     byte[] buf = new byte[16];
/*    */     int size;
/*    */     
/*    */     void add(Byte b) {
/* 56 */       if (this.buf.length == this.size)
/*    */       {
/* 58 */         byte[] nb = new byte[this.buf.length * 2];
/* 59 */         System.arraycopy(this.buf, 0, nb, 0, this.buf.length);
/* 60 */         this.buf = nb;
/*    */       }
/* 62 */       this.buf[(this.size++)] = b.byteValue();
/*    */     }
/*    */     
/*    */     byte[] build() {
/* 66 */       if (this.buf.length == this.size)
/*    */       {
/* 68 */         return this.buf;
/*    */       }
/* 70 */       byte[] r = new byte[this.size];
/* 71 */       System.arraycopy(this.buf, 0, r, 0, this.size);
/* 72 */       return r;
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\PrimitiveArrayListerByte.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */