/*     */ package com.sun.xml.bind.v2.util;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class EditDistance
/*     */ {
/*     */   private int[] cost;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private int[] back;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private final String a;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private final String b;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static int editDistance(String a, String b)
/*     */   {
/*  45 */     return new EditDistance(a, b).calc();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static String findNearest(String key, String[] group)
/*     */   {
/*  55 */     int c = Integer.MAX_VALUE;
/*  56 */     String r = null;
/*     */     
/*  58 */     for (int i = 0; i < group.length; i++) {
/*  59 */       int ed = editDistance(key, group[i]);
/*  60 */       if (c > ed) {
/*  61 */         c = ed;
/*  62 */         r = group[i];
/*     */       }
/*     */     }
/*  65 */     return r;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private EditDistance(String a, String b)
/*     */   {
/*  77 */     this.a = a;
/*  78 */     this.b = b;
/*  79 */     this.cost = new int[a.length() + 1];
/*  80 */     this.back = new int[a.length() + 1];
/*     */     
/*  82 */     for (int i = 0; i <= a.length(); i++) {
/*  83 */       this.cost[i] = i;
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   private void flip()
/*     */   {
/*  90 */     int[] t = this.cost;
/*  91 */     this.cost = this.back;
/*  92 */     this.back = t;
/*     */   }
/*     */   
/*     */   private int min(int a, int b, int c) {
/*  96 */     return Math.min(a, Math.min(b, c));
/*     */   }
/*     */   
/*     */   private int calc() {
/* 100 */     for (int j = 0; j < this.b.length(); j++) {
/* 101 */       flip();
/* 102 */       this.cost[0] = (j + 1);
/* 103 */       for (int i = 0; i < this.a.length(); i++) {
/* 104 */         int match = this.a.charAt(i) == this.b.charAt(j) ? 0 : 1;
/* 105 */         this.cost[(i + 1)] = min(this.back[i] + match, this.cost[i] + 1, this.back[(i + 1)] + 1);
/*     */       }
/*     */     }
/* 108 */     return this.cost[this.a.length()];
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\util\EditDistance.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */