/*    */ package net.rubyeye.xmemcached;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import java.net.InetSocketAddress;
/*    */ import java.util.Collection;
/*    */ import java.util.List;
/*    */ import java.util.Map;
/*    */ import java.util.Queue;
/*    */ import java.util.concurrent.TimeoutException;
/*    */ import net.rubyeye.xmemcached.auth.AuthInfo;
/*    */ import net.rubyeye.xmemcached.buffer.BufferAllocator;
/*    */ import net.rubyeye.xmemcached.exception.MemcachedException;
/*    */ import net.rubyeye.xmemcached.impl.ReconnectRequest;
/*    */ import net.rubyeye.xmemcached.networking.Connector;
/*    */ import net.rubyeye.xmemcached.transcoders.Transcoder;
/*    */ import net.rubyeye.xmemcached.utils.Protocol;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public abstract interface MemcachedClient
/*    */ {
/*    */   public static final int DEFAULT_READ_THREAD_COUNT = 0;
/*    */   public static final boolean DEFAULT_TCP_KEEPLIVE = true;
/*    */   public static final int DEFAULT_CONNECT_TIMEOUT = 60000;
/*    */   public static final int DEFAULT_TCP_SEND_BUFF_SIZE = 32768;
/*    */   public static final boolean DEFAULT_TCP_NO_DELAY = true;
/*    */   public static final int DEFAULT_SESSION_READ_BUFF_SIZE = 131072;
/*    */   public static final int DEFAULT_TCP_RECV_BUFF_SIZE = 65536;
/*    */   public static final long DEFAULT_OP_TIMEOUT = 5000L;
/*    */   public static final int DEFAULT_CONNECTION_POOL_SIZE = 1;
/*    */   public static final int DEFAULT_SESSION_IDLE_TIMEOUT = 5000;
/*    */   public static final int MAX_QUEUED_NOPS = 40000;
/* 83 */   public static final int DYNAMIC_MAX_QUEUED_NOPS = (int)(40000.0D * (Runtime.getRuntime().maxMemory() / 1024.0D / 1024.0D / 1024.0D));
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/* 92 */   public static final int DEFAULT_MAX_QUEUED_NOPS = DYNAMIC_MAX_QUEUED_NOPS > 40000 ? 40000 : DYNAMIC_MAX_QUEUED_NOPS;
/*    */   
/*    */   public abstract void setMergeFactor(int paramInt);
/*    */   
/*    */   public abstract long getConnectTimeout();
/*    */   
/*    */   public abstract void setConnectTimeout(long paramLong);
/*    */   
/*    */   public abstract Connector getConnector();
/*    */   
/*    */   public abstract void setOptimizeGet(boolean paramBoolean);
/*    */   
/*    */   public abstract void setOptimizeMergeBuffer(boolean paramBoolean);
/*    */   
/*    */   public abstract boolean isShutdown();
/*    */   
/*    */   public abstract void addServer(String paramString, int paramInt)
/*    */     throws IOException;
/*    */   
/*    */   public abstract void addServer(InetSocketAddress paramInetSocketAddress)
/*    */     throws IOException;
/*    */   
/*    */   public abstract void addServer(String paramString)
/*    */     throws IOException;
/*    */   
/*    */   public abstract List<String> getServersDescription();
/*    */   
/*    */   public abstract void removeServer(String paramString);
/*    */   
/*    */   @Deprecated
/*    */   public abstract void setBufferAllocator(BufferAllocator paramBufferAllocator);
/*    */   
/*    */   public abstract <T> T get(String paramString, long paramLong, Transcoder<T> paramTranscoder)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> T get(String paramString, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> T get(String paramString, Transcoder<T> paramTranscoder)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> T get(String paramString)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> GetsResponse<T> gets(String paramString, long paramLong, Transcoder<T> paramTranscoder)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> GetsResponse<T> gets(String paramString)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> GetsResponse<T> gets(String paramString, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> GetsResponse<T> gets(String paramString, Transcoder paramTranscoder)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> Map<String, T> get(Collection<String> paramCollection, long paramLong, Transcoder<T> paramTranscoder)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> Map<String, T> get(Collection<String> paramCollection, Transcoder<T> paramTranscoder)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> Map<String, T> get(Collection<String> paramCollection)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> Map<String, T> get(Collection<String> paramCollection, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> Map<String, GetsResponse<T>> gets(Collection<String> paramCollection, long paramLong, Transcoder<T> paramTranscoder)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> Map<String, GetsResponse<T>> gets(Collection<String> paramCollection)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> Map<String, GetsResponse<T>> gets(Collection<String> paramCollection, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> Map<String, GetsResponse<T>> gets(Collection<String> paramCollection, Transcoder<T> paramTranscoder)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> boolean set(String paramString, int paramInt, T paramT, Transcoder<T> paramTranscoder, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract boolean set(String paramString, int paramInt, Object paramObject)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract boolean set(String paramString, int paramInt, Object paramObject, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> boolean set(String paramString, int paramInt, T paramT, Transcoder<T> paramTranscoder)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void setWithNoReply(String paramString, int paramInt, Object paramObject)
/*    */     throws InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> void setWithNoReply(String paramString, int paramInt, T paramT, Transcoder<T> paramTranscoder)
/*    */     throws InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> boolean add(String paramString, int paramInt, T paramT, Transcoder<T> paramTranscoder, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract boolean add(String paramString, int paramInt, Object paramObject)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract boolean add(String paramString, int paramInt, Object paramObject, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> boolean add(String paramString, int paramInt, T paramT, Transcoder<T> paramTranscoder)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void addWithNoReply(String paramString, int paramInt, Object paramObject)
/*    */     throws InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> void addWithNoReply(String paramString, int paramInt, T paramT, Transcoder<T> paramTranscoder)
/*    */     throws InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> boolean replace(String paramString, int paramInt, T paramT, Transcoder<T> paramTranscoder, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract boolean replace(String paramString, int paramInt, Object paramObject)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract boolean replace(String paramString, int paramInt, Object paramObject, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> boolean replace(String paramString, int paramInt, T paramT, Transcoder<T> paramTranscoder)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void replaceWithNoReply(String paramString, int paramInt, Object paramObject)
/*    */     throws InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> void replaceWithNoReply(String paramString, int paramInt, T paramT, Transcoder<T> paramTranscoder)
/*    */     throws InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract boolean append(String paramString, Object paramObject)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract boolean append(String paramString, Object paramObject, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void appendWithNoReply(String paramString, Object paramObject)
/*    */     throws InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract boolean prepend(String paramString, Object paramObject)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract boolean prepend(String paramString, Object paramObject, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void prependWithNoReply(String paramString, Object paramObject)
/*    */     throws InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract boolean cas(String paramString, int paramInt, Object paramObject, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> boolean cas(String paramString, int paramInt, T paramT, Transcoder<T> paramTranscoder, long paramLong1, long paramLong2)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract boolean cas(String paramString, int paramInt, Object paramObject, long paramLong1, long paramLong2)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> boolean cas(String paramString, int paramInt, T paramT, Transcoder<T> paramTranscoder, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> boolean cas(String paramString, int paramInt, CASOperation<T> paramCASOperation, Transcoder<T> paramTranscoder)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> boolean cas(String paramString, int paramInt, GetsResponse<T> paramGetsResponse, CASOperation<T> paramCASOperation, Transcoder<T> paramTranscoder)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> boolean cas(String paramString, int paramInt, GetsResponse<T> paramGetsResponse, CASOperation<T> paramCASOperation)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> boolean cas(String paramString, GetsResponse<T> paramGetsResponse, CASOperation<T> paramCASOperation)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> boolean cas(String paramString, int paramInt, CASOperation<T> paramCASOperation)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> boolean cas(String paramString, CASOperation<T> paramCASOperation)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> void casWithNoReply(String paramString, GetsResponse<T> paramGetsResponse, CASOperation<T> paramCASOperation)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> void casWithNoReply(String paramString, int paramInt, GetsResponse<T> paramGetsResponse, CASOperation<T> paramCASOperation)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> void casWithNoReply(String paramString, int paramInt, CASOperation<T> paramCASOperation)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> void casWithNoReply(String paramString, CASOperation<T> paramCASOperation)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   @Deprecated
/*    */   public abstract boolean delete(String paramString, int paramInt)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract boolean delete(String paramString, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract boolean touch(String paramString, int paramInt, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract boolean touch(String paramString, int paramInt)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> T getAndTouch(String paramString, int paramInt, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract <T> T getAndTouch(String paramString, int paramInt)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract Map<InetSocketAddress, String> getVersions()
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract long incr(String paramString, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract long incr(String paramString, long paramLong1, long paramLong2)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract long incr(String paramString, long paramLong1, long paramLong2, long paramLong3)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract long decr(String paramString, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract long decr(String paramString, long paramLong1, long paramLong2)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract long decr(String paramString, long paramLong1, long paramLong2, long paramLong3)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void flushAll()
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void flushAllWithNoReply()
/*    */     throws InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void flushAll(long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void flushAll(InetSocketAddress paramInetSocketAddress)
/*    */     throws MemcachedException, InterruptedException, TimeoutException;
/*    */   
/*    */   public abstract void flushAllWithNoReply(InetSocketAddress paramInetSocketAddress)
/*    */     throws MemcachedException, InterruptedException;
/*    */   
/*    */   public abstract void flushAll(InetSocketAddress paramInetSocketAddress, long paramLong)
/*    */     throws MemcachedException, InterruptedException, TimeoutException;
/*    */   
/*    */   @Deprecated
/*    */   public abstract void flushAll(String paramString)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract Map<String, String> stats(InetSocketAddress paramInetSocketAddress)
/*    */     throws MemcachedException, InterruptedException, TimeoutException;
/*    */   
/*    */   public abstract Map<String, String> stats(InetSocketAddress paramInetSocketAddress, long paramLong)
/*    */     throws MemcachedException, InterruptedException, TimeoutException;
/*    */   
/*    */   public abstract Map<InetSocketAddress, Map<String, String>> getStats(long paramLong)
/*    */     throws MemcachedException, InterruptedException, TimeoutException;
/*    */   
/*    */   public abstract Map<InetSocketAddress, Map<String, String>> getStats()
/*    */     throws MemcachedException, InterruptedException, TimeoutException;
/*    */   
/*    */   public abstract Map<InetSocketAddress, Map<String, String>> getStatsByItem(String paramString)
/*    */     throws MemcachedException, InterruptedException, TimeoutException;
/*    */   
/*    */   public abstract void shutdown()
/*    */     throws IOException;
/*    */   
/*    */   public abstract boolean delete(String paramString)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract Transcoder getTranscoder();
/*    */   
/*    */   public abstract void setTranscoder(Transcoder paramTranscoder);
/*    */   
/*    */   public abstract Map<InetSocketAddress, Map<String, String>> getStatsByItem(String paramString, long paramLong)
/*    */     throws MemcachedException, InterruptedException, TimeoutException;
/*    */   
/*    */   public abstract long getOpTimeout();
/*    */   
/*    */   public abstract void setOpTimeout(long paramLong);
/*    */   
/*    */   public abstract Map<InetSocketAddress, String> getVersions(long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   @Deprecated
/*    */   public abstract Collection<InetSocketAddress> getAvaliableServers();
/*    */   
/*    */   public abstract Collection<InetSocketAddress> getAvailableServers();
/*    */   
/*    */   public abstract void addServer(String paramString, int paramInt1, int paramInt2)
/*    */     throws IOException;
/*    */   
/*    */   public abstract void addServer(InetSocketAddress paramInetSocketAddress, int paramInt)
/*    */     throws IOException;
/*    */   
/*    */   @Deprecated
/*    */   public abstract void deleteWithNoReply(String paramString, int paramInt)
/*    */     throws InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void deleteWithNoReply(String paramString)
/*    */     throws InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void incrWithNoReply(String paramString, long paramLong)
/*    */     throws InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void decrWithNoReply(String paramString, long paramLong)
/*    */     throws InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void setLoggingLevelVerbosity(InetSocketAddress paramInetSocketAddress, int paramInt)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void setLoggingLevelVerbosityWithNoReply(InetSocketAddress paramInetSocketAddress, int paramInt)
/*    */     throws InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void addStateListener(MemcachedClientStateListener paramMemcachedClientStateListener);
/*    */   
/*    */   public abstract void removeStateListener(MemcachedClientStateListener paramMemcachedClientStateListener);
/*    */   
/*    */   public abstract Collection<MemcachedClientStateListener> getStateListeners();
/*    */   
/*    */   public abstract void flushAllWithNoReply(int paramInt)
/*    */     throws InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void flushAll(int paramInt, long paramLong)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract void flushAllWithNoReply(InetSocketAddress paramInetSocketAddress, int paramInt)
/*    */     throws MemcachedException, InterruptedException;
/*    */   
/*    */   public abstract void flushAll(InetSocketAddress paramInetSocketAddress, long paramLong, int paramInt)
/*    */     throws MemcachedException, InterruptedException, TimeoutException;
/*    */   
/*    */   public abstract void setHealSessionInterval(long paramLong);
/*    */   
/*    */   public abstract long getHealSessionInterval();
/*    */   
/*    */   public abstract Protocol getProtocol();
/*    */   
/*    */   public abstract void setPrimitiveAsString(boolean paramBoolean);
/*    */   
/*    */   public abstract void setConnectionPoolSize(int paramInt);
/*    */   
/*    */   public abstract void setEnableHeartBeat(boolean paramBoolean);
/*    */   
/*    */   public abstract void setSanitizeKeys(boolean paramBoolean);
/*    */   
/*    */   public abstract boolean isSanitizeKeys();
/*    */   
/*    */   public abstract Counter getCounter(String paramString);
/*    */   
/*    */   public abstract Counter getCounter(String paramString, long paramLong);
/*    */   
/*    */   @Deprecated
/*    */   public abstract KeyIterator getKeyIterator(InetSocketAddress paramInetSocketAddress)
/*    */     throws MemcachedException, InterruptedException, TimeoutException;
/*    */   
/*    */   public abstract void setAuthInfoMap(Map<InetSocketAddress, AuthInfo> paramMap);
/*    */   
/*    */   public abstract Map<InetSocketAddress, AuthInfo> getAuthInfoMap();
/*    */   
/*    */   public abstract long decr(String paramString, long paramLong1, long paramLong2, long paramLong3, int paramInt)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract long incr(String paramString, long paramLong1, long paramLong2, long paramLong3, int paramInt)
/*    */     throws TimeoutException, InterruptedException, MemcachedException;
/*    */   
/*    */   public abstract String getName();
/*    */   
/*    */   public abstract void setName(String paramString);
/*    */   
/*    */   public abstract Queue<ReconnectRequest> getReconnectRequestQueue();
/*    */   
/*    */   public abstract void setFailureMode(boolean paramBoolean);
/*    */   
/*    */   public abstract boolean isFailureMode();
/*    */   
/*    */   public abstract void setKeyProvider(KeyProvider paramKeyProvider);
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\MemcachedClient.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */