/*     */ package net.rubyeye.xmemcached.impl;
/*     */ 
/*     */ import java.util.concurrent.Delayed;
/*     */ import java.util.concurrent.TimeUnit;
/*     */ import net.rubyeye.xmemcached.utils.InetSocketAddressWrapper;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class ReconnectRequest
/*     */   implements Delayed
/*     */ {
/*     */   private InetSocketAddressWrapper inetSocketAddressWrapper;
/*     */   private int tries;
/*     */   private static final long MIN_RECONNECT_INTERVAL = 1000L;
/*     */   private static final long MAX_RECONNECT_INTERVAL = 60000L;
/*     */   private volatile long nextReconnectTimestamp;
/*     */   
/*     */   public ReconnectRequest(InetSocketAddressWrapper inetSocketAddressWrapper, int tries, long reconnectInterval)
/*     */   {
/*  51 */     setInetSocketAddressWrapper(inetSocketAddressWrapper);
/*  52 */     setTries(tries);
/*  53 */     reconnectInterval = normalInterval(reconnectInterval);
/*  54 */     this.nextReconnectTimestamp = (System.currentTimeMillis() + reconnectInterval);
/*     */   }
/*     */   
/*     */   private long normalInterval(long reconnectInterval)
/*     */   {
/*  59 */     if (reconnectInterval < 1000L) {
/*  60 */       reconnectInterval = 1000L;
/*     */     }
/*  62 */     if (reconnectInterval > 60000L) {
/*  63 */       reconnectInterval = 60000L;
/*     */     }
/*  65 */     return reconnectInterval;
/*     */   }
/*     */   
/*     */   public long getDelay(TimeUnit unit)
/*     */   {
/*  70 */     return unit.convert(this.nextReconnectTimestamp - System.currentTimeMillis(), TimeUnit.MILLISECONDS);
/*     */   }
/*     */   
/*     */   public int compareTo(Delayed o)
/*     */   {
/*  75 */     ReconnectRequest other = (ReconnectRequest)o;
/*  76 */     if (this.nextReconnectTimestamp > other.nextReconnectTimestamp) {
/*  77 */       return 1;
/*     */     }
/*     */     
/*  80 */     return -1;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final InetSocketAddressWrapper getInetSocketAddressWrapper()
/*     */   {
/*  92 */     return this.inetSocketAddressWrapper;
/*     */   }
/*     */   
/*     */   public void updateNextReconnectTimeStamp(long interval)
/*     */   {
/*  97 */     interval = normalInterval(interval);
/*  98 */     this.nextReconnectTimestamp = (System.currentTimeMillis() + interval);
/*     */   }
/*     */   
/*     */   public final void setInetSocketAddressWrapper(InetSocketAddressWrapper inetSocketAddressWrapper)
/*     */   {
/* 103 */     this.inetSocketAddressWrapper = inetSocketAddressWrapper;
/*     */   }
/*     */   
/*     */   public final void setTries(int tries)
/*     */   {
/* 108 */     this.tries = tries;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final int getTries()
/*     */   {
/* 118 */     return this.tries;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\impl\ReconnectRequest.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */