/*    */ package net.sf.sevenzipjbinding.impl;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import java.io.RandomAccessFile;
/*    */ import net.sf.sevenzipjbinding.IInStream;
/*    */ import net.sf.sevenzipjbinding.SevenZipException;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class RandomAccessFileInStream
/*    */   implements IInStream
/*    */ {
/*    */   private final RandomAccessFile randomAccessFile;
/*    */   
/*    */   public RandomAccessFileInStream(RandomAccessFile paramRandomAccessFile)
/*    */   {
/* 25 */     this.randomAccessFile = paramRandomAccessFile;
/*    */   }
/*    */   
/*    */   public long seek(long paramLong, int paramInt)
/*    */     throws SevenZipException
/*    */   {
/*    */     try
/*    */     {
/* 33 */       switch (paramInt) {
/*    */       case 0: 
/* 35 */         this.randomAccessFile.seek(paramLong);
/* 36 */         break;
/*    */       
/*    */       case 1: 
/* 39 */         this.randomAccessFile.seek(this.randomAccessFile.getFilePointer() + paramLong);
/* 40 */         break;
/*    */       
/*    */       case 2: 
/* 43 */         this.randomAccessFile.seek(this.randomAccessFile.length() + paramLong);
/* 44 */         break;
/*    */       
/*    */       default: 
/* 47 */         throw new RuntimeException("Seek: unknown origin: " + paramInt);
/*    */       }
/*    */       
/* 50 */       return this.randomAccessFile.getFilePointer();
/*    */     } catch (IOException localIOException) {
/* 52 */       throw new SevenZipException("Error while seek operation", localIOException);
/*    */     }
/*    */   }
/*    */   
/*    */   public int read(byte[] paramArrayOfByte)
/*    */     throws SevenZipException
/*    */   {
/*    */     try
/*    */     {
/* 61 */       int i = this.randomAccessFile.read(paramArrayOfByte);
/* 62 */       if (i == -1) {
/* 63 */         return 0;
/*    */       }
/* 65 */       return i;
/*    */     }
/*    */     catch (IOException localIOException)
/*    */     {
/* 69 */       throw new SevenZipException("Error reading random access file", localIOException);
/*    */     }
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */   public void close()
/*    */     throws IOException
/*    */   {
/* 79 */     this.randomAccessFile.close();
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\sevenzipjbinding.jar!\net\sf\sevenzipjbinding\impl\RandomAccessFileInStream.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */