/*    */ package org.apache.avro.specific;
/*    */ 
/*    */ import org.apache.avro.Schema;
/*    */ import org.apache.avro.Schema.Type;
/*    */ import org.apache.avro.generic.GenericDatumReader;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class SpecificDatumReader<T>
/*    */   extends GenericDatumReader<T>
/*    */ {
/*    */   public SpecificDatumReader()
/*    */   {
/* 26 */     this(null, null, SpecificData.get());
/*    */   }
/*    */   
/*    */   public SpecificDatumReader(Class<T> c) {
/* 30 */     this(SpecificData.get().getSchema(c));
/*    */   }
/*    */   
/*    */   public SpecificDatumReader(Schema schema)
/*    */   {
/* 35 */     this(schema, schema, SpecificData.get());
/*    */   }
/*    */   
/*    */   public SpecificDatumReader(Schema writer, Schema reader)
/*    */   {
/* 40 */     this(writer, reader, SpecificData.get());
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public SpecificDatumReader(Schema writer, Schema reader, SpecificData data)
/*    */   {
/* 47 */     super(writer, reader, data);
/*    */   }
/*    */   
/*    */   public SpecificData getSpecificData() {
/* 51 */     return (SpecificData)getData();
/*    */   }
/*    */   
/*    */ 
/*    */   public void setSchema(Schema actual)
/*    */   {
/* 57 */     if ((getExpected() == null) && (actual != null) && (actual.getType() == Schema.Type.RECORD))
/*    */     {
/* 59 */       SpecificData data = getSpecificData();
/* 60 */       Class c = data.getClass(actual);
/* 61 */       if ((c != null) && (SpecificRecord.class.isAssignableFrom(c)))
/* 62 */         setExpected(data.getSchema(c));
/*    */     }
/* 64 */     super.setSchema(actual);
/*    */   }
/*    */   
/*    */ 
/*    */   protected Object createEnum(String symbol, Schema schema)
/*    */   {
/* 70 */     Class c = getSpecificData().getClass(schema);
/* 71 */     if (c == null) return super.createEnum(symbol, schema);
/* 72 */     return Enum.valueOf(c, symbol);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\apache\avro\specific\SpecificDatumReader.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */