/*     */ package org.codehaus.jackson.map.introspect;
/*     */ 
/*     */ import java.lang.reflect.Constructor;
/*     */ import java.lang.reflect.Member;
/*     */ import java.lang.reflect.Type;
/*     */ import org.codehaus.jackson.map.type.TypeBindings;
/*     */ import org.codehaus.jackson.type.JavaType;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class AnnotatedConstructor
/*     */   extends AnnotatedWithParams
/*     */ {
/*     */   protected final Constructor<?> _constructor;
/*     */   
/*     */   public AnnotatedConstructor(Constructor<?> constructor, AnnotationMap classAnn, AnnotationMap[] paramAnn)
/*     */   {
/*  24 */     super(classAnn, paramAnn);
/*  25 */     if (constructor == null) {
/*  26 */       throw new IllegalArgumentException("Null constructor not allowed");
/*     */     }
/*  28 */     this._constructor = constructor;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Constructor<?> getAnnotated()
/*     */   {
/*  38 */     return this._constructor;
/*     */   }
/*     */   
/*  41 */   public int getModifiers() { return this._constructor.getModifiers(); }
/*     */   
/*     */   public String getName() {
/*  44 */     return this._constructor.getName();
/*     */   }
/*     */   
/*     */   public Type getGenericType() {
/*  48 */     return getRawType();
/*     */   }
/*     */   
/*     */   public Class<?> getRawType()
/*     */   {
/*  53 */     return this._constructor.getDeclaringClass();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public JavaType getType(TypeBindings bindings)
/*     */   {
/*  64 */     return getType(bindings, this._constructor.getTypeParameters());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public AnnotatedParameter getParameter(int index)
/*     */   {
/*  75 */     return new AnnotatedParameter(this, getParameterType(index), this._paramAnnotations[index]);
/*     */   }
/*     */   
/*     */   public int getParameterCount()
/*     */   {
/*  80 */     return this._constructor.getParameterTypes().length;
/*     */   }
/*     */   
/*     */ 
/*     */   public Class<?> getParameterClass(int index)
/*     */   {
/*  86 */     Class<?>[] types = this._constructor.getParameterTypes();
/*  87 */     return index >= types.length ? null : types[index];
/*     */   }
/*     */   
/*     */ 
/*     */   public Type getParameterType(int index)
/*     */   {
/*  93 */     Type[] types = this._constructor.getGenericParameterTypes();
/*  94 */     return index >= types.length ? null : types[index];
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Class<?> getDeclaringClass()
/*     */   {
/* 104 */     return this._constructor.getDeclaringClass();
/*     */   }
/*     */   
/* 107 */   public Member getMember() { return this._constructor; }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String toString()
/*     */   {
/* 117 */     return "[constructor for " + getName() + ", annotations: " + this._annotations + "]";
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\introspect\AnnotatedConstructor.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */