/*    */ package org.codehaus.janino.util;
/*    */ 
/*    */ import java.io.FilterReader;
/*    */ import java.io.IOException;
/*    */ import java.io.Reader;
/*    */ import java.io.Writer;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class TeeReader
/*    */   extends FilterReader
/*    */ {
/*    */   private final Writer out;
/*    */   private final boolean closeWriterOnEOF;
/*    */   
/*    */   public TeeReader(Reader in, Writer out, boolean closeWriterOnEOF)
/*    */   {
/* 40 */     super(in);
/* 41 */     this.out = out;
/* 42 */     this.closeWriterOnEOF = closeWriterOnEOF;
/*    */   }
/*    */   
/* 45 */   public void close() throws IOException { this.in.close();
/* 46 */     this.out.close();
/*    */   }
/*    */   
/* 49 */   public int read() throws IOException { int c = this.in.read();
/* 50 */     if (c == -1) {
/* 51 */       if (this.closeWriterOnEOF) {
/* 52 */         this.out.close();
/*    */       } else {
/* 54 */         this.out.flush();
/*    */       }
/*    */     } else {
/* 57 */       this.out.write(c);
/*    */     }
/* 59 */     return c;
/*    */   }
/*    */   
/* 62 */   public int read(char[] cbuf, int off, int len) throws IOException { int bytesRead = this.in.read(cbuf, off, len);
/* 63 */     if (bytesRead == -1) {
/* 64 */       if (this.closeWriterOnEOF) {
/* 65 */         this.out.close();
/*    */       } else {
/* 67 */         this.out.flush();
/*    */       }
/*    */     } else {
/* 70 */       this.out.write(cbuf, off, bytesRead);
/*    */     }
/* 72 */     return bytesRead;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\util\TeeReader.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */