package prefuse.action;

import prefuse.Visualization;
import prefuse.util.collections.CopyOnWriteArrayList;

public abstract class CompositeAction
  extends Action
{
  protected CopyOnWriteArrayList m_actions = new CopyOnWriteArrayList();
  
  public CompositeAction()
  {
    super(null, 0L);
  }
  
  public CompositeAction(Visualization paramVisualization)
  {
    super(paramVisualization, 0L);
  }
  
  public CompositeAction(long paramLong)
  {
    super(null, paramLong, 15L);
  }
  
  public CompositeAction(Visualization paramVisualization, long paramLong)
  {
    super(paramVisualization, paramLong, 15L);
  }
  
  public CompositeAction(long paramLong1, long paramLong2)
  {
    super(null, paramLong1, paramLong2);
  }
  
  public void setVisualization(Visualization paramVisualization)
  {
    super.setVisualization(paramVisualization);
    for (int i = 0; i < this.m_actions.size(); i++) {
      get(i).setVisualization(paramVisualization);
    }
  }
  
  public int size()
  {
    return this.m_actions.size();
  }
  
  public void add(Action paramAction)
  {
    this.m_actions.add(paramAction);
  }
  
  public void add(int paramInt, Action paramAction)
  {
    this.m_actions.add(paramInt, paramAction);
  }
  
  public Action get(int paramInt)
  {
    return (Action)this.m_actions.get(paramInt);
  }
  
  public boolean remove(Action paramAction)
  {
    return this.m_actions.remove(paramAction);
  }
  
  public Action remove(int paramInt)
  {
    return (Action)this.m_actions.remove(paramInt);
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\CompositeAction.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */