package prefuse.action.animate;

import java.util.Iterator;
import prefuse.Visualization;
import prefuse.action.GroupAction;
import prefuse.util.ColorLib;
import prefuse.visual.VisualItem;
import prefuse.visual.expression.StartVisiblePredicate;

public class VisibilityAnimator
  extends GroupAction
{
  public VisibilityAnimator() {}
  
  public VisibilityAnimator(String paramString)
  {
    super(paramString);
  }
  
  public void run(double paramDouble)
  {
    if (paramDouble == 0.0D) {
      setup();
    } else if (paramDouble == 1.0D) {
      finish();
    }
  }
  
  private void setup()
  {
    Iterator localIterator = this.m_vis.visibleItems(this.m_group);
    VisualItem localVisualItem;
    while (localIterator.hasNext())
    {
      localVisualItem = (VisualItem)localIterator.next();
      if (!localVisualItem.isStartVisible())
      {
        localVisualItem.setStartFillColor(ColorLib.setAlpha(localVisualItem.getEndFillColor(), 0));
        localVisualItem.setStartStrokeColor(ColorLib.setAlpha(localVisualItem.getEndStrokeColor(), 0));
        localVisualItem.setStartTextColor(ColorLib.setAlpha(localVisualItem.getEndTextColor(), 0));
      }
    }
    localIterator = this.m_vis.items(this.m_group, StartVisiblePredicate.TRUE);
    while (localIterator.hasNext())
    {
      localVisualItem = (VisualItem)localIterator.next();
      if (!localVisualItem.isEndVisible())
      {
        localVisualItem.setVisible(true);
        localVisualItem.setEndFillColor(ColorLib.setAlpha(localVisualItem.getStartFillColor(), 0));
        localVisualItem.setEndStrokeColor(ColorLib.setAlpha(localVisualItem.getStartStrokeColor(), 0));
        localVisualItem.setEndTextColor(ColorLib.setAlpha(localVisualItem.getStartTextColor(), 0));
      }
    }
  }
  
  private void finish()
  {
    Iterator localIterator = this.m_vis.items(this.m_group, StartVisiblePredicate.TRUE);
    VisualItem localVisualItem;
    while (localIterator.hasNext())
    {
      localVisualItem = (VisualItem)localIterator.next();
      if (!localVisualItem.isEndVisible())
      {
        localVisualItem.setVisible(false);
        localVisualItem.setStartVisible(false);
      }
    }
    localIterator = this.m_vis.visibleItems(this.m_group);
    while (localIterator.hasNext())
    {
      localVisualItem = (VisualItem)localIterator.next();
      if (!localVisualItem.isStartVisible())
      {
        localVisualItem.setStartVisible(true);
        localVisualItem.setStartFillColor(localVisualItem.getEndFillColor());
        localVisualItem.setStartTextColor(localVisualItem.getEndTextColor());
        localVisualItem.setStartStrokeColor(localVisualItem.getEndStrokeColor());
      }
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\animate\VisibilityAnimator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */