package prefuse.action.assignment;

import java.awt.BasicStroke;
import java.awt.Stroke;
import java.util.logging.Logger;
import prefuse.action.ItemAction;
import prefuse.data.expression.Predicate;
import prefuse.data.expression.parser.ExpressionParser;
import prefuse.util.PredicateChain;
import prefuse.util.StrokeLib;
import prefuse.visual.VisualItem;

public class StrokeAction
  extends ItemAction
{
  protected PredicateChain m_chain = null;
  protected BasicStroke defaultStroke = StrokeLib.getStroke(1.0F);
  
  public StrokeAction() {}
  
  public StrokeAction(String paramString)
  {
    super(paramString);
  }
  
  public StrokeAction(String paramString, BasicStroke paramBasicStroke)
  {
    super(paramString);
    this.defaultStroke = paramBasicStroke;
  }
  
  public void setDefaultStroke(BasicStroke paramBasicStroke)
  {
    this.defaultStroke = paramBasicStroke;
  }
  
  public BasicStroke getDefaultStroke()
  {
    return this.defaultStroke;
  }
  
  public void add(Predicate paramPredicate, BasicStroke paramBasicStroke)
  {
    if (this.m_chain == null) {
      this.m_chain = new PredicateChain();
    }
    this.m_chain.add(paramPredicate, paramBasicStroke);
  }
  
  public void add(String paramString, BasicStroke paramBasicStroke)
  {
    Predicate localPredicate = (Predicate)ExpressionParser.parse(paramString);
    add(localPredicate, paramBasicStroke);
  }
  
  public void add(Predicate paramPredicate, StrokeAction paramStrokeAction)
  {
    if (this.m_chain == null) {
      this.m_chain = new PredicateChain();
    }
    this.m_chain.add(paramPredicate, paramStrokeAction);
  }
  
  public void add(String paramString, StrokeAction paramStrokeAction)
  {
    Predicate localPredicate = (Predicate)ExpressionParser.parse(paramString);
    add(localPredicate, paramStrokeAction);
  }
  
  public void process(VisualItem paramVisualItem, double paramDouble)
  {
    paramVisualItem.setStroke(getStroke(paramVisualItem));
  }
  
  public BasicStroke getStroke(VisualItem paramVisualItem)
  {
    if (this.m_chain != null)
    {
      Object localObject = this.m_chain.get(paramVisualItem);
      if (localObject != null)
      {
        if ((localObject instanceof StrokeAction)) {
          return ((StrokeAction)localObject).getStroke(paramVisualItem);
        }
        if ((localObject instanceof Stroke)) {
          return (BasicStroke)localObject;
        }
        Logger.getLogger(getClass().getName()).warning("Unrecognized Object from predicate chain.");
      }
    }
    return this.defaultStroke;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\assignment\StrokeAction.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */