package prefuse.controls;

import java.awt.Component;
import java.awt.Cursor;
import java.awt.Point;
import java.awt.event.MouseEvent;
import prefuse.Display;
import prefuse.util.ui.UILib;

public class RotationControl
  extends ControlAdapter
{
  private Point down = new Point();
  private double baseAngle = 0.0D;
  private int m_button;
  
  public RotationControl()
  {
    this(16);
  }
  
  public RotationControl(int paramInt)
  {
    this.m_button = paramInt;
  }
  
  public void mousePressed(MouseEvent paramMouseEvent)
  {
    if (UILib.isButtonPressed(paramMouseEvent, this.m_button))
    {
      Display localDisplay = (Display)paramMouseEvent.getComponent();
      localDisplay.setCursor(Cursor.getPredefinedCursor(11));
      this.down.setLocation(paramMouseEvent.getPoint());
      this.baseAngle = NaN.0D;
    }
  }
  
  public void mouseDragged(MouseEvent paramMouseEvent)
  {
    if (UILib.isButtonPressed(paramMouseEvent, this.m_button))
    {
      int i = paramMouseEvent.getY() - this.down.y;
      int j = paramMouseEvent.getX() - this.down.x;
      double d = Math.atan2(i, j);
      if (!Double.isNaN(this.baseAngle))
      {
        Display localDisplay = (Display)paramMouseEvent.getComponent();
        localDisplay.rotate(this.down, d - this.baseAngle);
      }
      this.baseAngle = d;
    }
  }
  
  public void mouseReleased(MouseEvent paramMouseEvent)
  {
    if (UILib.isButtonPressed(paramMouseEvent, this.m_button)) {
      paramMouseEvent.getComponent().setCursor(Cursor.getDefaultCursor());
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\controls\RotationControl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */