package prefuse.visual.expression;

import prefuse.Visualization;
import prefuse.data.Tuple;
import prefuse.data.expression.BooleanLiteral;
import prefuse.data.expression.Expression;
import prefuse.data.search.SearchTupleSet;
import prefuse.visual.VisualItem;

public class SearchPredicate
  extends InGroupPredicate
{
  private Expression m_incEmpty;
  private int paramCount = 0;
  
  public SearchPredicate()
  {
    this(Visualization.SEARCH_ITEMS, true);
  }
  
  public SearchPredicate(boolean paramBoolean)
  {
    this(Visualization.SEARCH_ITEMS, paramBoolean);
  }
  
  public SearchPredicate(String paramString, boolean paramBoolean)
  {
    super(paramString);
    this.m_incEmpty = new BooleanLiteral(paramBoolean);
    this.paramCount = 2;
  }
  
  public boolean getBoolean(Tuple paramTuple)
  {
    String str1 = getGroup(paramTuple);
    if (str1 == null) {
      return false;
    }
    boolean bool = this.m_incEmpty.getBoolean(paramTuple);
    VisualItem localVisualItem = (VisualItem)paramTuple;
    Visualization localVisualization = localVisualItem.getVisualization();
    SearchTupleSet localSearchTupleSet = (SearchTupleSet)localVisualization.getGroup(str1);
    if ((localSearchTupleSet == null) && (bool)) {
      return true;
    }
    String str2 = localSearchTupleSet.getQuery();
    return ((bool) && ((str2 == null) || (str2.length() == 0))) || (localVisualization.isInGroup(localVisualItem, str1));
  }
  
  public void addParameter(Expression paramExpression)
  {
    if (this.paramCount == 0) {
      super.addParameter(paramExpression);
    } else if (this.paramCount == 1) {
      this.m_incEmpty = paramExpression;
    } else {
      throw new IllegalStateException("This function takes only 2 parameters.");
    }
  }
  
  public String getName()
  {
    return "MATCH";
  }
  
  public int getParameterCount()
  {
    return 2;
  }
  
  public String toString()
  {
    return getName() + "(" + this.m_group + ", " + this.m_incEmpty + ")";
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\visual\expression\SearchPredicate.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */